function [beta,stat] = beta_rnd(Z0,Z1,Z2,D,h_vec,H_mat,size_b,r,Omega,delta,Gamma,alpha,lambda_alpha,cu_symmetric,prior_inf_alpha)

Z = Z0;
if isempty(delta)==0;
   Z = Z-(delta*D);
end;
if isempty(Gamma)==0;
   Z = Z-(Gamma*Z2);
end;

cov_mat = kron(alpha'*inverse(Omega)*alpha,Z1*Z1');
mean_vec = vec(Z1*Z'*inverse(Omega)*alpha);
%
if prior_inf_alpha==1;
   B_sigma = kron((1/(lambda_alpha^2))*alpha'*inverse(Omega)*alpha,eye(size_b));
   cov_mat = cov_mat+B_sigma;
end;
%
cov_mat_b_inv = cov_mat;
[test_mat,stat] = chol(cov_mat);
if stat>0;
   beta = [];
   return;
end;
cov_mat = inverse(cov_mat);
mean_vec = cov_mat*mean_vec;

%
% now we transform this mean and covariance into psi rather than vec(beta)
%

cov_mat_psi = inverse((H_mat'*cov_mat_b_inv*H_mat));
mean_vec = cov_mat_psi*H_mat'*cov_mat_b_inv*(mean_vec-h_vec);

[std_mat,stat] = chol(cov_mat_psi);
if stat>0;
   beta = [];
   return;
end;

if cu_symmetric==1;
   std_mat = symm(cov_mat_psi);
end;

psi = mean_vec+(std_mat'*randn(size(mean_vec,1),1));
beta_vec = h_vec+(H_mat*psi);
beta = vecinv(beta_vec,size_b);

%
% end of beta_rnd.m
%
