function [status,dvips] = check_ps(curr_ini)

status = 1;
dvips = '';

if (isempty(curr_ini.latex)==0)&(isempty(curr_ini.psviewer)==0);
   fid1 = fopen(curr_ini.latex,'rb');
   if fid1>-1;
      fclose(fid1);
   end;
   fid2 = fopen(curr_ini.psviewer,'rb');
   if fid2>-1;
      fclose(fid2);
   end;
   if min([fid1 fid2])==-1;
      return;
   else;
      %
      % make sure latex does not produce pdf
      %
      latex = getname(curr_ini.latex);
      if size(latex,2)>=5;
         if strcmp(lower(latex(1,1:3)),'pdf')==1;
            return;
         else;
            %
            % make sure latex includes latex in its filename
            %
            if isempty(findstr(lower(latex),'latex'))==1;
               return;
            else;
               %
               % check for dvips or dvipsk
               %
               if ispc==1;
                  dvips = [getpath(curr_ini.latex) 'dvips.exe'];
               else;
                  dvips = [getpath(curr_ini.latex) '/dvips' getext(curr_ini.latex)];
               end;
               fid3 = fopen(dvips,'rb');
               if fid3>-1;
                  status = 0;
                  fclose(fid3);
               else;
                  if ispc==1;
                     dvips = [getpath(curr_ini.latex) 'dvipsk.exe'];
                  else;
                     dvips = [getpath(curr_ini.latex) '/dvipsk'  getext(curr_ini.latex)];
                  end;
                  fid3 = fopen(dvips,'rb');
                  if fid3>-1;
                     status = 0;
                     fclose(fid3);
                  else;
                     dvips = '';
                  end;
               end;
            end;
         end;
      else;
         return;
      end;
   end;
end;

%
% end of check_ps.m
%
