function [Rmat,rvec,S,d] = create_rest(type_var,Psi,alpha,B,C,xi,Rmat_sr,rvec_sr,Rmat_lr,rvec_lr,Rmat_alpha,rvec_alpha,Rmat_C,rvec_C,n)

if strcmp(type_var,'short_run')==1;
   if isempty(Rmat_alpha)==1;
      if isempty([Psi alpha])==0;
         if isempty(Rmat_C)==1;
            Rmat = [zeros(size(Rmat_sr,1),size([Psi alpha],2)*n) Rmat_sr];
         else;
            Rmat = [[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];zeros(size(Rmat_sr,1),size([Psi alpha],2)*n) Rmat_sr];
         end;
      else;
         Rmat = Rmat_sr;
      end;
      rvec = [rvec_C;rvec_sr];
      if isempty(Rmat_C)==0;
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   else;
      if isempty(Rmat_C)==1;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[zeros(size(Rmat_sr,1),size(Rmat_alpha,2)) Rmat_sr]];
         rvec = [rvec_alpha;rvec_sr];
      else;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];[zeros(size(Rmat_sr,1),size(Rmat_alpha,2)) Rmat_sr]];
         rvec = [rvec_alpha;rvec_C;rvec_sr];
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   end;
elseif strcmp(type_var,'long_run')==1;
   if isempty(Rmat_alpha)==1;
      if isempty(Rmat_C)==1;
         Rmat = [Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];
         rvec = rvec_lr;
      else;
         Rmat = [[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];
         rvec = [rvec_C;rvec_lr];
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   else;
      if isempty(Rmat_C)==1;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)]];
         rvec = [rvec_alpha;rvec_lr];
      else;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)]];
         rvec = [rvec_alpha;rvec_C;rvec_lr];
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   end;
else;
   if isempty(Rmat_alpha)==1;
      if isempty(Rmat_C)==1;
         Rmat = [[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];[zeros(size(Rmat_sr,1),size([Psi alpha],2)*n) Rmat_sr]];
         rvec = [rvec_lr;rvec_sr];
      else;
         Rmat = [[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];[zeros(size(Rmat_sr,1),size([Psi alpha],2)*n) Rmat_sr]];
         rvec = [rvec_C;rvec_lr;rvec_sr];
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   else;
      if isempty(Rmat_C)==1;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];[zeros(size(Rmat_sr,1),size(Rmat_alpha,2)) Rmat_sr]];
         rvec = [rvec_alpha;rvec_lr;rvec_sr];
      else;
         Rmat = [[Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];[Rmat_C*kron(xi',C) zeros(size(Rmat_C,1),n*n)];[Rmat_lr*kron(B'*xi',C) Rmat_lr*kron(eye(n),C)];[zeros(size(Rmat_sr,1),size(Rmat_alpha,2)) Rmat_sr]];
         rvec = [rvec_alpha;rvec_C;rvec_lr;rvec_sr];
         if rank(Rmat)<size(Rmat,1);
            [red,use] = getdelvars(Rmat',[]);
            Rmat = Rmat(use,:);
            rvec = rvec(use,1);
         end;
      end;
   end;
end;

S = null(Rmat);
S_ort = null(S');

%d = [];
d = (S_ort/(Rmat*S_ort))*rvec;

%
% end of create_rest.m
%
