function [lnL_h0,beta,alpha,Psi,Omega,epsilon] = estimate_nyblomalt_null(tm,data_struc,curr_ini,r,T,Rmat,rvec,Rmat_C,rvec_C)

[S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(data_struc.Z0,data_struc.Z1,data_struc.Z2,r);
%
% if restricted beta
%
if tm.restrict(1,2)==1;
   [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,tm.modelsdir,tm.modelfile,0,tm.dcoint);
end;
%
alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
if isempty(data_struc.Z2)==0;
   Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
   epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1)-(Psi_n*data_struc.Z2);
   Z3 = [data_struc.Z2;beta_n'*data_struc.Z1];
else;
   Psi_n = [];
   epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1);
   Z3 = beta_n'*data_struc.Z1;
end;
%
% if restricted alpha
%
Theta_n = [Psi_n alpha_n];
if tm.restrict(1,1)==1;
   if curr_ini.reestbeta==0;
      [theta_n,Sigma_theta,infomat,newabort] = linrest(data_struc.Z0,Z3,Theta_n,Rmat,rvec,0);
   else;
      [theta_n,Sigma_theta,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(data_struc.Z0,data_struc.Z1,data_struc.Z2,Z3,beta_n,Theta_n,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,0);
   end;
   g2 = size(theta_n,2);
   alpha_n = theta_n(:,g2-tm.r+1:g2);
   if g2>tm.r;
      Psi_n = theta_n(:,1:g2-tm.r);
      epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1)-(Psi_n*data_struc.Z2);
   else;
      Psi_n = [];
      epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1);
   end;
end;
%
% if restricted C matrix
%
if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
   [theta_n,Sigma_theta,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(data_struc.Z0,data_struc.Z1,data_struc.Z2,tm.restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,tm.p,tm.pe,tm.d,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,0);
   %
   g2 = size(theta_n,2);
   alpha_n = theta_n(:,g2-tm.r+1:g2);
   if g2>tm.r;
      Psi_n = theta_n(:,1:g2-tm.r);
      epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1)-(Psi_n*data_struc.Z2);
   else;
      Psi_n = [];
      epsilon_n = data_struc.Z0-(alpha_n*beta_n'*data_struc.Z1);
   end;
end;
%
% now we compute the log-likelihood under the null hypothesis
%
lnL_h0 = loglike(epsilon_n);

if nargout>1;
   beta = beta_n;
   alpha = alpha_n;
   Psi = Psi_n;
   Omega = (1/T)*epsilon_n*epsilon_n';
   epsilon = epsilon_n;
end;


%
% end of estimate_nyblomalt_null.m
%



