function [tests,pvals,dfs] = exclude_dummies(epsilon_orig,Z0,Z1,Z2,deter,r,p,pe,q1,q0,df,num_const,num_dummies,restrict,modelsdir,modelfile,dcoint,reestbeta,sscorrect,showwaitbar)

[n T] = size(epsilon_orig);
lnL_orig = loglike(epsilon_orig);
t = T-df;
%
dummy_names = vecstr(deter);
dummy_names = dummy_names(1+num_const:num_dummies+num_const,:);

if num_dummies>1;
   tests = zeros(num_dummies+1,1);
   pvals = zeros(num_dummies+1,1);
   dfs = zeros(num_dummies+1,1+sscorrect);
else;
   tests = zeros(1,1);
   pvals = zeros(1,1);
   dfs = zeros(1,1+sscorrect);
end;

Z2_const = [];
Z2_base = [];
if num_const>0;
   Z2_const = Z2(1:num_const,:);
end;
if size(Z2,1)>num_const+num_dummies;
   Z2_base = [Z2(num_const+num_dummies+1:size(Z2,1),:)];
end;
dummy_series = (1:1:num_dummies)';
Z2_dummy_vars = Z2(num_const+1:num_dummies+num_const,:);
%
% display a progress report
%
if showwaitbar==1;
   txt = strvcat(' ','Computing exlusion tests for dummy variables...',['Excluded dummy variable: ' strtrim(dummy_names(1,:))],'Please wait!');
   mywait = waitdlg(txt,'information');
   waitf = get(mywait,'UserData');
end;
for i=1:num_dummies;
   %
   if (showwaitbar==1)&(i>1);
      txt = strvcat(' ','Computing exlusion tests for dummy variables...',['Excluded dummy variable: ' strtrim(dummy_names(i,:))],'Please wait!');
      set(waitf.text,'String',txt);
   end;
   use_dummies = dummy_series(dummy_series~=i);
   Z2_new = [Z2_const;Z2_dummy_vars(use_dummies,:);Z2_base];
   %
   % estimate model under the null hypothesis
   %
   [S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(Z0,Z1,Z2_new,r);
   %
   if restrict(1,2)==1;
      [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,modelsdir,modelfile,0,dcoint);
   end;
   alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
   if isempty(Z2_new)==0;
      Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
      epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      Z3 = [Z2_new;beta_n'*Z1];
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      Z3 = beta_n'*Z1;
   end;
   %
   % estimate under alpha restrictions
   %
   Theta_n = [Psi_n alpha_n];
   if restrict(1,1)==1;
      if i==1;
         %
         % retrieve the restrictions on alpha
         %
         file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
         G = loaddata(file);
         [Rmat,rvec] = rmatrix(G,n,r);
         dfalpha = size(G,1);
         if isempty(Z2_new)==0;
            Rmat = [zeros(dfalpha,size(Z2_new,1)*n) Rmat];
         end;
      end;
      if reestbeta==0;
         [theta_n,Sigma_theta,infomat,newabort] = linrest(Z0,Z3,Theta_n,Rmat,rvec,0);
      else;
         [theta_n,Sigma_theta,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(Z0,Z1,Z2_new,Z3,beta_n,Theta_n,Rmat,rvec,dcoint,q1,modelsdir,modelfile,0);
      end;
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      end;
   end;
   %
   % estimate under C restrictions
   %
   if (size(restrict,2)==3)&(restrict(1,3)==1);
      if i==1;
         file = strcat(modelsdir,'C-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
         G = loaddata(file);
         [Rmat_C,rvec_C] = rmatrix(G,n,n);
      end;
      %
      [theta_n,Sigma_theta,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(Z0,Z1,Z2_new,restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,p,pe,num_const+num_dummies-1,dcoint,q0,q1,modelsdir,modelfile,0);
      %
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      end;
   end;
   %
   lnL_new = loglike(epsilon_n);
   LR = 2*(lnL_orig-lnL_new);
   if sscorrect==0;
      tests(i,1) = LR;
      pvals(i,1) = 1-chis_cdf(LR,n);
      dfs(i,1) = n;
   else;
      dfs(i,:) = [n t];
      tests(i,1) = (t/(T*n))*LR;
      pvals(i,1) = 1-fdis_cdf(tests(i,1),dfs(i,1),dfs(i,2));
   end;
end;

%
% and now for the joint test
%
if num_dummies>1;
   if showwaitbar==1;
      txt = strvcat(' ','Computing exlusion tests for all dummy variables...',' ','Please wait!');
      set(waitf.text,'String',txt);
   end;
   Z2_new = [Z2_const;Z2_base];
   %
   % estimate model under the null hypothesis
   %
   [S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(Z0,Z1,Z2_new,r);
   %
   if restrict(1,2)==1;
      [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,modelsdir,modelfile,0,dcoint);
   end;
   alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
   if isempty(Z2_new)==0;
      Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
      epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      Z3 = [Z2_new;beta_n'*Z1];
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      Z3 = beta_n'*Z1;
   end;
   %
   % estimate under alpha restrictions
   %
   Theta_n = [Psi_n alpha_n];
   if restrict(1,1)==1;
      %
      % retrieve the restrictions on alpha
      %
      file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
      G = loaddata(file);
      [Rmat,rvec] = rmatrix(G,n,r);
      dfalpha = size(G,1);
      if isempty(Z2_new)==0;
         Rmat = [zeros(dfalpha,size(Z2_new,1)*n) Rmat];
      end;
      if reestbeta==0;
         [theta_n,Sigma_theta,infomat,newabort] = linrest(Z0,Z3,Theta_n,Rmat,rvec,0);
      else;
         [theta_n,Sigma_theta,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(Z0,Z1,Z2_new,Z3,beta_n,Theta_n,Rmat,rvec,dcoint,q1,modelsdir,modelfile,0);
      end;
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      end;
   end;
   %
   % estimate under C restrictions
   %
   if (size(restrict,2)==3)&(restrict(1,3)==1);
      [theta_n,Sigma_theta,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(Z0,Z1,Z2_new,restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,p,pe,num_const,dcoint,q0,q1,modelsdir,modelfile,0);
      %
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1);
      end;
   end;
   %
   lnL_new = loglike(epsilon_n);
   LR = 2*(lnL_orig-lnL_new);
   LR = 2*(lnL_orig-lnL_new);
   if sscorrect==0;
      tests(num_dummies+1,1) = LR;
      pvals(num_dummies+1,1) = 1-chis_cdf(LR,n*num_dummies);
      dfs(num_dummies+1,1) = n*num_dummies;
   else;
      dfs(num_dummies+1,:) = [n*num_dummies t+num_dummies-1];
      tests(num_dummies+1,1) = ((t+num_dummies-1)/(T*n*num_dummies))*LR;
      pvals(num_dummies+1,1) = 1-fdis_cdf(tests(num_dummies+1,1),dfs(num_dummies+1,1),dfs(num_dummies+1,2));
   end;
end;

if showwaitbar==1;
   set(waitf.text,'UserData','done');
   delete(mywait);
   drawnow;
end;

%
% end of exclude_dummies.m
%
