function beta = fix_norm_beta(beta,tm)

%
% Computing input values for beta
%
S_bb = beta'*beta;
%
% Solving the eigenvalue problem
%
% Step 1: Diagonalize S_bb
%
[W,rho] = eig(S_bb);
rho = diag(rho,0);
[rho2,AscInd] = sort(abs(rho));
nr = size(AscInd,1);
DescInd = zeros(nr,1);
i1 = 1;
while i1<=nr;
   DescInd(i1)=AscInd(nr+1-i1);
   i1 =i1+1;
end;
%
% Resort eigenvalues and eigenvectors
% in descending order
%
rho = rho(DescInd);
sqrho = sqrt(rho);
rho = diag(rho,0);
sqrho = diag(sqrho,0);
W = W(:,DescInd);
sqS_bb = (W/(sqrho))*W';
beta_new = zeros(size(beta));

for i=1:tm.r;
   file = strcat(tm.modelsdir,'H_',num2str(i),'-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.rest');
   H_mat = loaddata(file);
   %
   adjS_bb = sqS_bb*beta'*(H_mat/(H_mat'*H_mat))*H_mat'*beta*sqS_bb;
   [U,lambdai] = eig(adjS_bb);
   lambdai = diag(lambdai,0);
   [lambdai2,AscInd] = sort(abs(lambdai));
   nr = size(AscInd,1);
   DescInd = zeros(nr,1);
   i1 = 1;
   while i1<=nr;
      DescInd(i1)=AscInd(nr+1-i1);
      i1 =i1+1;
   end;
   %
   % Resort eigenvalues and eigenvectors
   % in descending order
   %
   lambdai = lambdai(DescInd);
   U = U(:,DescInd);
   %
   % Renormalize U such that V'S_bbV=I
   %
   V = sqS_bb*U;
   %
   % Computing the initial estimate of betai
   % using the first eigenvector from the
   % solution to the above eigenvalue problem
   %
   beta_new(:,i) = beta*V(:,1);
end;
file = strcat(tm.modelsdir,'normalize-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.norm');
norm_vec = loaddata(file);
for i=1:tm.r;
   norm_var = beta_new(norm_vec(i,1),i);
   if abs(norm_var)>0;
      beta_new(:,i) = (1/norm_var)*beta_new(:,i);
   end;
end;

beta = beta_new;

%
% end of fix_norm_beta.m
%
