function import_data_fcn

h = get(0,'CurrentFigure');
this_axes = gca;

%
% open a file open dialog
%

curr_ini = find_inisettings;

if matlabnumber>=6.0;
   myfile = {'*.txt;*.data;*.wk1;*.xls;*.mat;*.csv', 'Data Files (*.txt, *.data, *.wk1, *.xls, *.mat, *.csv)'; ...
           '*.txt;*.data', 'Text Files (*.txt, *.data)'; ...
           '*.mat', 'MatLab MAT Files (*.mat)'; ...
           '*.wk1', 'Lotus 1-2-3 Spreadsheets (*.wk1)'; ...
           '*.xls', 'Excel Spreadsheets (*.xls)'; ...
           '*.csv', 'Comma Separated Value Files (*.csv)'; ...
           '*.*', 'All Files (*.*)'};
else;
   if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1);
      fix_fig = findobj('Tag','StructuralVAR');
      model = get(fix_fig,'UserData');
      afile = get(model.endogenous,'String');
      basedir = getpath(strtrim(afile));
      file_fltr = 'Data Files (*.txt, *.data, *.wk1, *.mat, *.csv)|*.txt;*.data;*.wk1;*.mat;*.csv|Text Files (*.txt, *.data)|*.txt;*.data|MatLab MAT Files (*.mat)|*.mat|Lotus 1-2-3 Spreadsheets (*.wk1)|*.wk1|Comma Separated Value Files (*.csv)|*.csv|All Files (*.*)|*.*|';
      best_pos = 1;
      title_txt = 'Open';
   else;
      fix_fig = findobj('Tag','StructuralVAR');
      model = get(fix_fig,'UserData');
      afile = get(model.endogenous,'String');
      afile = strtrim(afile);
      if fileexist(afile)==1;
         adir = getpath(afile);
         if ispc==1;
            if strcmp(adir(1,size(adir,2)),'\')==0;
               adir = [adir '\'];
            end;
         else;
            if strcmp(adir(1,size(adir,2)),'/')==0;
               adir = [adir '/'];
            end;
         end;
      else;
         adir = getpath(strtrim(get(model.outputfile,'String')));
         if isempty(adir)==1;
            adir = pwd;
         end;
      end;
      myfile = [adir '*.txt;*.data;*.wk1;*.mat;*.csv'];
   end;
end;
drawnow;
if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1)&(matlabnumber<6.0);
   [openfile,openpath] = fileopen(basedir,file_fltr,best_pos,title_txt);
else;
   if matlabnumber>=6;
      fix_fig = findobj('Tag','StructuralVAR');
      model = get(fix_fig,'UserData');
      [openfile,openpath] = uigetfile(myfile,'Open',getpath(strtrim(get(model.endogenous,'String'))));
   else;
      [openfile,openpath] = uigetfile(myfile,'Open');
   end;
end;
drawnow;
if isnumeric(openfile)==0;
   %
   % make sure that the file is a legal data-file
   %
   file = [openpath openfile];
   [new_data,status,dtstr,endosheet,action] = loaddata(file);
   %
   if status==1;
      if (isempty(dtstr)==0)|(isempty(get(this_axes,'Children'))==1);
         %
         % make sure that the dates fit into the current graph
         %
         if isempty(dtstr)==0;
            %
            % create a dataindex from dtstr
            %
            c_dates = mystr2num(dtstr(1:min(12,size(dtstr,1)),:));
            %
            % check frequency
            %
            my_freq = 'y';
            d = 1;
            if size(c_dates,2)==2;
               if (max(c_dates(:,2))>1)&(max(c_dates(:,2))<5);
                  my_freq = 'q';
                  d = 4;
               elseif max(c_dates(:,2)>4);
                  my_freq = 'm';
                  d = 12;
               end;
            end;
            b_date_vec = mystr2num(dtstr(1,:));
            e_date_vec = mystr2num(dtstr(size(dtstr,1),:));
            if d>1;
               b_date = b_date_vec(1)+((1+(2*(b_date_vec(2)-1)))/(2*d));
               e_date = e_date_vec(1)+((1+(2*(e_date_vec(2)-1)))/(2*d));
               dataindex = (b_date:1/d:e_date)';
            else;
               b_date = b_date_vec(1);
               e_date = e_date_vec(1);
               dataindex = (b_date:1:e_date)';
            end;
         else;
            %
            % we have an empty graph and we create a dataindex based on the number
            % of observation
            %
            if size(new_data,2)>size(new_data,1);
               new_data = new_data';
            end;
            dataindex = (1:1:size(new_data,1))';
            b_date = 1;
            e_date = size(new_data,1);
            d = 1;
            my_freq = 'y';
         end;
         %
         % create sample selection strings
         %
         my_dates = getdate(dataindex(1,1),dataindex(size(dataindex,1),1),my_freq,1/size(dataindex,1));
         for i=2:size(dataindex,1);
            my_dates = [my_dates '|' getdate(dataindex(1,1),dataindex(size(dataindex,1),1),my_freq,i/size(dataindex,1))];
         end;
         %
         % check if we have an empty graph
         %
         if isempty(get(this_axes,'Children'))==1;
            xlim_status = 1;
            empty_graph = 1;
         else;
            x_lim = get(this_axes,'XLim');
            %
            % test if dates can be fit inside the upper and lower limits of the current axes
            %
            xlim_status = 1;
            if e_date<x_lim(1);
               xlim_status = 0;
            end;
            if b_date>x_lim(2);
               xlim_status = 0;
            end;
            empty_graph = 0;
         end;
         %
         if xlim_status==1;
            %
            % "make sure" that the variables are ordered column-wise
            %
            if size(new_data,2)>size(new_data,1);
               new_data = new_data';
            end;
            %
            % Try to read names
            %
            [new_names,my_status] = readnames(file,endosheet);
            %
            % If file contains more than 1 variable we need to present a select
            % variable dialog
            %
            if my_status==0;
               %
               % create temporary names
               %
               new_names = 'x_1';
               for i=2:size(new_data,2);
                  new_names = [new_names ' x_' int2str(i)];
               end;
            end;
            %
            % Setting up plotting selections
            %
            new_names = vecstr(new_names);
            %
            scrsz = get(0,'ScreenSize');
            %
            plot_gui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
               'FileName','import_data_fcn.m', ...
               'MenuBar','none', ...
               'Units','pixels', ...
               'Units','pixels', ...
               'Position',[scrsz(3)/2-200 (scrsz(4)-205)/2 400 205], ...
               'Tag','PlotGUIDlg', ...
               'Resize','off', ...
               'Name','Import Variable', ...
               'Visible','off', ...
               'NumberTitle','off', ...
               'WindowStyle','modal', ...
               'CloseRequestFcn','closegui', ...
               'ToolBar','none');
            %
            if matlabnumber>=7.0;
               set(plot_gui,'DockControl','off');
            end;
            %
            axesbox([2 2 398 198],'Graph Selections',82,[0.5 1]);
            %
            % select variable
            %
            plot_name.selecttext = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[16 153 100 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Style','text', ...
               'HorizontalAlignment','left', ...
               'String','Select variable:', ...
               'Tag','Text');
            %
            plot_name.select = uicontrol('Units','pixels', ...
               'BackgroundColor',[1 1 1], ...
               'Position',[155 158 129 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'HorizontalAlignment','Left', ...
               'Style','popupmenu', ...
               'String',new_names, ...
               'Value',1, ...
               'Enable','on', ...
               'Tag','VariablePopup');
            %
            if size(new_names,1)==1;
               set(plot_name.select,'Enable','off');
               set(plot_name.selecttext,'Enable','off');
            end;
            %
            % Select sample
            %
            uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[16 128 268 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Style','text', ...
               'String','Sample period:', ...
               'HorizontalAlignment','left', ...
               'Tag','PeriodText');
            %
            plot_name.begin = uicontrol('Units','pixels', ...
               'BackgroundColor',[1 1 1], ...
               'Position',[16 110 129 20], ...
               'Style','popupmenu', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'String',my_dates, ...
               'Callback','import_period_fcn', ...
               'HorizontalAlignment','center', ...
               'Tag','Begin',...
               'Value',1);
            %
            uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[145 112 10 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Style','text', ...
               'String','_', ...
               'HorizontalAlignment','center', ...
               'Tag','DashText');
            %
            plot_name.end = uicontrol('Units','pixels', ...
               'BackgroundColor',[1 1 1], ...
               'Position',[155 110 129 20], ...
               'Style','popupmenu', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'String',my_dates, ...
               'Callback','import_period_fcn', ...
               'HorizontalAlignment','center', ...
               'Tag','End',...
               'Value',size(dataindex,1));
            %
            % check if we can produce a scatter plot
            %
            if (empty_graph==1)&(size(new_names,1)>=2);
               plot_name.scatter = uicontrol('Units','pixels', ...
                  'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
                  'Position',[300 105 80 20], ...
                  'Value',0, ...
                  'String','Scatter plot', ...
                  'Style','checkbox', ...
                  'HorizontalAlignment','left', ...
                  'Callback','check_scatter_plot', ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'FontWeight',curr_ini.gui_fontweight, ...
                  'FontAngle',curr_ini.gui_fontangle, ...
                  'Enable','on', ...
                  'Tag','ScatterCheck');
            else;
               plot_name.scatter = [];
            end;
            %
            %
            set(plot_name.begin,'UserData',plot_name.end);
            set(plot_name.end,'UserData',plot_name.begin);
            %
            % rescaling option
            %
            plot_name.rescale = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[16 75 260 20], ...
               'Value',1, ...
               'String','Rescale data if necessary to fit into graph', ...
               'Style','checkbox', ...
               'HorizontalAlignment','left', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Enable','on', ...
               'Tag','RescaleCheck');
            %
            plot_name.mean = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[16 55 260 20], ...
               'Value',0, ...
               'String','Don''t rescale the mean', ...
               'Style','checkbox', ...
               'HorizontalAlignment','left', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Enable','on', ...
               'Tag','MeanCheck');
            %
            if empty_graph==1;
               set(plot_name.rescale,'Enable','off','Value',0);
               set(plot_name.mean,'Enable','off');
            end;
            %
            % Type of plot
            %
            plot_name.plot = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[285 75 110 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Style','radiobutton', ...
               'Value',1, ...
               'Enable','on', ...
               'Visible','on', ...
               'Max',1, ...
               'HorizontalAlignment','left', ...
               'Callback','radio_fcn', ...
               'String','Plot data as line', ...
               'Tag','WithinSampleButton');
            %
            plot_name.bars = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[285 55 110 20], ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Style','radiobutton', ...
               'Value',0, ...
               'Enable','on', ...
               'Visible','on', ...
               'Max',1, ...
               'HorizontalAlignment','left', ...
               'Callback','radio_fcn', ...
               'String','Plot data as bars', ...
               'Tag','OutOfSampleButton');
            %
            set(plot_name.plot,'UserData',plot_name.bars);
            set(plot_name.bars,'UserData',plot_name.plot);
            %
            % Two buttons to select action
            %
            plot_name.ok = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[123 12 75 25], ...
               'String','Finish', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Enable','on', ...
               'Callback','closegui', ...
               'UserData','waiting', ...
               'Tag','ButtonOK');
            %
            plot_name.cancel = uicontrol('Units','pixels', ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Position',[202 12 75 25], ...
               'String','Cancel', ...
               'FontSize',curr_ini.gui_fontsize, ...
               'FontName',curr_ini.gui_fontname, ...
               'FontWeight',curr_ini.gui_fontweight, ...
               'FontAngle',curr_ini.gui_fontangle, ...
               'Enable','on', ...
               'Callback','closegui', ...
               'Tag','ButtonCancel');
            %
            pid = [];
            %
            if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadguiicon==1);
               prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(plot_gui,'Name') ' ' fix_filepath([pwd '\icons\import.ico'])];
               dos(prog);
               if (strcmp(curr_ini.pstoolsdir,'')==0)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
                  %
                  % now we need to determine the pid
                  %
                  pid = getpid('seticon');
               end;
            end;
            %
            %
            set(plot_gui,'Visible','on');
            drawnow;
            if (iswinnt==1)&(iscompiled==1)&(matlabnumber<7);
               drawnow;
               prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(plot_gui,'Name') ' 1'];
               dos(prog);
               drawnow;
            elseif matlabnumber>=7;
               uicontrol(plot_name.cancel);
            end;
            if isempty(plot_name.scatter)==0;
               set(plot_name.scatter,'UserData',plot_name);
            end;
            waitfor(plot_gui,'waitstatus','inactive');
%            uiwait(plot_gui);
            %
            action = get(get(plot_gui,'CurrentObject'),'String');
            plot_type = get(plot_name.plot,'Value');
            rescaling = get(plot_name.rescale,'Value');
            meanscaling = get(plot_name.mean,'Value');
            s_b = get(plot_name.begin,'Value');
            s_e = get(plot_name.end,'Value');
            var_value = get(plot_name.select,'Value');
            if isempty(action)==1;
               action = 'Cancel';
            end;
            %
            % check if we should produce a regular plot or a scatter plot
            %
            reg_plot = 1;
            if (isempty(plot_name.scatter)==0)&(ishandle(plot_name.scatter)==1)&(get(plot_name.scatter,'Value')==1);
               reg_plot = 0;
            end;
            delete(plot_gui);
            drawnow;
            %
            % kill pid process if it is running
            %
            if (isempty(pid)==0)&(pid>-1)&(ispid('seticon',pid)==1);
               pid_prog = ['bin\runwindow.exe ' fix_path([curr_ini.pstoolsdir 'pskill.exe']) ' ' num2str(pid,'%0.0f') '>' fix_path([curr_ini.tempdir 'killpid.txt'])];
               dos(pid_prog);
               if ispid('seticon',pid)==1;
                  pid_prog = ['bin\runwindow.exe ' fix_path([curr_ini.pstoolsdir 'pskill.exe']) ' ' num2str(pid,'%0.0f')];
                  dos(pid_prog);
               end;
            end;
            %
            % We're now ready to plot the variable in question
            %
            if strcmp(action,'Finish')==1;
               if reg_plot==1;
                  %
                  % transform data if necessary and asked for
                  %
                  my_var = new_data(s_b:s_e,var_value);
                  dataindex = dataindex(s_b:s_e,1);
                  y_lim = get(this_axes,'YLim');
                  b_rescale = 0;
                  if rescaling==1;
                     var_max = max(my_var);
                     var_min = min(my_var);
                     %
                     % rescale if too big
                     %
                     if var_min<y_lim(1);
                        b_rescale = 1;
                     end;
                     if var_max>y_lim(2);
                        b_rescale = 1;
                     end;
                     if b_rescale==1;
                        %
                        % we need to rescale
                        %
                        % deal with the relative scale
                        %
                        y_rescale = 0.95*(abs(y_lim(2)-y_lim(1))/abs(var_max-var_min));
                        my_var = y_rescale*my_var;
                        %
                        % adjust the mean of my_var
                        %
                        if meanscaling==0;
                           y_lim_mean = sum(y_lim)/2;
                           my_var = my_var-((1/(size(my_var,1)))*sum(my_var))+y_lim_mean;
                        end;
                     end;
                     %
                     % fix Y-axis limits in the graph
                     %
                     if max(my_var)>y_lim(2);
                        y_lim(2) = 1.01*max(my_var);
                     end;
                     if min(my_var)<y_lim(1);
                        y_lim(1) = 1.01*min(my_var);
                     end;
                  end;
                  %
                  if curr_ini.colors==1;
                     colorstr1 = [0 1 0];
                  else;
                     colorstr1 = [0.3 0.3 0.3];
                  end;
                  %
                  axes(this_axes);
                  set(gca,'NextPlot','add');
                  if plot_type==1;
                     %
                     % we're doing a line plot
                     %
                     new_line = plot(dataindex',my_var','-','LineWidth',1,'Color',colorstr1,'Tag',strtrim(new_names(var_value,:)));
                     hold('on');
                     if rescaling==1;
                        set(gca,'YLim',y_lim);
                     end;
                     x_fix = 0;
                     if empty_graph==0;
                        if x_lim(1)>dataindex(1,1);
                           x_lim(1) = dataindex(1,1);
                           x_fix = 1;
                        end;
                        if x_lim(2)<dataindex(size(dataindex,1),1);
                           x_lim(2) = dataindex(size(dataindex,1),1);
                           x_fix = 1;
                        end;
                        set(gca,'XLim',x_lim);
                        if x_fix==1;
                           %
                           % stretch any lines without context menus
                           %
                           stretch_lines('h');
                           stretch_lines('v');
                           stretch_lines('d');
                        end;
                     else;
                        set(gca,'XLim',[min(dataindex) max(dataindex)]);
                        y_min = min(my_var);
                        y_max = max(my_var);
                        if y_min<0;
                           y_min = 1.01*y_min;
                        else;
                           y_min = 0.99*y_min;
                        end;
                        if y_max>0;
                           y_max = 1.01*y_max;
                        else;
                           y_max = 0.99*y_max;
                        end;
                        %
                        % make the limits symmetric
                        %
                        fix_y = max(abs(y_max-max(my_var)),abs(min(my_var)-y_min));
                        y_lim = [min(my_var)-fix_y max(my_var)+fix_y];
                        set(gca,'YLim',y_lim);
                        if (y_lim(1)<0)&(y_lim(2)>0);
                           zero_line = plot([min(dataindex) max(dataindex)],[0 0],'-','LineWidth',1,'Color',[0 0 0],'Tag','nolegend-1');
                           set(gca,'Children',[new_line;zero_line]);
                        end;
                        %
                        % Fix X axis tick marks if needed
                        %
                        xtick = get(gca,'XTick');
                        if size(xtick,2)>1;
                           if (abs(max(xtick))>10)&(abs(min(xtick))>10);
                              if abs(xtick(1,2)-xtick(1,1))<1;
                                 min_xtick = ceil(min(get(gca,'XLim')));
                                 max_xtick = floor(max(get(gca,'XLim')));
                                 new_xtick = (min_xtick:1:max_xtick);
                                 set(gca,'XTick',new_xtick);
                              end;
                           end;
                        end;
                     end;
                     if curr_ini.ytick==1;
                        fixytix(this_axes);
                     end;
                     if curr_ini.xtick==1;
                        fixxtix(this_axes);
                     end;
                     hold('off');
                     %
                     % Add a context menu to the line
                     %
                     lines_context_menu = uicontextmenu('Callback','set(get(gca,''Parent''),''Pointer'',''arrow'')');
                     uimenu('Parent',lines_context_menu,'Label','Color','Callback','lines_color_fcn');
                     line_type_menu = uimenu('Parent',lines_context_menu,'Separator','on','Label','Type');
                        uimenu('Parent',line_type_menu,'Label','Solid','Checked','on','Callback','set(gco,''LineStyle'',''-''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_type_menu,'Label','Dash','Checked','off','Callback','set(gco,''LineStyle'',''--''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_type_menu,'Label','Dot','Checked','off','Callback','set(gco,''LineStyle'','':''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_type_menu,'Label','Dash-Dot','Checked','off','Callback','set(gco,''LineStyle'',''-.''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_type_menu,'Label','None','Checked','off','Callback','set(gco,''LineStyle'',''none''); lines_type_fcn; uimenu_check_fcn');
                     line_width_menu = uimenu('Parent',lines_context_menu,'Label','Width');
                        uimenu('Parent',line_width_menu,'Label','1 pt','Checked','on','Callback','set(gco,''LineWidth'',1); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','2 pts','Checked','off','Callback','set(gco,''LineWidth'',2); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','3 pts','Checked','off','Callback','set(gco,''LineWidth'',3); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','4 pts','Checked','off','Callback','set(gco,''LineWidth'',4); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','5 pts','Checked','off','Callback','set(gco,''LineWidth'',5); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','6 pts','Checked','off','Callback','set(gco,''LineWidth'',6); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','7 pts','Checked','off','Callback','set(gco,''LineWidth'',7); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','8 pts','Checked','off','Callback','set(gco,''LineWidth'',8); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','9 pts','Checked','off','Callback','set(gco,''LineWidth'',9); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_width_menu,'Label','10 pts','Checked','off','Callback','set(gco,''LineWidth'',10); lines_type_fcn; uimenu_check_fcn');
                     line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker');
                        uimenu('Parent',line_marker_menu,'Label','none','Checked','on','Callback','set(gco,''Marker'',''none''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','plus sign','Checked','off','Callback','set(gco,''Marker'',''+''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','circle','Checked','off','Callback','set(gco,''Marker'',''o''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','asterisk','Checked','off','Callback','set(gco,''Marker'',''*''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','point','Checked','off','Callback','set(gco,''Marker'',''.''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','cross','Checked','off','Callback','set(gco,''Marker'',''x''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','square','Checked','off','Callback','set(gco,''Marker'',''s''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','diamond','Checked','off','Callback','set(gco,''Marker'',''d''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','up triangle','Checked','off','Callback','set(gco,''Marker'',''^''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','down triangle','Checked','off','Callback','set(gco,''Marker'',''v''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','right triangle','Checked','off','Callback','set(gco,''Marker'',''>''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','left triangle','Checked','off','Callback','set(gco,''Marker'',''<''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','pentagram','Checked','off','Callback','set(gco,''Marker'',''p''); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_marker_menu,'Label','hexagram','Checked','off','Callback','set(gco,''Marker'',''h''); lines_type_fcn; uimenu_check_fcn');
                     line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
                        uimenu('Parent',line_markersize_menu,'Label','1 pt','Checked','off','Callback','set(gco,''MarkerSize'',1); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','2 pts','Checked','off','Callback','set(gco,''MarkerSize'',2); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','3 pts','Checked','off','Callback','set(gco,''MarkerSize'',3); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','4 pts','Checked','off','Callback','set(gco,''MarkerSize'',4); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','5 pts','Checked','off','Callback','set(gco,''MarkerSize'',5); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked','on','Callback','set(gco,''MarkerSize'',6); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','7 pts','Checked','off','Callback','set(gco,''MarkerSize'',7); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','8 pts','Checked','off','Callback','set(gco,''MarkerSize'',8); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','9 pts','Checked','off','Callback','set(gco,''MarkerSize'',9); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','10 pts','Checked','off','Callback','set(gco,''MarkerSize'',10); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','11 pts','Checked','off','Callback','set(gco,''MarkerSize'',11); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','12 pts','Checked','off','Callback','set(gco,''MarkerSize'',12); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','13 pts','Checked','off','Callback','set(gco,''MarkerSize'',13); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','14 pts','Checked','off','Callback','set(gco,''MarkerSize'',14); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','15 pts','Checked','off','Callback','set(gco,''MarkerSize'',15); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','16 pts','Checked','off','Callback','set(gco,''MarkerSize'',16); lines_type_fcn; uimenu_check_fcn');
                     uimenu('Parent',lines_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
                     uimenu('Parent',lines_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
                     if islinetimeseries(new_line)==1;
                        uimenu('Parent',lines_context_menu,'Separator','on','Label','De-Mean','Callback','toolbar_demean_fcn');
                     end;
                     uimenu('Parent',lines_context_menu,'Label','Cut','Separator','on','Callback','delete_line_patch_fcn');
                     uimenu('Parent',lines_context_menu,'Label','Copy','Callback','copy_line_fcn');
                     set(new_line,'UIContextMenu',lines_context_menu);
                  else;
                     %
                     % we're doing a bar plot
                     %
                     new_bar = bar(dataindex,my_var,0.5);
                     hold('on');
                     if rescaling==1;
                        set(gca,'YLim',y_lim);
                     end;
                     set(new_bar,'FaceColor',colorstr1,'EdgeColor','k','LineWidth',1,'Tag','import-data');
                     %
                     x_fix = 0;
                     if empty_graph==0;
                        if x_lim(1)>dataindex(1,1);
                           x_lim(1) = dataindex(1,1);
                           x_fix = 1;
                        end;
                        if x_lim(2)<dataindex(size(dataindex,1),1);
                           x_lim(2) = dataindex(size(dataindex,1),1);
                           x_fix = 1;
                        end;
                        set(gca,'XLim',x_lim);
                        if x_fix==1;
                           %
                           % stretch any lines without context menus
                           %
                           stretch_lines('h');
                           stretch_lines('v');
                           stretch_lines('d');
                        end;
                     else;
                        set(gca,'XLim',[min(dataindex) max(dataindex)]);
                        y_min = min(my_var);
                        y_max = max(my_var);
                        if y_min<0;
                           y_min = 1.01*y_min;
                        else;
                           y_min = 0.99*y_min;
                        end;
                        if y_max>0;
                           y_max = 1.01*y_max;
                        else;
                           y_max = 0.99*y_max;
                        end;
                        %
                        % make the limits symmetric
                        %
                        fix_y = max(abs(y_max-max(my_var)),abs(min(my_var)-y_min));
                        y_lim = [min(my_var)-fix_y max(my_var)+fix_y];
                        set(gca,'YLim',y_lim);
                        if (y_lim(1)<0)&(y_lim(2)>0);
                           zero_line = plot([min(dataindex) max(dataindex)],[0 0],'-','LineWidth',1,'Color',[0 0 0],'Tag','nolegend-1');
                           set(gca,'Children',[new_bar;zero_line]);
                        end;
                     end;
                     %
                     if curr_ini.ytick==1;
                        fixytix(this_axes);
                     end;
                     if curr_ini.xtick==1;
                        fixxtix(this_axes);
                     end;
                     hold('off');
                     %
                     % create a context menu
                     %
                     patches_context_menu = uicontextmenu('Callback','set(get(gca,''Parent''),''Pointer'',''arrow'')');
                     uimenu('Parent',patches_context_menu,'Label','Patch Color','Callback','patch_color_fcn');
                     uimenu('Parent',patches_context_menu,'Label','Edge Color','Callback','patch_edgecolor_fcn');
                     uimenu('Parent',patches_context_menu,'Label','Face Color','Callback','patch_facecolor_fcn');
                     patch_type_menu = uimenu('Parent',patches_context_menu,'Separator','on','Label','Type');
                        uimenu('Parent',patch_type_menu,'Label','Solid','Checked','on','Callback','change_patch_type(''-''); uimenu_check_fcn');
                        uimenu('Parent',patch_type_menu,'Label','Dash','Checked','off','Callback','change_patch_type(''--''); uimenu_check_fcn');
                        uimenu('Parent',patch_type_menu,'Label','Dot','Checked','off','Callback','change_patch_type('':''); uimenu_check_fcn');
                        uimenu('Parent',patch_type_menu,'Label','Dash-Dot','Checked','off','Callback','change_patch_type(''-.''); uimenu_check_fcn');
                     patch_width_menu = uimenu('Parent',patches_context_menu,'Label','Width');
                        uimenu('Parent',patch_width_menu,'Label','1 pt','Checked','on','Callback','change_patch_width(1); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','2 pts','Checked','off','Callback','change_patch_width(2); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','3 pts','Checked','off','Callback','change_patch_width(3); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','4 pts','Checked','off','Callback','change_patch_width(4); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','5 pts','Checked','off','Callback','change_patch_width(5); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','6 pts','Checked','off','Callback','change_patch_width(6); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','7 pts','Checked','off','Callback','change_patch_width(7); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','8 pts','Checked','off','Callback','change_patch_width(8); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','9 pts','Checked','off','Callback','change_patch_width(9); uimenu_check_fcn');
                        uimenu('Parent',patch_width_menu,'Label','10 pts','Checked','off','Callback','change_patch_width(10); uimenu_check_fcn');
                     nudge_menu = uimenu('Parent',patches_context_menu,'Label','Nudge','Separator','on');
                        uimenu('Parent',nudge_menu,'Label','Up','Callback','nudge_fcn(''u'')');
                        uimenu('Parent',nudge_menu,'Label','Down','Callback','nudge_fcn(''d'')');
                        uimenu('Parent',nudge_menu,'Label','Left','Callback','nudge_fcn(''l'')');
                        uimenu('Parent',nudge_menu,'Label','Right','Callback','nudge_fcn(''r'')');
                     rescale_menu = uimenu('Parent',patches_context_menu,'Label','Rescale');
                        uimenu('Parent',rescale_menu,'Label','10%','Callback','rescale_patch_fcn(0.1)');
                        uimenu('Parent',rescale_menu,'Label','20%','Callback','rescale_patch_fcn(0.2)');
                        uimenu('Parent',rescale_menu,'Label','25%','Callback','rescale_patch_fcn(0.25)');
                        uimenu('Parent',rescale_menu,'Label','30%','Callback','rescale_patch_fcn(0.3)');
                        uimenu('Parent',rescale_menu,'Label','40%','Callback','rescale_patch_fcn(0.4)');
                        uimenu('Parent',rescale_menu,'Label','50%','Callback','rescale_patch_fcn(0.5)');
                        uimenu('Parent',rescale_menu,'Label','60%','Callback','rescale_patch_fcn(0.6)');
                        uimenu('Parent',rescale_menu,'Label','70%','Callback','rescale_patch_fcn(0.7)');
                        uimenu('Parent',rescale_menu,'Label','75%','Callback','rescale_patch_fcn(0.75)');
                        uimenu('Parent',rescale_menu,'Label','80%','Callback','rescale_patch_fcn(0.8)');
                        uimenu('Parent',rescale_menu,'Label','90%','Callback','rescale_patch_fcn(0.9)');
                        uimenu('Parent',rescale_menu,'Label','110%','Callback','rescale_patch_fcn(1.1)');
                        uimenu('Parent',rescale_menu,'Label','120%','Callback','rescale_patch_fcn(1.2)');
                        uimenu('Parent',rescale_menu,'Label','125%','Callback','rescale_patch_fcn(1.25)');
                        uimenu('Parent',rescale_menu,'Label','130%','Callback','rescale_patch_fcn(1.3)');
                        uimenu('Parent',rescale_menu,'Label','140%','Callback','rescale_patch_fcn(1.4)');
                        uimenu('Parent',rescale_menu,'Label','150%','Callback','rescale_patch_fcn(1.5)');
                        uimenu('Parent',rescale_menu,'Label','160%','Callback','rescale_patch_fcn(1.6)');
                        uimenu('Parent',rescale_menu,'Label','170%','Callback','rescale_patch_fcn(1.7)');
                        uimenu('Parent',rescale_menu,'Label','180%','Callback','rescale_patch_fcn(1.8)');
                        uimenu('Parent',rescale_menu,'Label','190%','Callback','rescale_patch_fcn(1.9)');
                        uimenu('Parent',rescale_menu,'Label','200%','Callback','rescale_patch_fcn(2.0)');
                        uimenu('Parent',rescale_menu,'Label','250%','Callback','rescale_patch_fcn(2.5)');
                        uimenu('Parent',rescale_menu,'Label','300%','Callback','rescale_patch_fcn(3.0)');
                        uimenu('Parent',rescale_menu,'Label','400%','Callback','rescale_patch_fcn(4.0)');
                        uimenu('Parent',rescale_menu,'Label','500%','Callback','rescale_patch_fcn(5.0)');
                        uimenu('Parent',rescale_menu,'Label','1000%','Callback','rescale_patch_fcn(10.0)');
                     uimenu('Parent',patches_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
                     if isvalidpatchname(new_bar)==1;
                        uimenu('Parent',patches_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
                     end;
                     uimenu('Parent',patches_context_menu,'Label','Cut','Separator','on','Callback','delete_line_patch_fcn');
                     uimenu('Parent',patches_context_menu,'Label','Copy','Callback','copy_patch_fcn');
                     set(new_bar,'UIContextMenu',patches_context_menu);
                  end;
                  %
                  % Update the legend if there is any
                  %
                  if isempty(get(gca,'UserData'))==0;
                     if ishandle(get(gca,'UserData'))==1;
                        update_legend_fcn;
                        my_leg = find_legend(gca);
                        ud = get(my_leg,'UserData');
                        leg_str = ud.lstrings;
                        add_str = '';
                        if b_rescale==1;
                           add_str = ' (rescaled)';
                        end;
                        leg_str{size(leg_str,1),size(leg_str,2)} = [strtrim(new_names(var_value,:)) add_str];;
                        ud.lstrings = leg_str;
                        set(my_leg,'UserData',ud);
                        txt_obj = findobj(my_leg,'Type','text')';
                        set(txt_obj,'String',leg_str);
                        update_legend_fcn;
                     end;
                  elseif empty_graph==1;
                     %
                     % Create the simplest possible title
                     %
                     setaxesfonts('Title',strtrim(new_names(var_value,:)));
                     %
                     % create a legend for the imported data in the previously empty axes
                     %
                     my_leg = add_legend_fcn(strtrim(new_names(var_value,:)));
                     set(gca,'UserData',my_leg);
                  end;
                  if empty_graph==0;
                     %
                     % make sure all previous plots except rectangle patches are presented above the new bars
                     %
                     kids = get(gca,'Children');
                     newkids = kids(1,1);
                     newkids_above = [];
                     newkids_below = [];
                     for i=2:size(kids,1);
                        if (strcmp(lower(get(kids(i,1),'Tag')),'rectpatch')==1)|(strcmp(lower(get(kids(i,1),'Tag')),'rectpatch-new')==1)|(strcmp(get(kids(i,1),'Tag'),'confpatch')==1)|(strcmp(get(kids(i,1),'Tag'),'confpatch-new')==1);
                           newkids_below = [newkids_below;kids(i,1)];
                        else;
                           newkids_above = [newkids_above;kids(i,1)];
                        end;
                     end;
                     newkids = [newkids_above;newkids;newkids_below];
                     set(gca,'Children',newkids);
                  end;
               else;
                  %
                  % select variables for scatter plot
                  %
                  [action,x_val,y_val,mark_type,bool_fd] = scatter_dlg(new_names);
                  if strcmp(lower(action),'cancel')==0;
                     %
                     % produce a scatter plot
                     %
                     x_var = new_data(s_b:s_e,x_val);
                     y_var = new_data(s_b:s_e,y_val);
                     if bool_fd==1;
                        x_var = diff(x_var);
                        y_var = diff(y_var);
                     end;
                     %
                     if curr_ini.colors==1;
                        colorstr1 = [1 0 0];
                     else;
                        colorstr1 = [0.3 0.3 0.3];
                     end;
                     %
                     axes(this_axes);
                     set(gca,'NextPlot','add');
                     %
                     % create the line plot
                     %
                     new_line = plot(x_var,y_var,'-');
                     set(new_line,'Color',get(gca,'Color'), ...
                        'LineWidth',1, ...
                        'Marker',mark_type, ...
                        'MarkerSize',6, ...
                        'MarkerFaceColor',get(gca,'Color'), ...
                        'MarkerEdgeColor',colorstr1, ...
                        'Tag',['scatter-' strtrim(new_names(x_val,:)) '.' strtrim(new_names(y_val,:))]);
                     hold('on');
                     %
                     % check if lines should be added below the scatter plot
                     %
                     y_min = min(y_var);
                     y_max = max(y_var);
                     if y_min<0;
                        y_min = 1.01*y_min;
                     else;
                        y_min = 0.99*y_min;
                     end;
                     if y_max>0;
                        y_max = 1.01*y_max;
                     else;
                        y_max = 0.99*y_max;
                     end;
                     %
                     x_min = min(x_var);
                     x_max = max(x_var);
                     if x_min<0;
                        x_min = 1.01*x_min;
                     else;
                        x_min = 0.99*x_min;
                     end;
                     if x_max>0;
                        x_max = 1.01*x_max;
                     else;
                        x_max = 0.99*x_max;
                     end;
                     if (x_min<0)&(x_max>0);
                        zero_line_x = plot([0 0],[y_min y_max],'-','LineWidth',1,'Color',[0 0 0],'Tag','nolegend-x');
                        hold('on');
                     end;
                     if (y_min<0)&(y_max>0);
                        zero_line_y = plot([x_min x_max],[0 0],'-','LineWidth',1,'Color',[0 0 0],'Tag','nolegend-y');
                        hold('on');
                     end;
                     %
                     % make the limits symmetric
                     %
                     fix_y = max(abs(y_max-max(y_var)),abs(min(y_var)-y_min));
                     y_lim = [min(y_var)-fix_y max(y_var)+fix_y];
                     %
                     % make the limits symmetric
                     %
                     fix_x = max(abs(x_max-max(x_var)),abs(min(x_var)-x_min));
                     x_lim = [min(x_var)-fix_x max(x_var)+fix_x];
                     %
                     set(gca,'XLim',x_lim,'YLim',y_lim,'Layer','top');
                     %
                     if curr_ini.ytick==1;
                        fixytix(this_axes);
                     end;
                     if curr_ini.xtick==1;
                        fixxtix(this_axes);
                     end;
                     hold('off');
                     %
                     % fix the axes context menu
                     %
                     lay_obj = findobj(get(gca,'UIContextmenu'),'Label','Layer');
                     kids = get(lay_obj,'Children');
                     b_obj = findobj(kids,'Label','Bottom');
                     t_obj = findobj(kids,'Label','Top');
                     set(b_obj,'Checked','off');
                     set(t_obj,'Checked','on');
                     if bool_fd==0;
                        set(get(gca,'Title'),'String',['Scatter plot of ' strtrim(new_names(x_val,:)) ' and ' strtrim(new_names(y_val,:))]);
                        set(get(gca,'XLabel'),'String',strtrim(new_names(x_val,:)));
                        set(get(gca,'YLabel'),'String',strtrim(new_names(y_val,:)));
                     else;
                        set(get(gca,'Title'),'String',['Scatter plot of \Delta' strtrim(new_names(x_val,:)) ' and \Delta' strtrim(new_names(y_val,:))]);
                        set(get(gca,'XLabel'),'String',['\Delta' strtrim(new_names(x_val,:))]);
                        set(get(gca,'YLabel'),'String',['\Delta' strtrim(new_names(y_val,:))]);
                     end;
                     %
                     % Add a context menu to the line
                     %
                     lines_context_menu = uicontextmenu('Callback','set(get(gca,''Parent''),''Pointer'',''arrow'')');
                     uimenu('Parent',lines_context_menu,'Label','Color','Callback','scatter_color_fcn');
                     line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker','Separator','on');
                        if strcmp(mark_type,'+')==0;
                           uimenu('Parent',line_marker_menu,'Label','plus sign','Checked','off','Callback','set(gco,''Marker'',''+''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','plus sign','Checked','on','Callback','set(gco,''Marker'',''+''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'o')==0;
                           uimenu('Parent',line_marker_menu,'Label','circle','Checked','off','Callback','set(gco,''Marker'',''o''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','circle','Checked','on','Callback','set(gco,''Marker'',''o''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'*')==0;
                           uimenu('Parent',line_marker_menu,'Label','asterisk','Checked','off','Callback','set(gco,''Marker'',''*''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','asterisk','Checked','on','Callback','set(gco,''Marker'',''*''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'.')==0;
                           uimenu('Parent',line_marker_menu,'Label','point','Checked','off','Callback','set(gco,''Marker'',''.''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','point','Checked','on','Callback','set(gco,''Marker'',''.''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'x')==0;
                           uimenu('Parent',line_marker_menu,'Label','cross','Checked','off','Callback','set(gco,''Marker'',''x''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','cross','Checked','on','Callback','set(gco,''Marker'',''x''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'s')==0;
                           uimenu('Parent',line_marker_menu,'Label','square','Checked','off','Callback','set(gco,''Marker'',''s''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','square','Checked','on','Callback','set(gco,''Marker'',''s''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'d')==0;
                           uimenu('Parent',line_marker_menu,'Label','diamond','Checked','off','Callback','set(gco,''Marker'',''d''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','diamond','Checked','on','Callback','set(gco,''Marker'',''d''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'^')==0;
                           uimenu('Parent',line_marker_menu,'Label','up triangle','Checked','off','Callback','set(gco,''Marker'',''^''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','up triangle','Checked','on','Callback','set(gco,''Marker'',''^''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'v')==0;
                           uimenu('Parent',line_marker_menu,'Label','down triangle','Checked','off','Callback','set(gco,''Marker'',''v''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','down triangle','Checked','on','Callback','set(gco,''Marker'',''v''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'>')==0;
                           uimenu('Parent',line_marker_menu,'Label','right triangle','Checked','off','Callback','set(gco,''Marker'',''>''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','right triangle','Checked','on','Callback','set(gco,''Marker'',''>''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'<')==0;
                           uimenu('Parent',line_marker_menu,'Label','left triangle','Checked','off','Callback','set(gco,''Marker'',''<''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','left triangle','Checked','on','Callback','set(gco,''Marker'',''<''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'p')==0;
                           uimenu('Parent',line_marker_menu,'Label','pentagram','Checked','off','Callback','set(gco,''Marker'',''p''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','pentagram','Checked','on','Callback','set(gco,''Marker'',''p''); lines_type_fcn; uimenu_check_fcn');
                        end;
                        if strcmp(mark_type,'h')==0;
                           uimenu('Parent',line_marker_menu,'Label','hexagram','Checked','off','Callback','set(gco,''Marker'',''h''); lines_type_fcn; uimenu_check_fcn');
                        else;
                           uimenu('Parent',line_marker_menu,'Label','hexagram','Checked','on','Callback','set(gco,''Marker'',''h''); lines_type_fcn; uimenu_check_fcn');
                        end;
                     line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
                        uimenu('Parent',line_markersize_menu,'Label','1 pt','Checked','off','Callback','set(gco,''MarkerSize'',1); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','2 pts','Checked','off','Callback','set(gco,''MarkerSize'',2); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','3 pts','Checked','off','Callback','set(gco,''MarkerSize'',3); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','4 pts','Checked','off','Callback','set(gco,''MarkerSize'',4); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','5 pts','Checked','off','Callback','set(gco,''MarkerSize'',5); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked','on','Callback','set(gco,''MarkerSize'',6); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','7 pts','Checked','off','Callback','set(gco,''MarkerSize'',7); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','8 pts','Checked','off','Callback','set(gco,''MarkerSize'',8); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','9 pts','Checked','off','Callback','set(gco,''MarkerSize'',9); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','10 pts','Checked','off','Callback','set(gco,''MarkerSize'',10); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','11 pts','Checked','off','Callback','set(gco,''MarkerSize'',11); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','12 pts','Checked','off','Callback','set(gco,''MarkerSize'',12); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','13 pts','Checked','off','Callback','set(gco,''MarkerSize'',13); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','14 pts','Checked','off','Callback','set(gco,''MarkerSize'',14); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','15 pts','Checked','off','Callback','set(gco,''MarkerSize'',15); lines_type_fcn; uimenu_check_fcn');
                        uimenu('Parent',line_markersize_menu,'Label','16 pts','Checked','off','Callback','set(gco,''MarkerSize'',16); lines_type_fcn; uimenu_check_fcn');
                     uimenu('Parent',lines_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
                     uimenu('Parent',lines_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
                     uimenu('Parent',lines_context_menu,'Label','Cut','Separator','on','Callback','delete_line_patch_fcn');
                     uimenu('Parent',lines_context_menu,'Label','Copy','Callback','copy_line_fcn');
                     set(new_line,'UIContextMenu',lines_context_menu);
                  end;
               end;
            end;
         else;
            txt = ['The X-axis limits in the axes object don''t match up with the dates limits in "' getfilename(file) '". Unable to complete data import.'];
            about(txt,'information','Import Data Dates Issue...',120,350);
         end;
      else;
         txt = ['Unable to locate any date data in the file "' openfile '". This is needed to plot a variable from this file into the current axes.'];
         about(txt,'error','Import Data Error...',120,350);
      end;
   else;
      if status==-1;
         txt = ['There are missing observations in the file "' openfile '".'];
      else;
         txt = ['Unable to locate any numeric data in the file "' openfile '".'];
      end;
      about(txt,'error','Import Data Error...',120,350);
   end;
end;

%
% end of import_data_fcn.m
%
