function [out,m_v,oldmodel_var,curr_ini] = main_openmodel_fcn(out,m_v,oldmodel_var,curr_ini,button_images,fig)

thisfile = get(out.reopen,'UserData');
if isfield(m_v,'modelfile')==1;
   oldmodelfile = m_v.modelfile;
else;
   oldmodelfile = '';
end;
if strcmp(thisfile,'')==1;
   needfix = 1;
   %
   if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1)&(matlabnumber<6.0);
      basedir = pwd;
      newinputfile = get(out.open,'UserData');
      if fileexist(newinputfile)==1;
         basedir = getpath(newinputfile);
      end;
      file_fltr = 'VAR Model Files (*.var)|*.var|';
      best_pos = 1;
      title_txt = 'Open';
      %
      [m_v.modelfile,modelpath] = fileopen(basedir,file_fltr,best_pos,title_txt);
   else;
      if matlabnumber>=6.0;
         inputfiletype = {'*.var', 'VAR Model Files (*.var)'};
      else;
         inputfiletype = '*.var';
         if ispc==1;
            inputfiletype = 'VAR Model File ;*.var';
         end;
      end;
      newinputfile = get(out.open,'UserData');
      if fileexist(newinputfile)==1;
         inpsize = size(getpath(newinputfile),2);
         if strcmp(newinputfile(1,inpsize),'\')==1;
            inputfiletype=strcat(getpath(newinputfile),inputfiletype);
         elseif strcmp(newinputfile(1,inpsize),'/')==1;
            inputfiletype=strcat(getpath(newinputfile),inputfiletype);
         else;
            inputfiletype=strcat(getpath(newinputfile),'/',inputfiletype);
         end;
      end;
      if matlabnumber>=6;
         if strcmp(oldmodelfile,'')==1;
            if ispc==1;
               dfile = [pwd '\'];
            else;
               dfile = [pwd '/'];
            end;
         else;
            dfile = oldmodelfile;
         end;
         [m_v.modelfile,modelpath] = uigetfile(inputfiletype,'Open',dfile);
      else;
         [m_v.modelfile,modelpath] = uigetfile(inputfiletype,'Open');
      end;
   end;
   drawnow;
else;
   needfix = 0;
   m_v.modelfile = getfilename(thisfile);
   modelpath = getpath(thisfile);
   set(out.reopen,'UserData','');
end;
%
% check to make sure that the input files exist
%
if isnumeric(m_v.modelfile)==0;
   mv = m_v;
   mv.inputfile = strcat(modelpath,m_v.modelfile);
   if fileexist(mv.inputfile)==1;
      [mv,renable] = load_model_fcn(mv);
      check_datafile = [];
      if fileexist(mv.endofile)==0;
         check_datafile.endogenous = mv.endofile;
      end;
      if strcmp(strtrim(lower(mv.exo1file)),'')==0;
         if fileexist(mv.exo1file)==0;
            check_datafile.exogenousi1 = mv.exo1file;
         end;
      end;
      if strcmp(strtrim(lower(mv.exo1file)),'')==0;
         if fileexist(mv.exo1file)==0;
            check_datafile.exogenousi0 = mv.exo1file;
         end;
      end;
      if strcmp(strtrim(lower(mv.deterfile)),'')==0;
         if fileexist(mv.deterfile)==0;
            check_datafile.deterministic = mv.deterfile;
         end;
      end;
      %
      % prepare error message if needed
      %
      if isempty(check_datafile)==0;
         txt = ['The model file "' getname(mv.inputfile) '" contains references to data files that don''t exist. Specifically, the following files could not be found:'];
         txt_add = '';
         if isfield(check_datafile,'endogenous')==1;
            txt_add = strvcat(txt_add,['     Endogenous - ' check_datafile.endogenous]);
         end;
         if isfield(check_datafile,'exogenousi1')==1;
            txt_add = strvcat(txt_add,['     Exogenous I(1) -' check_datafile.exogenousi1]);
         end;
         if isfield(check_datafile,'exogenousi0')==1;
            txt_add = strvcat(txt_add,['     Exogenous I(0) - ' check_datafile.exogenousi0]);
         end;
         if isfield(check_datafile,'deterministic')==1;
            txt_add = strvcat(txt_add,['     Deterministic - ' check_datafile.deterministic]);
         end;
         txt = strvcat(txt,' ',txt_add);
         about(txt,'error','Error Loading Model',160,600);
         m_v.modelfile = oldmodelfile;
         return;
      end;
   end;
end;
%
if isnumeric(m_v.modelfile)==0;
   m_v.inputfile = strcat(modelpath,m_v.modelfile);
   if fileexist(m_v.inputfile)==1;
      %
      % if need to fix curr_ini.reopenlist variable and m_v.reopenfile variable
      %
      if needfix==1;
         if isempty(findstr(m_v.inputfile,curr_ini.reopenlist))==1;
            if size(m_v.reopenfile,1)>=10;
               m_v.reopenfile = m_v.reopenfile(1:9,:);
            end;
            m_v.reopenfile = strvcat(m_v.inputfile,m_v.reopenfile);
            curr_ini.reopenlist = [m_v.inputfile '|' curr_ini.reopenlist];
         end;
         %
         % Delete objects in file list
         %
         thish = findobj('Type','uimenu','Callback','maindlg reopen')';
         if isempty(thish)==0;
            delete(thish);
         end;
         %
         % recreate objects in file list menu
         %
         num = 1;
         for i=1:size(m_v.reopenfile,1);
            thisfile = strtrim(m_v.reopenfile(i,:));
            if strcmp(m_v.inputfile,thisfile)==0;
               if num==1;
                  out.thisfile = uimenu('Parent',out.reopen, ...
                     'Label',['&' num2str(num) '. ' getfilename(thisfile)], ...
                     'Callback','maindlg reopen', ...
                     'Accelerator',num2str(num), ...
                     'Separator','on', ...
                     'UserData',thisfile, ...
                     'Tag',[num2str(num) '-' getfilename(thisfile)]);
               else;
                  if num<10;
                     out.thisfile = uimenu('Parent',out.reopen, ...
                        'Label',['&' num2str(num) '. ' getfilename(thisfile)], ...
                        'Callback','maindlg reopen', ...
                        'Accelerator',num2str(num), ...
                        'UserData',thisfile, ...
                        'Tag',[num2str(num) '-' getfilename(thisfile)]);
                  else;
                     out.thisfile = uimenu('Parent',out.reopen, ...
                        'Label',['1&0. ' getfilename(thisfile)], ...
                        'Callback','maindlg reopen', ...
                        'Accelerator','0', ...
                        'UserData',thisfile, ...
                        'Tag',['10-' getfilename(thisfile)]);
                  end;
               end;
               num = num+1;
            end;
         end;
%         set(fig,'UserData',model);
      end;
      m_v.nameinput = m_v.inputfile;
      set(out.close,'Enable','on');
      set(out.clear,'Enable','on');
      set(out.reorderlist,'Enable','on');
      %
      [m_v,runenable] = load_model_fcn(m_v);
      %
      m_v.basedir = m_v.modelsdir;
      numchar = size(m_v.basedir,2);
      if numchar>=1;
         m_v.basedir = m_v.basedir(1,1:numchar-1);
      end;
      i = numchar-1;
      while i>=1;
         if strcmp(m_v.basedir(1,i),'\')==1;
            m_v.basedir = m_v.basedir(1,1:i-1);
            i = 0;
         elseif strcmp(m_v.basedir(1,i),'/')==1;
            m_v.basedir = m_v.basedir(1,1:i-1);
            i = 0;
         else;
            i = i-1;
         end;
      end;
   end;
   m_v.newdeterselect = m_v.deterselect;
   m_v.newmodeltype = m_v.modeltype;
   m_v.newseasonal = m_v.seasonal;
   oldmodel_var = m_v;
   %
   set(out.endogenous,'String',m_v.endofile,'UserData',m_v.modelsdir);
   set(out.exogenous1,'String',m_v.exo1file);
   set(out.exogenous0,'String',m_v.exo0file);
   set(out.deterministic,'String',m_v.deterfile);
   %
   if isempty(m_v.endosheet)==1;
      set(out.endosheettext,'String','Data sheet: None');
   else;
      set(out.endosheettext,'String',['Data sheet: ' m_v.endosheet]);
   end;
   if isempty(m_v.exo1sheet)==1;
      set(out.exo1sheettext,'String','Data sheet: None');
   else;
      set(out.exo1sheettext,'String',['Data sheet: ' m_v.exo1sheet]);
   end;
   if isempty(m_v.exo0sheet)==1;
      set(out.exo0sheettext,'String','Data sheet: None');
   else;
      set(out.exo0sheettext,'String',['Data sheet: ' m_v.exo0sheet]);
   end;
   if isempty(m_v.detersheet)==1;
      set(out.detersheettext,'String','Data sheet: None');
   else;
      set(out.detersheettext,'String',['Data sheet: ' m_v.detersheet]);
   end;
   %
   set(out.outputfile,'String',m_v.outputfile);
   lagstring = '1';
   for i=2:max(max([m_v.newp m_v.lagexo]),curr_ini.maxlag);
      lagstring = [lagstring '|' num2str(i,'%0.0f')];
   end;
   respstring = '1';
   for i=2:max(m_v.newh,curr_ini.maxresp);
      respstring = [respstring '|' num2str(i,'%0.0f')];
   end;
   set(out.mypopup,'String',lagstring,'Value',m_v.newp);
   set(out.lagexo,'String',['0|' lagstring],'Value',m_v.lagexo+1);
   set(out.mypopuph,'String',respstring,'Value',m_v.newh);
   set(out.mypopupc,'Value',m_v.newc);
   set(out.radiocoint,'Value',m_v.cointvalue);
   if m_v.cointvalue==1;
      m_v.nocointvalue = 0;
   else;
      m_v.nocointvalue = 1;
   end;
   set(out.radionocoint,'Value',m_v.nocointvalue);
   set(out.serial,'Value',m_v.spectest(1,1));
   set(out.arch,'Value',m_v.spectest(1,2));
   set(out.normality,'Value',m_v.spectest(1,3));
   set(out.constancy,'Value',m_v.spectest(1,4));
   set(out.uconstant,'Value',m_v.deterselect(1,1));
   set(out.rconstant,'Value',m_v.deterselect(1,2));
   set(out.utrend,'Value',m_v.deterselect(1,3));
   set(out.rtrend,'Value',m_v.deterselect(1,4));
   set(out.structural,'Value',m_v.modeltype(1,1));
   set(out.reduced,'Value',m_v.modeltype(1,2));
   set(out.seasonal,'Value',m_v.seasonal(1,1));
   set(out.noseasonal,'Value',m_v.seasonal(1,2));
   set(out.seasonal,'UserData',m_v.freq);
   set(out.open,'UserData',m_v.inputfile);
   %
   % Fix the scale variables controls
   %
   set(out.scale_1,'Check','off');
   set(out.scale_2,'Check','off');
   set(out.scale_3,'Check','off');
   set(out.scale_4,'Check','off');
   set(out.scale_5,'Check','off');
   set(out.scale_6,'Check','off');
   set(out.scale_7,'Check','off');
   set(out.scale_8,'Check','off');
   set(out.scale_9,'Check','off');
   if m_v.scale_endo==0.0001;
      set(out.scale_1,'Check','on');
   elseif m_v.scale_endo==0.001;
      set(out.scale_2,'Check','on');
   elseif m_v.scale_endo==0.01;
      set(out.scale_3,'Check','on');
   elseif m_v.scale_endo==0.1;
      set(out.scale_4,'Check','on');
   elseif m_v.scale_endo==1;
      set(out.scale_5,'Check','on');
   elseif m_v.scale_endo==10;
      set(out.scale_6,'Check','on');
   elseif m_v.scale_endo==100;
      set(out.scale_7,'Check','on');
   elseif m_v.scale_endo==1000;
      set(out.scale_8,'Check','on');
   elseif m_v.scale_endo==10000;
      set(out.scale_9,'Check','on');
   end;
   if fileexist(m_v.endofile)==1;
      set(out.run,'Enable','on');
      set(out.estimate,'Enable','on');
      set(out.model_select,'Enable','on');
      if strcmp(strtrim(m_v.evars),'')==1;
         set(out.endogenoustext,'String','Endogenous variables:  Not determined');
      else;
         set(out.endogenoustext,'String',['Endogenous variables:  ' m_v.evars]);
      end;
      set(out.endonames,'UserData',m_v.evars,'Enable','on');
      set(out.endonamesmenu,'Enable','on');
      set(out.change_endonames,'Enable','on','CData',button_images.rename);
      set(out.endographicsmenu,'Enable','on');
      set(out.beginyear,'String',m_v.beginyear,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.beginperiod,'String',m_v.beginperiod,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.endyear,'String',m_v.endyear,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.endperiod,'String',m_v.endperiod,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.subbeginyear,'String',m_v.subbeginyear,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.subbeginperiod,'String',m_v.subbeginperiod,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.subendyear,'String',m_v.subendyear,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.subendperiod,'String',m_v.subendperiod,'Enable','on','BackgroundColor',[1 1 1]);
      set(out.sample,'Enable','on');
      set(out.subsample,'Enable','on');
      set(out.mypopup,'Enable','on');
      set(out.mypopupc,'Enable','on');
      set(out.mypopuph,'Enable','on');
      set(out.mypopuptext,'Enable','on');
      set(out.mypopuphtext,'Enable','on');
      set(out.mypopupctext,'Enable','on');
      set(out.radiocoint,'Enable','on');
      set(out.radionocoint,'Enable','on');
      set(out.serial,'Enable','on');
      set(out.arch,'Enable','on');
      set(out.normality,'Enable','on');
      set(out.constancy,'Enable','on');
      set(out.uconstant,'Enable','on');
      set(out.rconstant,'Enable','on');
      set(out.utrend,'Enable','on');
      set(out.rtrend,'Enable','on');
      set(out.structural,'Enable','on');
      set(out.reduced,'Enable','on');
      set(out.exo1menu,'Enable','on');
      set(out.exo0menu,'Enable','on');
      set(out.determenu,'Enable','on');
      set(out.exogenous1text,'Enable','on');
      if strcmp(get(out.exogenous1,'Type'),'uicontrol')==1;
         set(out.exogenous1,'Enable','on','BackgroundColor',[1 1 1]);
      else;
         editbox(out.exogenous1,'Enable','on','BackgroundColor',[1 1 1]);
      end;
      set(out.exo1button,'Enable','on');
      set(out.exo1button,'CData',button_images.browse);
      set(out.exogenous0text,'Enable','on');
      if strcmp(get(out.exogenous0,'Type'),'uicontrol')==1;
         set(out.exogenous0,'Enable','on','BackgroundColor',[1 1 1]);
      else;
         editbox(out.exogenous0,'Enable','on','BackgroundColor',[1 1 1]);
      end;
      set(out.exo0button,'Enable','on','CData',button_images.browse);
      set(out.deterministictext,'Enable','on');
      if strcmp(get(out.deterministic,'Type'),'uicontrol')==1;
         set(out.deterministic,'Enable','on','BackgroundColor',[1 1 1]);
      else;
         editbox(out.deterministic,'Enable','on','BackgroundColor',[1 1 1]);
      end;
      set(out.deterbutton,'Enable','on','CData',button_images.browse);
      if strcmp(get(out.seasonal,'UserData'),'')==0;
         if strcmp(m_v.freq,'y')==0;
            set(out.seasonal,'Enable','on');
            set(out.noseasonal,'Enable','on');
         else;
            set(out.seasonal,'Enable','off');
            set(out.noseasonal,'Enable','off');
         end;
      else;
         set(out.seasonal,'Enable','off');
         set(out.noseasonal,'Enable','off');
      end;
      status_str = 'Ready';
   else;
      status_str = ['Structural VAR, version ' num2str(myvers,'%0.2f')];
   end;
   lagexo_str = 'off';
   if fileexist(m_v.exo1file)==1;
      set(out.exo1names,'UserData',m_v.xvars1,'Enable','on');
      set(out.exo1namesmenu,'Enable','on');
      set(out.change_exo1names,'Enable','on','CData',button_images.rename);
      if strcmp(strtrim(m_v.xvars1),'')==1;
         set(out.exogenous1text,'String','Exogenous I(1) variables:  Not determined');
      else;
         set(out.exogenous1text,'String',['Exogenous I(1) variables:  ' m_v.xvars1]);
      end;
      set(out.exo1graphicsmenu,'Enable','on');
      lagexo_str = 'on';
   else;
      set(out.exo1names,'UserData',m_v.xvars1,'Enable','off');
      set(out.exo1namesmenu,'Enable','off');
      set(out.change_exo1names,'Enable','off','CData',button_images.renamedisable);
      set(out.exogenous1text,'String','Exogenous I(1) variables:  None');
      set(out.exo1graphicsmenu,'Enable','off');
   end;
   if fileexist(m_v.exo0file)==1;
      set(out.exo0names,'UserData',m_v.xvars0,'Enable','on');
      set(out.exo0namesmenu,'Enable','on');
      set(out.change_exo0names,'Enable','on','CData',button_images.rename);
      if strcmp(strtrim(m_v.xvars0),'')==1;
         set(out.exogenous0text,'String','Exogenous I(0) variables:  Not determined');
      else;
         set(out.exogenous0text,'String',['Exogenous I(0) variables:  ' m_v.xvars0]);
      end;
      set(out.exo0graphicsmenu,'Enable','on');
      lagexo_str = 'on';
   else;
      set(out.exo0names,'UserData',m_v.xvars0,'Enable','off');
      set(out.exo0namesmenu,'Enable','off');
      set(out.change_exo0names,'Enable','off','CData',button_images.renamedisable);
      set(out.exogenous0text,'String','Exogenous I(0) variables:  None');
      set(out.exo0graphicsmenu,'Enable','off');
   end;
   set(out.lagexo,'Enable',lagexo_str);
   set(out.lagexotext,'Enable',lagexo_str);
   if fileexist(m_v.deterfile)==1;
      set(out.deternames,'UserData',m_v.deter,'Enable','on');
      set(out.deternamesmenu,'Enable','on');
      set(out.change_deternames,'Enable','on','CData',button_images.rename);
      if strcmp(strtrim(m_v.deter),'')==1;
         set(out.deterministictext,'String','Deterministic variables:  Not determined');
      else;
         set(out.deterministictext,'String',['Deterministic variables:  ' m_v.deter]);
      end;
      set(out.detergraphicsmenu,'Enable','on');
   else;
      set(out.deternames,'UserData',m_v.deter,'Enable','off');
      set(out.deternamesmenu,'Enable','off');
      set(out.change_deternames,'Enable','off','CData',button_images.renamedisable);
      set(out.deterministictext,'String','Deterministic variables:  None');
      set(out.detergraphicsmenu,'Enable','off');
   end;
   if fileexist(m_v.outputfile)==1;
      set(out.printpreview,'Enable','on');
      set(out.print,'Enable','on');
      set(out.printmenu,'Enable','on');
      set(out.printpreviewmenu,'Enable','on');
      if strcmp(curr_ini.editor,'')==0;
         set(out.editormenu,'Enable','on');
      else;
         set(out.editormenu,'Enable','off');
      end;
      if islatexformat(m_v.outputfile)==1;
         stat_dvi = check_dvi(curr_ini);
         if stat_dvi==0;
            set(out.dvimenu,'Enable','on');
         else;
            set(out.dvimenu,'Enable','off');
         end;
         [stat_ps,dvips] = check_ps(curr_ini);
         if stat_ps==0;
            set(out.psmenu,'Enable','on');
         else;
            set(out.psmenu,'Enable','off');
         end;
         [stat_pdf,prog_seq] = check_pdf(curr_ini);
         if stat_pdf==0;
            set(out.pdfmenu,'Enable','on');
         else;
            set(out.pdfmenu,'Enable','off');
         end;
      else;
         set(out.dvimenu,'Enable','off');
         set(out.psmenu,'Enable','off');
         set(out.pdfmenu,'Enable','off');
      end;
   else;
      set(out.printpreview,'Enable','off');
      set(out.print,'Enable','off');
      set(out.printmenu,'Enable','off');
      set(out.printpreviewmenu,'Enable','off');
      if strcmp(curr_ini.editor,'')==0;
         set(out.editormenu,'Enable','off');
      end;
      set(out.dvimenu,'Enable','off');
      set(out.psmenu,'Enable','off');
      set(out.pdfmenu,'Enable','off');
   end;
   set(out.store,'Enable','off');
   set(out.savemenu,'Enable','off');
   ud = get(out.statusbar,'UserData');
   ud.string = status_str;
   set(out.statusbar,'String',ud.string,'UserData',ud);
   set(fig,'Name',['Structural VAR' m_v.nameinput],'UserData',out);
else;
   oldmodel_var = oldmodel_var;
end;
modeldesc = getmodeldesc(m_v,m_v.deterselect,m_v.modeltype,m_v.seasonal);
set(out.text,'String',modeldesc);

%
% end of main_openmodel_fcn.m
%
