function [out,m_v,curr_ini] = main_run_fcn(out,m_v,curr_ini,fig)

m_v.newp = get(out.mypopup,'Value');
m_v.lagexo = get(out.lagexo,'Value')-1;
if strcmp(get(out.lagexo,'Enable'),'off')==1;
   m_v.lagexo = 0;
end;
m_v.newh = get(out.mypopuph,'Value');
m_v.newc = get(out.mypopupc,'Value');
m_v.modelfile = get(out.open,'UserData');
m_v.spectest(1,1) = get(out.serial,'Value');
m_v.spectest(1,2) = get(out.arch,'Value');
m_v.spectest(1,3) = get(out.normality,'Value');
m_v.spectest(1,4) = get(out.constancy,'Value');
%
m_v.modelfile = getname(m_v.modelfile);
m_v.cointvalue = get(out.radiocoint,'Value');
m_v.nocointvalue = get(out.radionocoint,'Value');
m_v.endofile = get(out.endogenous,'String');
m_v.modelsdir = get(out.endogenous,'UserData');
if strcmp(m_v.modelsdir,'')==1;
   if curr_ini.dirstructure==0;
      m_v.modelsdir = getpath(m_v.outputfile);
      mysize = size(m_v.modelsdir,2);
      mymodelsdir1 = m_v.modelsdir(1,1:mysize-8);
      mymodelsdir2 = m_v.modelsdir(1,mysize);
      m_v.modelsdir = [mymodelsdir1 'models' mymodelsdir2];
   else;
      m_v.modelsdir = getpath(m_v.endofile);
   end;
end;
m_v.exo1file = get(out.exogenous1,'String');
m_v.exo0file = get(out.exogenous0,'String');
m_v.deterfile = get(out.deterministic,'String');
m_v.evars = get(out.endonames,'UserData');
m_v.xvars1 = get(out.exo1names,'UserData');
m_v.xvars0 = get(out.exo0names,'UserData');
m_v.deter = get(out.deternames,'UserData');
m_v.outputfile = get(out.outputfile,'String');
numout = size(m_v.outputfile,2);
if numout<=4;
   if (isfield(m_v,'outputdir')==0)|(direxist(m_v.outputdir)==0);
      mypwd = pwd;
      if strcmp(mypwd(1,1),'/')==1;
         if curr_ini.dirstructure==1;
            m_v.outputfile = strcat(pwd,'/output.txt');
         else;
            m_v.outputfile = strcat(pwd,'/results/output.txt');
         end;
      else;
         if curr_ini.dirstructure==1;
            m_v.outputfile = strcat(pwd,'\output.txt');
         else;
            m_v.outputfile = strcat(pwd,'\results\output.txt');
         end;
      end;
   else;
      m_v.outputfile = [m_v.outputdir 'output-' getname(m_v.endofile) '.txt'];
   end;
   set(out.outputfile,'String',m_v.outputfile);
end;
numout = size(m_v.exo1file,2);
if numout>0;
   if fileexist(m_v.exo1file)==0;
      m_v.exo1file = '';
      m_v.xvars1 = '';
   end;
end;
numout = size(m_v.exo0file,2);
if numout>0;
   if fileexist(m_v.exo0file)==0;
      m_v.exo0file = '';
      m_v.xvars0 = '';
   end;
end;
numout = size(m_v.deterfile,2);
if numout>0;
   if fileexist(m_v.deterfile)==0;
      m_v.deterfile = '';
      m_v.deter = '';
   end;
end;
%
% scale variables
%
if strcmp(get(out.scale_1,'Check'),'on')==1;
   m_v.scale_endo = 0.0001;
elseif strcmp(get(out.scale_2,'Check'),'on')==1;
   m_v.scale_endo = 0.001;
elseif strcmp(get(out.scale_3,'Check'),'on')==1;
   m_v.scale_endo = 0.01;
elseif strcmp(get(out.scale_4,'Check'),'on')==1;
   m_v.scale_endo = 0.1;
elseif strcmp(get(out.scale_5,'Check'),'on')==1;
   m_v.scale_endo = 1;
elseif strcmp(get(out.scale_6,'Check'),'on')==1;
   m_v.scale_endo = 10;
elseif strcmp(get(out.scale_7,'Check'),'on')==1;
   m_v.scale_endo = 100;
elseif strcmp(get(out.scale_8,'Check'),'on')==1;
   m_v.scale_endo = 1000;
elseif strcmp(get(out.scale_9,'Check'),'on')==1;
   m_v.scale_endo = 10000;
else;
   m_v.scale_endo = 1;
end;
%
m_v.p = m_v.newp;
m_v.pe = m_v.lagexo;
m_v.h = m_v.newh;
m_v.c = 49+m_v.newc;
txt = ['Are you sure you want to estimate the model with ' num2str(m_v.p) ' lag'];
if m_v.p>1;
   txt = [txt 's'];
end;
add_txt = '';
height = 90;
if strcmp(get(out.lagexo,'Enable'),'on')==1;
   if m_v.nocointvalue==1;
      txt = [txt ' on endogenous variables, ' num2str(m_v.pe) ' lag'];
   else;
      txt = [txt ' on endogenous variables and ' num2str(m_v.pe) ' lag'];
   end;
   if m_v.pe~=1;
      txt = [txt 's'];
   end;
   txt = [txt ' on exogenous variables'];
   add_txt = ',';
   height = height+20;
end;
if m_v.nocointvalue==1;
   txt = [txt add_txt ' and no cointegration restrictions?'];
   height = height+20;
else;
   txt = [txt '?'];
end
if curr_ini.method(1,3)==0;
   name = 'Structural VAR - Estimate';
else;
   txt = strrep(txt,'estimate','analyse');
   name = 'Structural VAR - Bayesian Analysis';
end;
if (curr_ini.sillyq==0)&(curr_ini.startrun==0)&(m_v.inistartrun==0);
   answer = query(txt,'question',max(height,120),name,350);
   drawnow;
else;
   answer = 'Yes';
end;
if strcmp(answer,'Yes');
   if curr_ini.method(1,3)==0;
      set(out.statusbar,'String',['Estimating model "' getname(m_v.inputfile) '"...']);
      set(out.quitdata,'UserData',['Estimating model "' getname(m_v.inputfile) '"...']);
   else;
      set(out.statusbar,'String',['Bayesian analysis of model "' getname(m_v.inputfile) '"...']);
      set(out.quitdata,'UserData',['Bayesian analysis of model "' getname(m_v.inputfile) '"...']);
   end;
   set(fig,'WindowButtonMotionFcn','');
   if curr_ini.clearlog==0;
      set(out.estimation_log,'String','','UserData',1);
   else;
      log_str = get(out.estimation_log,'String');
      if isempty(log_str)==0;
         setlogtext(strvcat(' ','*********************************************************',' '));
      else;
         set(out.estimation_log,'UserData',1);
      end;
   end;
   drawnow;
   outputdir = getpath(m_v.outputfile);
   if curr_ini.dirstructure==1;
      mystatus = 2;
      mystatus2 = 2;
   else;
      if m_v.newoutputpath==1;
         mystatus = makedirs(m_v.modelsdir);
         mystatus2 = makedirs(outputdir);
         m_v.newoutputpath = 0;
      else;
         if direxist(m_v.modelsdir)==0;
            mystatus = makedirs(m_v.modelsdir);
         else;
            mystatus = 2;
         end;
         if direxist(outputdir)==0;
            mystatus2 = makedirs(outputdir);
         else;
            mystatus2 = 2;
         end;
      end;
   end;
   %
   % check if output-file exist
   %
   if direxist(outputdir)==0;
      mystatus = makedirs(outputdir);
   end;
   %
   m_v.deterselect(1,1) = get(out.uconstant,'Value');
   m_v.deterselect(1,2) = get(out.rconstant,'Value');
   m_v.deterselect(1,3) = get(out.utrend,'Value');
   m_v.deterselect(1,4) = get(out.rtrend,'Value');
   m_v.modeltype(1,1) = get(out.structural,'Value');
   m_v.modeltype(1,2) = get(out.reduced,'Value');
   m_v.seasonal(1,1) = get(out.seasonal,'Value');
   m_v.seasonal(1,2) = get(out.noseasonal,'Value');
   m_v.beginyear = get(out.beginyear,'String');
   m_v.beginyear = strrep(m_v.beginyear,' ','');
   m_v.beginperiod = get(out.beginperiod,'String');
   m_v.beginperiod = strrep(m_v.beginperiod,' ','');
   m_v.endyear = get(out.endyear,'String');
   m_v.endyear = strrep(m_v.endyear,' ','');
   m_v.endperiod = get(out.endperiod,'String');
   m_v.endperiod = strrep(m_v.endperiod,' ','');
   m_v.subbeginyear = get(out.subbeginyear,'String');
   m_v.subbeginyear = strrep(m_v.subbeginyear,' ','');
   m_v.subbeginperiod = get(out.subbeginperiod,'String');
   m_v.subbeginperiod = strrep(m_v.subbeginperiod,' ','');
   m_v.subendyear = get(out.subendyear,'String');
   m_v.subendyear = strrep(m_v.subendyear,' ','');
   m_v.subendperiod = get(out.subendperiod,'String');
   m_v.subendperiod = strrep(m_v.subendperiod,' ','');
   set(out.run,'Enable','off');
   set(out.estimate,'Enable','off');
   set(out.model_select,'Enable','off');
   if (strcmp(get(out.endogenous,'Type'),'uicontrol')==1)&(isfield(out,'editundo')==1);
      set(out.editundo,'Enable','off');
      set(out.editcopy,'Enable','off');
      set(out.editcut,'Enable','off');
      set(out.editpaste,'Enable','off');
      set(out.editselectall,'Enable','off');
      set(out.cutbtn,'Enable','off');
      set(out.copybtn,'Enable','off');
      set(out.pastebtn,'Enable','off');
      set(out.selectallbtn,'Enable','off');
   end;
   newxvars1 = m_v.xvars1;
   newxvars0 = m_v.xvars0;
   varrun(m_v,curr_ini,fig);
   ud = get(out.statusbar,'UserData');
   set(out.statusbar,'String',ud.string);
   set(fig,'WindowButtonMotionFcn','show_main_status_fcn');
   m_v.xvars1 = newxvars1;
   m_v.xvars0 = newxvars0;
   set(out.run,'Enable','on');
   set(out.estimate,'Enable','on');
   set(out.model_select,'Enable','on');
   if fileexist(m_v.outputfile)==1;
      set(out.printpreview,'Enable','on');
      set(out.print,'Enable','on');
      set(out.printmenu,'Enable','on');
      set(out.printpreviewmenu,'Enable','on');
      if strcmp(curr_ini.editor,'')==0;
         set(out.editormenu,'Enable','on');
      else;
         set(out.editormenu,'Enable','off');
      end;
      if islatexformat(m_v.outputfile)==1;
         stat_dvi = check_dvi(curr_ini);
         if stat_dvi==0;
            set(out.dvimenu,'Enable','on');
         else;
            set(out.dvimenu,'Enable','off');
         end;
         [stat_ps,dvips] = check_ps(curr_ini);
         if stat_ps==0;
            set(out.psmenu,'Enable','on');
         else;
            set(out.psmenu,'Enable','off');
         end;
         [stat_pdf,prog_seq] = check_pdf(curr_ini);
         if stat_pdf==0;
            set(out.pdfmenu,'Enable','on');
         else;
            set(out.pdfmenu,'Enable','off');
         end;
      else;
         set(out.dvimenu,'Enable','off');
         set(out.psmenu,'Enable','off');
         set(out.pdfmenu,'Enable','off');
      end;
   else;
      set(out.dvimenu,'Enable','off');
      set(out.psmenu,'Enable','off');
      set(out.pdfmenu,'Enable','off');
   end;
   if (strcmp(get(out.endogenous,'Type'),'uicontrol')==1)&(isfield(out,'editundo')==1);
      set(out.editundo,'Enable','on');
      set(out.editcopy,'Enable','on');
      set(out.editcut,'Enable','on');
      set(out.editpaste,'Enable','on');
      set(out.editselectall,'Enable','on');
      set(out.cutbtn,'Enable','on');
      set(out.copybtn,'Enable','on');
      set(out.pastebtn,'Enable','on');
      set(out.selectallbtn,'Enable','on');
   end;
end;

%
% end of main_run_fcn.m
%
