function out_txt = merge_latextable(main_txt,inc_txt,add_txt);

if nargin<3;
   add_txt = '';
end;

if isequal(size(main_txt,1),size(inc_txt,1)+1)==0;
   out_txt = '';
   return;
end;

if strcmp(add_txt,'')==0;
   if isequal(size(inc_txt,1),size(add_txt,1))==0;
      out_txt = '';
      return;
   else;
      %
      % cleanse first row of add_txt and add brackets around other elements
      % of add_txt
      %
      f_add_txt = '';
      for i=1:size(add_txt,1);
         this_txt = vecstr(strtrim(strrep(add_txt(i,:),'\rm ','\rm_')));
         f_addtxt = ' ';
         for j=2:size(this_txt,1)-1;
            if strcmp(strtrim(this_txt(j,:)),'&')==0;
               fj_addtxt = ['[' strtrim(this_txt(j,:)) ']'];
               f_addtxt = [f_addtxt '& ' fj_addtxt];
            end;
         end;
         f_addtxt = [f_addtxt ' \\'];
         f_add_txt = strvcat(f_add_txt,strrep(f_addtxt,'\rm_','\rm '));
      end;
   end;
end;

out_txt = main_txt(1,:);
%
% cleanse first row of inc_txt and add parenthesis around other elements
% of inc_txt
%

f_inc_txt = '';
for i=1:size(inc_txt,1);
   this_txt = vecstr(strtrim(strrep(inc_txt(i,:),'\rm ','\rm_')));
   f_inctxt = ' ';
   for j=2:size(this_txt,1)-1;
      if strcmp(strtrim(this_txt(j,:)),'&')==0;
         fj_inctxt = ['(' strtrim(this_txt(j,:)) ')'];
         f_inctxt = [f_inctxt '& ' fj_inctxt];
      end;
   end;
   f_inctxt = [f_inctxt ' \\'];
   f_inc_txt = strvcat(f_inc_txt,strrep(f_inctxt,'\rm_','\rm '));
end;

%
% merge the two string matrices
%

if strcmp(add_txt,'')==0;
   for i=1:size(f_inc_txt,1);
      out_txt = strvcat(out_txt,strtrim(main_txt(i+1,:)),strtrim(f_inc_txt(i,:)),strtrim(f_add_txt(i,:)));
   end;
else;
   for i=1:size(f_inc_txt,1);
      out_txt = strvcat(out_txt,strtrim(main_txt(i+1,:)),strtrim(f_inc_txt(i,:)));
   end;
end;

%
% end of merge_latextable.m
%
