function [nyblomT,nyblomcorr,evaluet,tT_out,e_parm] = nyblom_restbeta_fcn(tm,curr_ini,cointbeta,Z0,Z1,Z2,T,r,real_T)

M_02 = (1/T)*Z0*Z2';
M_12 = (1/T)*Z1*Z2';
M_22 = (1/T)*Z2*Z2';
dfalpha_t = 0;
if isempty(Z2)==0;
   R0_T = Z0-((M_02/M_22)*Z2);
   R1_T = Z1-((M_12/M_22)*Z2);
else;
   R0_T = Z0;
   R1_T = Z1;
end;
T1 = round(real_T*curr_ini.T0);
if T1<=tm.n+tm.q1+tm.dcoint+size(Z2,1);
   T1 = tm.n+tm.q1+tm.dcoint+size(Z2,1)+1;
end;
if curr_ini.taylor_nyblom==1;
   if T1<=tm.n+tm.q1+tm.dcoint+size(Z2,1)+4;
      T1 = tm.n+tm.q1+tm.dcoint+size(Z2,1)+5;
   end;
end;
%
tT = ones(1,T-T1+1);
if T1<=T;
   t = T;
   if tm.restrict(1,1)==1;
      file = strcat(tm.modelsdir,'G-',int2str(tm.n),'x',int2str(r),'-',tm.modelfile,'.rest');
      G = loaddata(file);
      [Rmat,rvec] = rmatrix(G,tm.n,r);
      dfalpha_t = size(G,1);
      if isempty(Z2)==0;
         if curr_ini.fullrec==0;
            Rmat = [zeros(dfalpha_t,size(Z2,1)*tm.n) Rmat];
            g2 = size(Z2,1)+r;
         else;
            g2 = r;
         end;
      else;
         g2 = r;
      end;
   end;
   while t>=T1;
      %
      % Estimate unrestricted beta for period t
      %
      if curr_ini.fullrec==1;
         R0_t = R0_T(:,1:t);
         R1_t = R1_T(:,1:t);
         [S00_t,S01_t,S10_t,S11_t,beta_t] = recbeta(R0_t,R1_t,r);
      else;
         if tm.d>0;
            [Z2t,dfix] = fixdet(Z1(:,1:t),Z2(:,1:t),tm.d,tm.dcoint);
         else;
            dfix = 0;
            if isempty(Z2)==0;
               Z2t = Z2(:,1:t);
            else;
               Z2t = [];
            end;
         end;
         [S00_t,S01_t,S10_t,S11_t,M02_t,M22_t,M12_t,beta_t,lambda_t,trace_t] = mlcointbasic(Z0(:,1:t),Z1(:,1:t),Z2t,r);
      end;
      unOmega_t = S00_t-S01_t*(beta_t/(beta_t'*S11_t*beta_t))*beta_t'*S10_t;
      %
      % subperiod estimates of restricted alpha and beta
      %
      if (t==T)|(curr_ini.taylor_nyblom==1);
         %
         % Estimate restricted beta for period t
         %
         if curr_ini.fullrec==1;
            [betar_t,dfbeta_t,stdbeta_t] = recbetar(S00_t,S11_t,S01_t,S10_t,beta_t,t,tm.modelsdir,tm.modelfile,tm.dcoint);
         else;
            [betar_t,newlambda_t,dfbeta_t,stdbeta_t,outputtxt_t,abort_t] = betarestrict(S00_t,S11_t,S01_t,S10_t,beta_t,T,tm.modelsdir,tm.modelfile,0,tm.dcoint);
         end;
         dfc = round((((tm.n+tm.q1+tm.dcoint-r)*r)-dfbeta_t)/tm.n);
         np = tm.n*(tm.p-1)+r+tm.q1*tm.p+tm.q0*(tm.p+1)+tm.d+dfc-round(dfalpha_t/tm.n);
         %
         % Estimate restricted Omega for period t
         %
         resOmega_t = S00_t-S01_t*(betar_t/(betar_t'*S11_t*betar_t))*betar_t'*S10_t;
         rOmega_alpha_t = resOmega_t;
         %
         % estimate alpha for period t if so indicated
         %
         if tm.restrict(1,1)==0;
            alpha_t = S01_t*betar_t/(betar_t'*S11_t*betar_t);
            Sigma_alpha_t = (1/t)*kron(eye(r)/(betar_t'*S11_t*betar_t),resOmega_t);
            if curr_ini.fullrec==1;
               if t==T;
                  if isempty(Z2)==0;
                     Z3t = [Z2;betar_t'*Z1];
                     Psi_t = (M_02/M_22)-(alpha_t*betar_t'*(M_12/M_22));
                  else;
                     Z3t = betar_t'*Z1;
                     Psi_t = [];
                  end;
               end;
            else;
               if isempty(Z2)==0;
                  Z3t = [Z2t;betar_t'*Z1(:,1:t)];
                  Psi_t = (M02_t/M22_t)-(alpha_t*betar_t'*(M12_t/M22_t));
               else;
                  Z3t = betar_t'*Z1(:,1:t);
                  Psi_t = [];
               end;
            end;
            %
            if t==T;
               eps_t = Z0-[Psi_t alpha_t]*Z3t;
               Omega_t = (1/T)*eps_t*eps_t';
            end;
            %
            if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
               if t==T;
                  file = strcat(tm.modelsdir,'C-',int2str(tm.n),'x',int2str(r),'-',tm.modelfile,'.rest');
                  G = loaddata(file);
                  [Rmat_C,rvec_C] = rmatrix(G,tm.n,tm.n);
               end;
               %
               if tm.d>0;
                  x = Z2(1:tm.d,1:t)';
                  if tm.dcoint==1;
                     x_ = Z1(size(Z1,1),1:t)';
                  else;
                     x_ = [];
                  end;
                  [delvar,keepvar] = getdelvars(x,x_);
                  x = checkdeter(x,x_);
                  Z2t = [x';Z2(tm.d+1:size(Z2,1),1:t)];
                  my_d = size(x',1);
               else;
                  if isempty(Z2)==0;
                     Z2t = Z2(:,1:t);
                  else;
                     Z2t = [];
                  end;
                  my_d = 0;
               end;
               thetar_t = [Psi_t alpha_t];
               [thetar_t,Sigma_theta,betar_t,stdbeta_t,C,Sigma_C,num_c_rest,num_a_rest,infomat,dabort] = c_restrict(Z0(:,1:t),Z1(:,1:t),Z2t,tm.restrict,betar_t,thetar_t,Rmat_C,rvec_C,tm.p,tm.pe,my_d,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,0);
               g = size(thetar_t,2);
               alpha_t = thetar_t(:,g-r+1:g);
               if g>r;
                  Psi_t = thetar_t(:,1:g-r);
               else;
                  Psi_t = [];
               end;
               if t==T;
                  %
                  % we also need to determine Omega_t and eps_t
                  %
                  if g>r;
                     eps_t = Z0-(thetar_t*[Z2t;betar_t'*Z1]);
                  else;
                     eps_t = Z0-(thetar_t*betar_t'*Z1);
                  end;
                  Omega_t = (1/T)*eps_t*eps_t';
               end;
               Sigma_alpha_t = Sigma_theta(tm.n*(g-r)+1:tm.n*g,tm.n*(g-r)+1:tm.n*g);
            end;
         else;
            if curr_ini.fullrec==1;
               if t==T;
                  theta_t = get(cointbeta.estalpha,'UserData');
                  g = size(theta_t,2);
                  if g>r;
                     Rmat_t = [zeros(size(Rmat,1),tm.n*(g-r)) Rmat];
                     Z3t = [Z2;betar_t'*Z1];
                  else;
                     Rmat_t = Rmat;
                     Z3t = betar_t'*Z1;
                  end;
                  if curr_ini.reestbeta==0;
                     [thetar_t,Sigma_theta,infomat,abort] = linrest(Z0,Z3t,theta_t,Rmat_t,rvec,0,1);
                  else;
                     [thetar_t,Sigma_theta,betar_t,stdbeta_t,Z3t,infomat,abort] = alpha_beta_restrict(Z0,Z1,Z2,Z3t,betar_t,theta_t,Rmat_t,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,0);
                  end;
                  %
                  % re-estimate everything conditional on C restrictions
                  %
                  if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
                     file = strcat(tm.modelsdir,'C-',int2str(tm.n),'x',int2str(r),'-',tm.modelfile,'.rest');
                     G = loaddata(file);
                     [Rmat_C,rvec_C] = rmatrix(G,tm.n,tm.n);
                     [thetar_t,Sigma_theta,betar_t,stdbeta_t,C,Sigma_C,num_c_rest,num_a_rest,infomat,dabort] = c_restrict(Z0,Z1,Z2,tm.restrict,betar_t,thetar_t,Rmat_C,rvec_C,tm.p,tm.pe,tm.d,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,0);
                  end;
                  %
                  alpha_t = thetar_t(:,g-r+1:g);
                  if g>r;
                     Psi_t = thetar_t(:,1:g-r);
                  else;
                     Psi_t = [];
                  end;
                  %
                  Sigma_alpha_t = Sigma_theta(tm.n*(g-r)+1:tm.n*g,tm.n*(g-r)+1:tm.n*g);
                  eps_t = Z0(:,1:t)-thetar_t*Z3t;
                  Omega_t = (1/T)*eps_t*eps_t';
               else;
                  alpha_t = S01_t*betar_t/(betar_t'*S11_t*betar_t);
                  [alpha_t,Sigma_alpha_t,infomat,abort] = linrest(R0_t,betar_t'*R1_t,alpha_t,Rmat,rvec,0,1);
                  if curr_ini.reestbeta==1;
                     [alpha_t,Sigma_alpha_t,betar_t,stdbeta_t,R0_t,R1_t] = rec_alpha_beta_restrict(R0_t,R1_t,betar_t,alpha_t,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,Sigma_alpha_t);
                  end;
                  %
                  if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
                     if tm.d>0;
                        x = Z2(1:tm.d,1:t)';
                        if tm.dcoint==1;
                           x_ = Z1(size(Z1,1),1:t)';
                        else;
                           x_ = [];
                        end;
                        [delvar,keepvar] = getdelvars(x,x_);
                        x = checkdeter(x,x_);
                        Z2t = [x';Z2(tm.d+1:size(Z2,1),1:t)];
                        my_d = size(x',1);
                     else;
                        if isempty(Z2)==0;
                           Z2t = Z2(:,1:t);
                        else;
                           Z2t = [];
                        end;
                        my_d = 0;
                     end;
                     [thetar_t,Sigma_theta,betar_t,stdbeta_t,C,Sigma_C,num_c_rest,num_a_rest,infomat,dabort] = c_restrict(Z0(:,1:t),Z1(:,1:t),Z2t,tm.restrict,betar_t,[Psi_t alpha_t],Rmat_C,rvec_C,tm.p,tm.pe,my_d,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,0);
                     alpha_t = thetar_t(:,g-r+1:g);
                  end;
                  %
                  eps_t = R0_t-(alpha_t*betar_t'*R1_t);
               end;
            else;
               alpha_t = S01_t*betar_t/(betar_t'*S11_t*betar_t);
               if isempty(Z2)==0;
                  Z3t = [Z2t;betar_t'*Z1(:,1:t)];
                  Psi_t = (M02_t/M22_t)-(alpha_t*betar_t'*(M12_t/M22_t));
               else;
                  Z3t = betar_t'*Z1(:,1:t);
                  Psi_t = [];
               end;
               theta_t = [Psi_t alpha_t];
               if curr_ini.reestbeta==0;
                  [thetar_t,Sigma_theta,infomat,abort] = linrest(Z0(:,1:t),Z3t,theta_t,Rmat,rvec,0,1);
               else;
                  [thetar_t,Sigma_theta,betar_t,stdbeta_t,Z3t,infomat,abort] = alpha_beta_restrict(Z0(:,1:t),Z1(:,1:t),Z2t,Z3t,betar_t,theta_t,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,0);
               end;
               %
               if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
                  if tm.d>0;
                     x = Z2(1:tm.d,1:t)';
                     if tm.dcoint==1;
                        x_ = Z1(size(Z1,1),1:t)';
                     else;
                        x_ = [];
                     end;
                     [delvar,keepvar] = getdelvars(x,x_);
                     x = checkdeter(x,x_);
                     Z2t = [x';Z2(tm.d+1:size(Z2,1),1:t)];
                     my_d = size(x',1);
                  else;
                     if isempty(Z2)==0;
                        Z2t = Z2(:,1:t);
                     else;
                        Z2t = [];
                     end;
                     my_d = 0;
                  end;
                  if t==T;
                     file = strcat(tm.modelsdir,'C-',int2str(tm.n),'x',int2str(r),'-',tm.modelfile,'.rest');
                     G = loaddata(file);
                     [Rmat_C,rvec_C] = rmatrix(G,tm.n,tm.n);
                  end;
                  [thetar_t,Sigma_theta,betar_t,stdbeta_t,C,Sigma_C,num_c_rest,num_a_rest,infomat,dabort] = c_restrict(Z0(:,1:t),Z1(:,1:t),Z2t,tm.restrict,betar_t,thetar_t,Rmat_C,rvec_C,tm.p,tm.pe,my_d,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,0);
               end;
               %
               alpha_t = thetar_t(:,g2-r+1:g2);
               if g2>r;
                  Psi_t = thetar_t(:,1:g2-r);
               end;
               Sigma_alpha_t = Sigma_theta(tm.n*(g2-r)+1:tm.n*g2,tm.n*(g2-r)+1:tm.n*g2);
               eps_t = Z0(:,1:t)-thetar_t*Z3t;
               if t==T;
                  Omega_t = (1/T)*eps_t*eps_t';
               end;
            end;
            rOmega_alpha_t = (1/t)*eps_t*eps_t';
         end;
      end;
      %
      % material for Nyblom test
      %
      if curr_ini.nyblom==1;
         if t==T;
            if curr_ini.taylor_nyblom==1;
               betatT = betar_t;
               fix_beta = chol(betar_t'*S11_t*betar_t)';
               betatT = betar_t/fix_beta';
               if tm.restrict(1,1)==0;
                  alpha_cT = S01_t*betatT/(betatT'*S11_t*betatT);
               else;
                  alpha_cT = alpha_t*fix_beta;
               end;
               beta_orth = null(betatT(1:tm.n,1:r)');
               qp = size(betatT,1)-tm.n;
               if size(betatT,1)==tm.n;
                  c = betatT;
                  c_orth = beta_orth;
               else;
                  c = betatT(1:tm.n,:);
                  c_orth = beta_orth(1:tm.n,:);
                  c = [c;zeros(qp,r)];
                  c_orth = [[c_orth zeros(tm.n,qp)];[zeros(qp,tm.n-r) eye(qp)]];
               end;
               c_bar = c/(c'*c);
               c_bar_orth = c_orth*inverse(c_orth'*c_orth);
               alpha_cT = alpha_cT*betatT'*c_bar;
   %                        alpha_cT = alpha_t*betatT'*c_bar;
               M_T = (1/T)*c_orth'*S11_t*c_orth;
               V_T = (alpha_cT'/rOmega_alpha_t)*alpha_cT;
               nyblomT = zeros(1,T-T1+1);
               nyblomcorr = zeros(1,T-T1+1);
            else;
               for i1=1:tm.r;
                  file = strcat(tm.modelsdir,'H_',num2str(i1),'-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.rest');
                  h = loaddata(file);
                  %
                  % need to remove column which corresponds to the normalizing variable
                  %
                  if i1==1;
                     file = strcat(tm.modelsdir,'normalize-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.norm');
                     normfile = loaddata(file);
                  end;
                  %
                  % normalizing h such that row with normalizing variable is a vector with 1 one and zeros elsewhere
                  % and the unit element is found in the first column of the normalized h matrix
                  %
                  normvar = normfile(i1);
                  normmat = h(normvar,:);
                  for j1=1:size(betar_t,1);
                     if size(normmat,1)==size(normmat,2);
                        break;
                     end;
                     if isequal(j1,normvar)==0;
                        checkmat = [normmat;h(j1,:)];
                        if rank(checkmat*checkmat')==size(checkmat,1);
                           normmat = [normmat;h(j1,:)];
                        end;
                     end;
                  end;
                  h = h*inverse(normmat);
                  %
                  % removing first column of h
                  %
                  h = h(:,2:size(h,2));
                  %
                  if i1==1;
                     bH = h;
                  else;
                     bH = [[bH zeros(size(bH,1),size(h,2))];[zeros(size(h,1),size(bH,2)) h]];
                  end;
               end;
               J_T = bH'*kron(alpha_t'*inverse(rOmega_alpha_t)*alpha_t,S11_t)*bH;
               alpha_T = alpha_t;
               Omega_T = rOmega_alpha_t;
               beta_T = betar_t;
               nyblomT = zeros(1,T-T1+1);
               nyblomcorr = zeros(1,T-T1+1);
            end;
         else;
            if curr_ini.taylor_nyblom==1;
               betatt = betar_t;
               fix_beta = chol(betar_t'*S11_t*betar_t)';
               betatt = betar_t/fix_beta';
               nyblomT(1,t-T1+1) = nyblombeta(betatt,betatT,S11_t,c_bar,c_orth,c_bar_orth,M_T,V_T,t,T);
               nyblomcorr(1,t-T1+1) = ((T-np)/T)*nyblomT(1,t-T1+1);
            else;
               S_t = (vec(alpha_T))'*kron(eye(tm.r),inverse(Omega_T)*(S01_t-alpha_T*beta_T'*S11_t))*bH;
               Q_t = (t/T)*(t/T)*T*S_t*inverse(J_T)*S_t';
               nyblomT(1,t-T1+1) = Q_t;
               nyblomcorr(1,t-T1+1) = ((T-np)/T)*Q_t;
            end;
         end;
      end;
      %
      % Compute largest non-zero eigenvalue
      %
      if (curr_ini.topeig==1)|(nargout>2);
         eigen_t = companionrest(alpha_t,Psi_t,betar_t,tm.p,tm.n,tm.d);
         eigen_t = abs(sort(eigen_t));
         i = size(eigen_t,1);
         while i>=1;
            evalue_t = eigen_t(i,1);
            if strcmp(num2str(evalue_t,'%1.10f'),'1.0000000000')==1;
               i = i-1;
            else;
               i = 0;
            end;
         end;
         if t==T;
            evaluet = [zeros(1,T-T1) evalue_t];
         else;
            evaluet(1,t-T1+1) = evalue_t;
         end;
      end;
      if (t==T)&(nargout==5);
         e_parm.alpha = alpha_t;
         e_parm.beta = betar_t;
         e_parm.Psi = Psi_t;
         e_parm.Omega = Omega_t;
         e_parm.epsilon = eps_t;
      end;
      %
      if t<T;
         tT(1,t-T1+1) = t/T;
      end;
      t = t-1;
   end;
end;

if nargout==4;
   tT_out = tT;
end;

%
% end of nyblom_restbeta_fcn.m
%
