function table = nyblom_table(n,r,test_type,deter_type)

%
% test_type = max or mean (string)
% deter_type = 1x4 0-1 vector with only one unit element
%

table = [];
if ispc==1;
   file = [pwd '\mat\nyblom.mat'];
elseif isunix==1;
   file = [pwd '/mat/nyblom.mat'];
else;
   return;
end;

a = load(file);
if deter_type==[1 0 0 0];
   %
   % unrestricted constant
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_uc'];
elseif deter_type==[0 1 0 0];
   %
   % restricted constant
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_rc'];
elseif deter_type==[0 0 1 0];
   %
   % constant+linear trend
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_ut'];
elseif deter_type==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_rt'];
end;

if isfield(a,table_name)==1;
   table = getfield(a,table_name);
else;
   return;
end;

table = table(:,r);

%
% end of nyblom_table.m
%
