function print_commoncycles(tm,curr_ini,alpha,Psi,beta)

%
% compute the results
%
[test,deg_free,pval,infomat,abort,Sigma_theta,Psi_n,alpha_n,Sigma_xi_orth,xi_orth,beta,stdbeta] = estimate_common_cycles(tm.Z0,tm.Z1,tm.Z2,tm.epsilon,alpha,Psi,beta,tm.p,tm.pe,tm.q1,tm.q0,tm.dcoint,tm.d,tm.df,tm.modelsdir,tm.modelfile,tm.restrict,curr_ini.convcrit,curr_ini.maxit,curr_ini.reestbeta,curr_ini.sscorrect,tm.n-1,tm.r,0);
%
% open the output file
%
fout = fopen(tm.outputfile,'at');
%
% check the output format
%
if curr_ini.texoutputformat>=2;
   add_str = '';
   if tm.p>2;
      add_str = [' \hspace*{1mm} \cdots \hspace*{1mm} \Gamma_{' num2str(tm.p-1,'%0.0f') '}'];
   end;
   fprintf(fout,['\\subsection*{Testing for Common Cycles} \n\n\\header{For $r$=' num2str(tm.r) '}\n\n']);
   fprintf(fout,'\\header{LR-type test statistic}\n\n');
   fprintf(fout,'\\begin{tabular}{llll}\n');
   fprintf(fout,'$H_0$: & \\multicolumn{3}{l}{$[\\Gamma_1%s \\hspace*{2mm} \\alpha ]$ has at most rank $k$} \\\\\n',add_str);
   fprintf(fout,'$H_A$: & \\multicolumn{3}{l}{$[\\Gamma_1%s \\hspace*{2mm} \\alpha ]$ has rank greater than $k$} \\\\[2mm]\n',add_str);
   fprintf(fout,'\\multicolumn{4}{c}{ } \\\\\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,'$k$ & $LR$ & df & $p$-value \\\\\n');
      for i=1:size(test,1);
         fprintf(fout,['%0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],tm.r+i-1,test(i,1),deg_free(i,1),pval(i,1));
      end;
   else;
      fprintf(fout,'$k$ & $F$ & df & $p$-value \\\\\n');
      for i=1:size(test,1);
         fprintf(fout,['%0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],tm.r+i-1,test(i,1),deg_free(i,1),deg_free(i,2),pval(i,1));
      end;
   end;
   fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,['TESTING FOR COMMON CYCLES (for rank=' num2str(tm.r) ') \n\n']);
   fprintf(fout,'  LR-type test statistic\n  ~~~~~~~~~~~~~~~~~~~~~~ \n\n');
   fprintf(fout,'Null Hypothesis:        There are at most k common cycles \n');
   fprintf(fout,'Alternative Hypothesis: There are more than k common cycles \n\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,'  k       LR      df      p-value \n');
      prt_str = [' %2.0f   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f       %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'];
      for i=1:size(test,1);
         fprintf(fout,prt_str,tm.r+i-1,test(i,1),deg_free(i,1),pval(i,1));
      end;
   else;
      fprintf(fout,'  k       F         df         p-value \n');
      prt_str = [' %2.0f   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%3.0f,%3.0f)       %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'];
      for i=1:size(test,1);
         fprintf(fout,prt_str,tm.r+i-1,test(i,1),deg_free(i,1),deg_free(i,2),pval(i,1));
      end;
   end;
   fprintf(fout,'\n===============================================================================\n\n');
end;
%
fclose(fout);

%
% end of print_commoncycles.m
%
