function print_lstr1test(tm,curr_ini,epsilon,Zb,my_df)

fout = fopen(tm.outputfile,'at');
print_flag = 0;
%
[lmvec,fvec,dfmat,nrvec,nof,warn] = lstr1(epsilon,tm.Z2,Zb,tm.p,tm.d,tm.T-my_df,tm.trendplace);
if nrvec(1,1)>0;
   print_flag = 1;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for deterministic\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(1,1)) ' deg. freedom:}\n\n']);
      fprintf(fout,'\\begin{tabular}{rrr}\n');
      fprintf(fout,'Equation & Test & $p$-value \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i,1),lmvec(i,3));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if dfmat(1,3)>dfmat(1,2);
         fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for deterministic\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(1,2)) ',' num2str(dfmat(1,3)) ') deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i,1),fvec(i,3));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
      end;
      if nof(1,1)==0;
         fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for deterministic\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(1,4)) ' deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i,2),lmvec(i,4));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
         if dfmat(1,6)>dfmat(1,5);
            fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for deterministic\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(1,5)) ',' num2str(dfmat(1,6)) ') deg. freedom:}\n\n']);
            fprintf(fout,'\\begin{tabular}{rrr}\n');
            fprintf(fout,'Equation & Test & $p$-value \\\\\n');
            for i=1:tm.n;
               fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i,2),fvec(i,4));
            end;
            fprintf(fout,'\\end{tabular}\n\n');
         end;
      end;
      if warn>0;
         fprintf(fout,['\\vspace*{2mm}\\noindent\n\\textbf{NOTE:} ' num2str(warn) ' deterministic variables were removed for these tests.\n\n']);
      end;
   else;
      fprintf(fout,'LM-tests for parameter constancy against LSTR1 model for deterministic\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(1,1)) ' deg. freedom:\n']);
      fprintf(fout,'\nEquation       Test       p-value\n\n');
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i,1),lmvec(i,3));
      end;
      if dfmat(1,3)>dfmat(1,2);
         fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for deterministic\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(1,2)) ',' num2str(dfmat(1,3)) ') deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i,1),fvec(i,3));
         end;
      end;
      if nof(1,1)==0;
         fprintf(fout,'\nLM-tests for parameter constancy against LSTR1 model for deterministic\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(1,4)) ' deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i,2),lmvec(i,4));
         end;
         if dfmat(1,6)>dfmat(1,5);
            fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for deterministic\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(1,5)) ',' num2str(dfmat(1,6)) ') deg. freedom:\n']);
            fprintf(fout,'\nEquation       Test       p-value\n\n');
            for i=1:tm.n;
               fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i,2),fvec(i,4));
            end;
         end;
      end;
      if warn>0;
         fprintf(fout,['\nNOTE: ' num2str(warn) ' deterministic variables were removed for these tests.\n']);
      end;
      fprintf(fout,'\n');
   end;
end;
if nrvec(1,2)>0;
   if curr_ini.texoutputformat>=2;
      if print_flag==1;
         fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   else;
      if print_flag==1;
         fprintf(fout,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   end;
   print_flag = 1;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:}\n\n']);
      fprintf(fout,'\\begin{tabular}{rrr}\n');
      fprintf(fout,'Equation & Test & $p$-value \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
      end;
      if nof(1,2)==0;
         fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:}\n\n']);
            fprintf(fout,'\\begin{tabular}{rrr}\n');
            fprintf(fout,'Equation & Test & $p$-value \\\\\n');
            for i=1:tm.n;
               fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
            fprintf(fout,'\\end{tabular}\n\n');
         end;
      end;
   else;
      fprintf(fout,'LM-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:\n']);
      fprintf(fout,'\nEquation       Test       p-value\n\n');
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
      end;
      if nof(1,2)==0;
         fprintf(fout,'\nLM-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for lagged endogenous\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:\n']);
            fprintf(fout,'\nEquation       Test       p-value\n\n');
            for i=1:tm.n;
               fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
         end;
      end;
      fprintf(fout,'\n');
   end;
end;
if nrvec(1,3)>0;
   if curr_ini.texoutputformat>=2;
      if print_flag==1;
         fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   else;
      if print_flag==1;
         fprintf(fout,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   end;
   print_flag = 1;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   if nrvec(1,2)>0;
      nr = nr+tm.n;
   end;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for exogenous\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:}\n\n']);
      fprintf(fout,'\\begin{tabular}{rrr}\n');
      fprintf(fout,'Equation & Test & $p$-value \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for exogenous\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
      end;
      if nof(1,3)==0;
         fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for exogenous\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for exogenous\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:}\n\n']);
            fprintf(fout,'\\begin{tabular}{rrr}\n');
            fprintf(fout,'Equation & Test & $p$-value \\\\\n');
            for i=1:tm.n;
               fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
            fprintf(fout,'\\end{tabular}\n\n');
         end;
      end;
   else;
      fprintf(fout,'LM-tests for parameter constancy against LSTR1 model for exogenous\n');
      fprintf(fout,['variables (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:\n']);
      fprintf(fout,'\nEquation       Test       p-value\n\n');
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for exogenous\n');
         fprintf(fout,['variables (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
      end;
      if nof(1,3)==0;
         fprintf(fout,'\nLM-tests for parameter constancy against LSTR1 model for exogenous\n');
         fprintf(fout,['variables (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for exogenous\n');
            fprintf(fout,['variables (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:\n']);
            fprintf(fout,'\nEquation       Test       p-value\n\n');
            for i=1:tm.n;
               fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
         end;
      end;
      fprintf(fout,'\n');
   end;
end;
if nrvec(1,4)>0;
   if curr_ini.texoutputformat>=2;
      if print_flag==1;
         fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   else;
      if print_flag==1;
         fprintf(fout,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      end;
   end;
   print_flag = 1;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   if nrvec(1,2)>0;
      nr = nr+tm.n;
   end;
   if nrvec(1,3)>0;
      nr = nr+tm.n;
   end;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for cointegration\n');
      fprintf(fout,['relations (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:}\n\n']);
      fprintf(fout,'\\begin{tabular}{rrr}\n');
      fprintf(fout,'Equation & Test & $p$-value \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for cointegration\n');
         fprintf(fout,['relations (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
      end;
      if nof(1,4)==0;
         fprintf(fout,'\\header{LM-tests for parameter constancy against LSTR1 model for cointegration\n');
         fprintf(fout,['relations (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:}\n\n']);
         fprintf(fout,'\\begin{tabular}{rrr}\n');
         fprintf(fout,'Equation & Test & $p$-value \\\\\n');
         for i=1:tm.n;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\\header{F-tests for parameter constancy against LSTR1 model for cointegration\n');
            fprintf(fout,['relations (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:}\n\n']);
            fprintf(fout,'\\begin{tabular}{rrr}\n');
            fprintf(fout,'Equation & Test & $p$-value \\\\\n');
            for i=1:tm.n;
               fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
            fprintf(fout,'\\end{tabular}\n\n');
         end;
      end;
   else;
      fprintf(fout,'LM-tests for parameter constancy against LSTR1 model for cointegration\n');
      fprintf(fout,['relations (1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg. freedom:\n']);
      fprintf(fout,'\nEquation       Test       p-value\n\n');
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,1),lmvec(i+nr,3));
      end;
      if dfmat(nr+1,3)>dfmat(nr+1,2);
         fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for cointegration\n');
         fprintf(fout,['relations (1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ') deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,1),fvec(i+nr,3));
         end;
      end;
      if nof(1,4)==0;
         fprintf(fout,'\nLM-tests for parameter constancy against LSTR1 model for cointegration\n');
         fprintf(fout,['relations (3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg. freedom:\n']);
         fprintf(fout,'\nEquation       Test       p-value\n\n');
         for i=1:tm.n;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],lmvec(i+nr,2),lmvec(i+nr,4));
         end;
         if dfmat(nr+1,6)>dfmat(nr+1,5);
            fprintf(fout,'\nF-tests for parameter constancy against LSTR1 model for cointegration\n');
            fprintf(fout,['relations (3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ') deg. freedom:\n']);
            fprintf(fout,'\nEquation       Test       p-value\n\n');
            for i=1:tm.n;
               fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],fvec(i+nr,2),fvec(i+nr,4));
            end;
            fprintf(fout,'\n');
         end;
      end;
   end;
end;
if curr_ini.texoutputformat>=2;
   if print_flag==1;
      fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
   end;
else;
   if print_flag==1;
      fprintf(fout,'===============================================================================\n\n');
   end;
end;
fclose(fout);

%
% end of print_lstr1test.m
%
