function dO_R = do_r(B,R)

%
% Computes the partial derivatives: dvec(Omega)/vec(R)'
%

n = size(B,1);
Nn = ncommutation(n);
my_I = eye(n);
Rp = R'/(R*R');
Bp = vec(B)*vec(B)';
dO_R = zeros(n*n,n*n*size(R,1));

for i=1:n;
   ei = my_I(:,i);
   part1 = kron(ei',my_I)*Bp;
   part2 = kron(ei',my_I)*Rp;
   dO_R = dO_R+kron(part1,part2);
end;

dO_R = -2*Nn*dO_R;

%
% end of do_r.m
%
