function out = ig2_rnd(s,v)

%
% delivers a draw from the inverted Gamma-2 distribution.
%
% The function is constructed as described on page 317 in
%
%       Bauwens, L., Lubrano, M., and Richard, J.-F. (1999), "Bayesian Inference
%           in Dynamic Econometric Models", Oxford: Oxford University Press.
%

%
% first set the random number generator state
%
randn('state',sum(100*clock));
x = randn(1,v);
x = x*x';
out = s/x;

%
% end of ig2_rnd.m
%