function [Rmat,rvec] = rmatrix(A,n,r)

%
% Preliminaries
%

numelem = size(A,2)/3;

rvec = A(:,size(A,2));
A = A(:,1:size(A,2)-1);

[row col] = size(A);

Rmat = zeros(row,n*r);

%
% First batch of restrictions
%

for i=1:row;
   s1 = A(i,1);
   s2 = A(i,2);
   if ((s1>0)&(s2>0));
      Rmat(i,s1+n*(s2-1)) = 1;
   end;
end;

%
% The second batch of restrictions
%

for i=1:row;
   for j=1:numelem-1;
      s3 = A(i,3*j);
      s1 = A(i,3*j+1);
      s2 = A(i,3*j+2);
      if ((s1>0)&(s2>0));
         if Rmat(i,s1+n*(s2-1))==0;
            Rmat(i,s1+n*(s2-1)) = s3;
         end;
      end;
   end;
end;

%
% end of rmatrix.m
%
