function show_common_cycles(tm,curr_ini,alpha,Psi,beta)

[test,deg_free,pval,infomat,abort,Sigma_theta,Psi_n,alpha_n,Sigma_xi_orth,xi_orth,beta,stdbeta] = estimate_common_cycles(tm.Z0,tm.Z1,tm.Z2,tm.epsilon,alpha,Psi,beta,tm.p,tm.pe,tm.q1,tm.q0,tm.dcoint,tm.d,tm.df,tm.modelsdir,tm.modelfile,tm.restrict,curr_ini.convcrit,curr_ini.maxit,curr_ini.reestbeta,curr_ini.sscorrect,tm.n-1,tm.r,1);
%
prt_val = ['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
sp_str = spacestr(curr_ini.decimals-2);
if strcmp(abort,'cancel')==0;
   %
   % create the output text string
   %
   txt = strvcat(' ',['TESTING FOR COMMON CYCLES (for rank=' num2str(tm.r) ')']);
   numchar = size(txt,2);
   addtxt = '';
   for i=1:numchar;
      addtxt = strcat(addtxt,'=');
   end;
   txt = strvcat(txt,addtxt,' ');
   txt = strvcat(txt,'  LR-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~',' ');
   %
   txt = strvcat(txt,'Null Hypothesis:        There are at most k common cycles');
   txt = strvcat(txt,'Alternative Hypothesis: There are more than k common cycles',' ');
   %
   if curr_ini.sscorrect==0;
      txt = strvcat(txt,['    k        LR  ' sp_str '     df        p-value']);
      for i=1:size(test,1);
         out = sprintf(['   %2.0f     ' prt_val '    %4.0f      ' prt_val],tm.r+i-1,test(i,1),deg_free(i,1),pval(i,1));
         txt = strvcat(txt,out);
      end;
   else;
      txt = strvcat(txt,['    k         F    ' sp_str '   df         p-value']);
      for i=1:size(test,1);
         out = sprintf(['   %2.0f     ' prt_val '   (%2.0f,%3.0f)    ' prt_val],tm.r+i-1,test(i,1),deg_free(i,1),deg_free(i,2),pval(i,1));
         txt = strvcat(txt,out);
      end;
   end;
   %
   txt = strvcat(txt,' ');
   %
   % display the results
   %
   realscrsz = get(0,'ScreenSize');
   textgui(txt,'Common Cycles Restrictions',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
end;
%
% end of show_common_cycles.m
%
