function show_constancytest(fig_handle,beta,tm,curr_ini,ind,aind,rind)

set(fig_handle,'Visible','off');
drawnow;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
if tm.r>0;
   Zb = beta(:,1:tm.r)'*tm.Z1;
else;
   Zb = 0;
   beta = [];
end;
if size(tm.Z1,1)+size(tm.Z2,1)+11<=tm.T;
   %
   % Display wait dialogue
   %
   txt = strvcat(' ','Computing parameter constancy tests. Please hold!',' ');
   mywait = waitdlg(txt,'information');
   waitf = get(mywait,'UserData');
end;
[lmvec,fvec,dfmat,nrvec,nof,warn] = lstr1(tm.epsilon,tm.Z2,Zb,tm.p,tm.d,tm.T-tm.df,tm.trendplace);
context = strvcat(' ',['PARAMETER CONSTANCY TESTS (for' res_str ' rank=' num2str(tm.r) ')']);
numchar = size(context,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
sp_str = spacestr(curr_ini.decimals-2);
prt_val = ['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
context = strvcat(context,addcorr,' ');
if nrvec(1,1)>0;
   context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for deterministic variables',['(1st order Taylor expansion) with ' num2str(dfmat(1,1)) ' deg.'],'freedom:',' ');
   context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
   for i=1:tm.n;
      out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(i,1),lmvec(i,3));
      context = strvcat(context,out);
   end;
   if dfmat(1,3)>dfmat(1,2);
      context = strvcat(context,' ');
      context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for deterministic variables',['(1st order Taylor expansion) with (' num2str(dfmat(1,2)) ',' num2str(dfmat(1,3)) ')'],'deg. freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(i,1),fvec(i,3));
         context = strvcat(context,out);
      end;
   end;
   if nof(1,1)==0;
      context = strvcat(context,' ','LM-tests for parameter constancy against','LSTR1 model for deterministic variables',['(3rd order Taylor expansion) with ' num2str(dfmat(1,4)) ' deg.'],'freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(i,2),lmvec(i,4));
         context = strvcat(context,out);
      end;
      if dfmat(1,6)>dfmat(1,5);
         context = strvcat(context,' ');
         context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for deterministic variables',['(3rd order Taylor expansion) with (' num2str(dfmat(1,5)) ',' num2str(dfmat(1,6)) ')'],'deg. freedom:',' ');
         context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
         for i=1:tm.n;
            out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(i,2),fvec(i,4));
            context = strvcat(context,out);
         end;
      end;
   end;
   if warn>0;
      context = strvcat(context,' ',['NOTE: ' num2str(warn) ' deterministic variables were'],'removed for these tests.');
   end;
   context = strvcat(context,' ');
end;
if nrvec(1,2)>0;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for lagged endogenous variables',['(1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg.'],'freedom:',' ');
   context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
   for i=1:tm.n;
      out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,1),lmvec(nr+i,3));
      context = strvcat(context,out);
   end;
   context = strvcat(context,' ');
   if dfmat(nr+1,3)>dfmat(nr+1,2);
      context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for lagged endogenous variables',['(1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ')'],'deg. freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,1),fvec(nr+i,3));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
   end;
   if nof(1,2)==0;
      context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for lagged endogenous variables',['(3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg.'],'freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,2),lmvec(nr+i,4));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
      if dfmat(nr+1,6)>dfmat(nr+1,5);
         context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for lagged endogenous variables',['(3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ')'],'deg. freedom:',' ');
         context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
         for i=1:tm.n;
            out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,2),fvec(nr+i,4));
            context = strvcat(context,out);
         end;
         context = strvcat(context,' ');
      end;
   end;
end;
if nrvec(1,3)>0;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   if nrvec(1,2)>0;
      nr = nr+tm.n;
   end;
   context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for exogenous variables',['(1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg.'],'freedom:',' ');
   context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
   for i=1:tm.n;
      out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,1),lmvec(nr+i,3));
      context = strvcat(context,out);
   end;
   context = strvcat(context,' ');
   if dfmat(nr+1,3)>dfmat(nr+1,2);
      context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for exogenous variables',['(1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ')'],'deg. freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,1),fvec(nr+i,3));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
   end;
   if nof(1,3)==0;
      context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for exogenous variables',['(3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg.'],'freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,2),lmvec(nr+i,4));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
      if dfmat(nr+1,6)>dfmat(nr+1,5);
         context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for exogenous variables',['(3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ')'],'deg. freedom:',' ');
         context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
         for i=1:tm.n;
            out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,2),fvec(nr+i,4));
            context = strvcat(context,out);
         end;
         context = strvcat(context,' ');
      end;
   end;
end;
if nrvec(1,4)>0;
   nr = 0;
   if nrvec(1,1)>0;
      nr = tm.n;
   end;
   if nrvec(1,2)>0;
      nr = nr+tm.n;
   end;
   if nrvec(1,3)>0;
      nr = nr+tm.n;
   end;
   context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for cointegration relations',['(1st order Taylor expansion) with ' num2str(dfmat(nr+1,1)) ' deg.'],'freedom:',' ');
   context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
   for i=1:tm.n;
      out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,1),lmvec(nr+i,3));
      context = strvcat(context,out);
   end;
   context = strvcat(context,' ');
   if dfmat(nr+1,3)>dfmat(nr+1,2);
      context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for cointegration relations',['(1st order Taylor expansion) with (' num2str(dfmat(nr+1,2)) ',' num2str(dfmat(nr+1,3)) ')'],'deg. freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,1),fvec(nr+i,3));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
   end;
   if nof(1,4)==0;
      context = strvcat(context,'LM-tests for parameter constancy against','LSTR1 model for cointegration relations',['(3rd order Taylor expansion) with ' num2str(dfmat(nr+1,4)) ' deg.'],'freedom:',' ');
      context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
      for i=1:tm.n;
         out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,lmvec(nr+i,2),lmvec(nr+i,4));
         context = strvcat(context,out);
      end;
      context = strvcat(context,' ');
      if dfmat(nr+1,6)>dfmat(nr+1,5);
         context = strvcat(context,'F-tests for parameter constancy against','LSTR1 model for cointegration relations',['(3rd order Taylor expansion) with (' num2str(dfmat(nr+1,5)) ',' num2str(dfmat(nr+1,6)) ')'],'deg. freedom:',' ');
         context = strvcat(context,['Equation      Test ' sp_str '   p-value']);
         for i=1:tm.n;
            out = sprintf([' %s%s ' prt_val '    %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,fvec(nr+i,2),fvec(nr+i,4));
            context = strvcat(context,out);
         end;
         context = strvcat(context,' ');
      end;
   end;
end;
if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
   [my_fmat,lrmat,dff,dflr,fpmat,lrpmat,dstr,abort,chow_ss,chow_bp,df_ss,df_bp,chow_dates,from_to_vec,chow_ss_pval,chow_bp_pval] = chowft(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0,tm.modelfile,tm.modelsdir,aind,1,tm);
else;
   if aind==1;
      [my_fmat,lrmat,dff,dflr,fpmat,lrpmat,dstr,abort,chow_ss,chow_bp,df_ss,df_bp,chow_dates,from_to_vec,chow_ss_pval,chow_bp_pval] = chowft(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0,tm.modelfile,tm.modelsdir,1);
   else;
      [my_fmat,lrmat,dff,dflr,fpmat,lrpmat,dstr,abort,chow_ss,chow_bp,df_ss,df_bp,chow_dates,from_to_vec,chow_ss_pval,chow_bp_pval] = chowft(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0);
   end;
end;
contextadd = '';
if rind==1;
   if tm.r>0;
      if tm.evalue<1;
         if curr_ini.fluctest==1;
            if curr_ini.fullrec==1;
               if tm.q1==0;
                  [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = reclambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect);
               else;
                  [nyblomT,nyblomcorr] = boot_nyblom_partial(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.T);
                  evaluet = 0;
                  tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
               end;
            else;
               if tm.q1==0;
                  [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = rectlambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect);
               else;
                  [nyblomT,nyblomcorr] = boot_nyblom_full(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.deterselect,tm.T);
                  evaluet = 0;
                  tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
               end;
            end;
            if (isempty(lambdaT)==0)|(isempty(nyblomT)==0);
               datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
               dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
               if (tm.q1+tm.q0==0)&(tm.datad==0);
                  tauT = max(tauT')';
                  pval = 1-ploberger_cdf(tauT,1);
                  contextadd = strvcat('  Hansen-Johansen fluctuation tests','  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~',' ');
                  contextadd = strvcat(contextadd,'Null hypothesis:        eig(i) is constant','Null hypothesis:        eig(i) is not constant',' ');
                  if curr_ini.transeig==1;
                     contextadd = strvcat(contextadd,'Using the statistic:',' ',['    HJ(i,1) = sup_{t=' datet ',...,' dateT '} tau(log[eig(i)/(1-eig(i))]), i=1,...,' num2str(tm.r,'%1.0f')],' ');
                  else;
                     contextadd = strvcat(contextadd,'Using the statistic:',' ',['    HJ(i,1) = sup_{t=' datet ',...,' dateT '} tau(eig(i)), i=1,...,' num2str(tm.r,'%1.0f')],' ');
                  end;
                  contextadd = strvcat(contextadd,['Eigenvalue   HJ(i,1)  ' sp_str ' p-value']);
                  for i=1:tm.r;
                     contextadd = strvcat(contextadd,sprintf(['  %2.0f       %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],i,tauT(i,1),pval(i,1)));
                  end;
                  contextadd = strvcat(contextadd,' ');
                  if min(xistdT)>0;
                     t1 = size(xisumT,2);
                     tauxisumT = xisumT-(xisumT(1,t1)*ones(1,t1));
                     tauxisumT = max(abs(tT.*(tauxisumT./(sqrt(xistdT(1,t1))*ones(1,t1)))));
                     pval = 1-ploberger_cdf(tauxisumT,1);
                     contextadd = strvcat(contextadd,'  Hansen-Johansen fluctuation test for sum of eigenvalues','  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~',' ');
                     contextadd = strvcat(contextadd,['Null hypothesis:        sum(xi;1,...,' num2str(tm.r,'%1.0f') ') is constant']);
                     contextadd = strvcat(contextadd,['Alternative hypothesis: sum(xi;1,...,' num2str(tm.r,'%1.0f') ') is not constant']);
                     contextadd = strvcat(contextadd,' ',['Using the transformation xi=log[eig(i)/(1-eig(i))], i=1,...,' num2str(tm.r,'%1.0f')],' ');
                     contextadd = strvcat(contextadd,['sup_{t=' datet ',...,' dateT '} tau(sum(xi);1) = ' num2str(tauxisumT,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
                     contextadd = strvcat(contextadd,['p-value = ' num2str(pval,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
                  end;
                  if max(evaluet)>=1;
                     [maxevaluet,maxevaluepos] = max(evaluet);
                     datemax = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,maxevaluepos));
                     contextadd = strvcat(contextadd,'WARNING! The largest non-unit eigenvalue of the companion matrix over the');
                     contextadd = strvcat(contextadd,'         recursion period is greater than unity. It''s largest value');
                     contextadd = strvcat(contextadd,['        is ' num2str(maxevaluet,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' at date ' datemax '.'],' ');
                  end;
               else;
                  contextadd = '';
               end;
            end;
         end;
         if ((curr_ini.nyblom==1)&(tm.r<tm.n));
            if curr_ini.fluctest==0;
               if curr_ini.fullrec==1;
                  [nyblomT,nyblomcorr] = boot_nyblom_partial(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.T);
               else;
                  [nyblomT,nyblomcorr] = boot_nyblom_full(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.deterselect,tm.T);
               end;
               evaluet = 0;
               tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
               datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
               dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
               contextadd = '';
            end;
            if isempty(nyblomT)==0;
               meannT = (1/size(nyblomT,2))*sum(nyblomT);
               nyblomT = max(nyblomT);
               contextadd = strvcat(contextadd,'  Nyblom tests for beta','  ~~~~~~~~~~~~~~~~~~~~~',' ');
               contextadd = strvcat(contextadd,'Null hypothesis:        beta is constant','Alternative hypothesis: beta is not constant',' ');
               contextadd = strvcat(contextadd,['sup_{t=' datet ',...,' dateT '} Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(nyblomT(1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
               if tm.nyblom_asymp==1;
                  contextadd = strvcat(contextadd,['p-value = ' num2str(nyblom_pvalues(tm.n,tm.r,nyblomT(1,1),'max',tm.deterselect),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
               end;
               contextadd = strvcat(contextadd,' ');
               contextadd = strvcat(contextadd,['Mean Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(meannT,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
               if tm.nyblom_asymp==1;
                  contextadd = strvcat(contextadd,['p-value = ' num2str(nyblom_pvalues(tm.n,tm.r,meannT,'mean',tm.deterselect),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
               end;
               contextadd = strvcat(contextadd,' ');
               if max(evaluet)>1;
                  if curr_ini.fluctest==0;
                     [maxevaluet,maxevaluepos] = max(evaluet);
                     datemax = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,maxevaluepos));
                     contextadd = strvcat(contextadd,'WARNING! The largest non-unit eigenvalue of the companion matrix over the');
                     contextadd = strvcat(contextadd,'         recursion period is greater than unity. It''s largest value');
                     contextadd = strvcat(contextadd,['        is ' num2str(maxevaluet,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' at date ' datemax '.'],' ');
                  end;
               end;
            end;
         end;
         if isempty(contextadd)==0;
            numchar = size(contextadd,2);
            addcontext = '';
            for i=1:numchar;
               addcontext=strcat(addcontext,'*');
            end;
            contextadd = strvcat(addcontext,' ',contextadd);
         end;
      end;
   end;
%elseif (tm.q1+tm.q0==0)&(rind==0);
elseif rind==0;
   if ((curr_ini.nyblom==1)&(tm.r<tm.n)&(tm.r>0));
      if tm.restrict(1,2)==0;
         if curr_ini.fullrec==1;
            if tm.q1==0;
               [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = reclambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect);
            else;
               [nyblomT,nyblomcorr] = boot_nyblom_partial(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.T);
               evaluet = 0;
               tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
            end;
         else;
            if tm.q1==0;
               [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = rectlambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,tm.df,tm.deterselect);
            else;
               [nyblomT,nyblomcorr] = boot_nyblom_full(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.deterselect,tm.T);
               evaluet = 0;
               tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
            end;
         end;
         datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
         dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
         contextadd = '';
         if isempty(nyblomT)==0;
            meannT = (1/size(nyblomT,2))*sum(nyblomT);
            nyblomT = max(nyblomT);
            contextadd = strvcat(contextadd,'  Nyblom tests for beta','  ~~~~~~~~~~~~~~~~~~~~~',' ');
            contextadd = strvcat(contextadd,'Null hypothesis:        beta is constant','Alternative hypothesis: beta is not constant',' ');
            contextadd = strvcat(contextadd,['sup_{t=' datet ',...,' dateT '} Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(nyblomT(1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
            contextadd = strvcat(contextadd,['Mean Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(meannT,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
            if max(evaluet)>1;
               if curr_ini.fluctest==0;
                  [maxevaluet,maxevaluepos] = max(evaluet);
                  datemax = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,maxevaluepos));
                  contextadd = strvcat(contextadd,'WARNING! The largest non-unit eigenvalue of the companion matrix over the');
                  contextadd = strvcat(contextadd,'         recursion period is greater than unity. It''s largest value');
                  contextadd = strvcat(contextadd,['        is ' num2str(maxevaluet,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' at date ' datemax '.'],' ');
               end;
            end;
         end;
      elseif (tm.restrict(1,2)==1)&(curr_ini.nyblombeta==1);
         status = testident(tm.modelsdir,tm.modelfile,tm.r,tm.n,tm.dcoint,tm.q1);
         if sum(status)==tm.r;
            [nyblomT,nyblomcorr,evaluet,tT] = nyblom_restbeta_fcn(tm,curr_ini,tm.cointbeta,tm.Z0,tm.Z1,tm.Z2,tm.T,tm.r,tm.T);
            meannT = (1/size(nyblomT,2))*sum(nyblomT);
            nyblomT = max(nyblomT);
            datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
            dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
            contextadd = strvcat(contextadd,'  Nyblom tests for beta','  ~~~~~~~~~~~~~~~~~~~~~',' ');
            contextadd = strvcat(contextadd,'Null hypothesis:        beta is constant','Alternative hypothesis: beta is not constant',' ');
            contextadd = strvcat(contextadd,['sup_{t=' datet ',...,' dateT '} Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(nyblomT(1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
            contextadd = strvcat(contextadd,['Mean Q(t|T=' dateT ';endo vars=' num2str(tm.n,'%1.0f') ',rank=' num2str(tm.r,'%1.0f') ') = ' num2str(meannT,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
            if max(evaluet)>1;
               [maxevaluet,maxevaluepos] = max(evaluet);
               datemax = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,maxevaluepos));
               contextadd = strvcat(contextadd,'WARNING! The largest non-unit eigenvalue of the companion matrix over the');
               contextadd = strvcat(contextadd,'         recursion period is greater than unity. It''s largest value');
               contextadd = strvcat(contextadd,['        is ' num2str(maxevaluet,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' at date ' datemax '.'],' ');
            end;
         end;
      end;
      if isempty(contextadd)==0;
         numchar = size(contextadd,2);
         addcontext = '';
         for i=1:numchar;
            addcontext=strcat(addcontext,'*');
         end;
         contextadd = strvcat(addcontext,' ',contextadd);
      end;
   end;
end;
%
if isempty(my_fmat)==0;
   addcontext = '';
   for i=1:numchar;
      addcontext=strcat(addcontext,'*');
   end;
   contextadd = strvcat(contextadd,addcontext,' ');
   contextadd = strvcat(contextadd,'  Chow forecast tests','  ~~~~~~~~~~~~~~~~~~~',' ');
   for i=1:tm.n;
      vari = strrep(tm.myvars(i,:),' ','');
      contextadd = strvcat(contextadd,['Null hypothesis:        Short run coefficients in equation ' vari]);
      contextadd = strvcat(contextadd,'                        are constant for date t relative to date t+1');
      contextadd = strvcat(contextadd,['Alternative hypothesis: Short run coefficients in equation ' vari]);
      contextadd = strvcat(contextadd,'                        are not constant for date t relative to date t+1',' ');
      if curr_ini.sscorrect==0;
         contextadd = strvcat(contextadd,[' t             LR     ' sp_str '  df        p-value']);
         for j=1:size(lrmat,1);
            out = sprintf(['%s      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %2.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],dstr(j,:),lrmat(j,i),dflr(j,:),lrpmat(j,i));
            contextadd = strvcat(contextadd,out);
         end;
      else;
         contextadd = strvcat(contextadd,[' t             F       ' sp_str '    df           p-value']);
         for j=1:size(my_fmat,1);
            out = sprintf(['%s      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      (%2.0f,%3.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],dstr(j,:),my_fmat(j,i),dff(j,1),dff(j,2),fpmat(j,i));
            contextadd = strvcat(contextadd,out);
         end;
      end;
      if i<tm.n;
         addcontext = '';
         numchar = size(contextadd,2);
         for j1=1:numchar;
            addcontext=strcat(addcontext,'~');
         end;
      else;
         addcontext = '';
         numchar = size(contextadd,2);
         for j1=1:numchar;
            addcontext=strcat(addcontext,'*');
         end;
      end;
      contextadd = strvcat(contextadd,' ',addcontext,' ');
   end;
end;
%
if isempty(chow_ss)==0;
   addcontext = '';
   for i=1:numchar;
      addcontext=strcat(addcontext,'*');
   end;
   contextadd = strvcat(contextadd,'  Chow sample-split tests','  ~~~~~~~~~~~~~~~~~~~~~~~',' ');
   contextadd = strvcat(contextadd,'Null hypothesis:        Short run coefficients are constant over the','                        whole sample','Alternative hypothesis: Short run coefficients are not constant with','                        a structural break in period t',' ');
   contextadd = strvcat(contextadd,[' t                 SS   ' sp_str '     df        p-value']);
   for j=1:size(chow_ss,1);
      out = sprintf(['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %3.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f '],chow_dates(j,:),chow_ss(j,1),df_ss(j,1),chow_ss_pval(j,1));
      contextadd = strvcat(contextadd,out);
   end;
   contextadd = strvcat(contextadd,' ',addcontext,' ');
   contextadd = strvcat(contextadd,'  Chow break-point tests','  ~~~~~~~~~~~~~~~~~~~~~~',' ');
   contextadd = strvcat(contextadd,'Null hypothesis:        Short run coefficients are constant over the','                        whole sample','Alternative hypothesis: Short run coefficients are not constant with','                        a structural break in period t',' ');
   contextadd = strvcat(contextadd,[' t                  F    ' sp_str '       df           p-value']);
   for j=1:size(chow_bp,1);
      if isequal(chow_bp(j,1),0)==0;
         out = sprintf(['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      (%3.0f,%3.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f '],chow_dates(j,:),chow_bp(j,1),df_bp(j,1),df_bp(j,2),chow_bp_pval(j,1));
         contextadd = strvcat(contextadd,out);
      end;
   end;
   contextadd = strvcat(contextadd,' ',addcontext,' ');
end;
%
if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
   [smat,k,abort,dstr] = pkktest(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0,tm.modelfile,tm.modelsdir,aind,1,tm.T,1,tm);
else;
   if aind==1;
      [smat,k,abort,dstr] = pkktest(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0,tm.modelfile,tm.modelsdir,1);
   else;
      [smat,k,abort,dstr] = pkktest(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0);
   end;
end;
if isempty(smat)==0;
   [mymaxi mymaxj] = max(smat);
   spmat = 1-ploberger_cdf(mymaxi',k);
   p_str = '';
   if k<10;
      p_str = '  ';
   elseif k<100;
      p_str = ' ';
   end;
   contextadd = strvcat(contextadd,'  Ploberger-Krmer-Kontrus fluctuation test','  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~',' ');
   contextadd = strvcat(contextadd,'Null hypothesis:        Short run coefficients in equation k',['                        are constant for all t in {' strrep(dstr(1,:),' ','') ',...,' getdate(tm.samplebeg,tm.sampleend,tm.freq,1) '}']);
   contextadd = strvcat(contextadd,'Alternative hypothesis: Short run coefficients in equation k','                        are not constant',' ');
   contextadd = strvcat(contextadd,[' k          S(' num2str(k,'%0.0f') ')  ' sp_str p_str ' p-value  ' sp_str ' t']);
   for i=1:tm.n;
      if mymaxj(i)>size(dstr,1);
         thisdate = getdate(tm.samplebeg,tm.sampleend,tm.freq,1);
      else;
         thisdate = dstr(mymaxj(i),:);
      end;
      out = sprintf(['%s       %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f     %s'],tm.myvars(i,:),mymaxi(i),spmat(i),thisdate);
      contextadd = strvcat(contextadd,out);
   end;
   contextadd = strvcat(contextadd,' ');
end;
%
% Appending to LSTR1 model results
%
context = strvcat(context,contextadd);
if size(context,1)==4;
   context = strvcat(' ','There are too few observations to compute any parameter','constancy tests.',' ');
end;
if size(tm.Z1,1)+size(tm.Z2,1)+11<=tm.T;
   %
   % Close wait dialogue
   %
   set(waitf.text,'UserData','done');
   delete(mywait);
   drawnow;
end;
%context = aligntxt(context);
textgui(context,'Parameter Constancy Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');

%
% end of show_constancytest.m
%
