function show_recursivebeta(fig_handle,tm,curr_ini)

realscrsz = get(0,'ScreenSize');
status = testident(tm.modelsdir,tm.modelfile,tm.r,tm.n,tm.dcoint,tm.q1);
if sum(status)==tm.r;
   set(fig_handle,'Visible','off');
   drawnow;
   drawnow;
   plot_handles = [];
   cointbeta = get(fig_handle,'UserData');
   nyblomtest = [];
   if isempty(tm.Z2)==0;
      R0_T = tm.Z0-(tm.M_02*inverse(tm.M_22)*tm.Z2);
      R1_T = tm.Z1-(tm.M_12*inverse(tm.M_22)*tm.Z2);
   else;
      R0_T = tm.Z0;
      R1_T = tm.Z1;
   end;
   T1 = round(tm.T*curr_ini.T0);
   if T1<=tm.n+tm.q1+tm.dcoint+size(tm.Z2,1);
      T1 = tm.n+tm.q1+tm.dcoint+size(tm.Z2,1)+1;
   end;
   if T1<=tm.T;
      t = tm.T;
      if (curr_ini.recalpha==1)|(curr_ini.topeig==1)|(curr_ini.reestbeta==1)|(curr_ini.recpi);
         if tm.restrict(1,1)==1;
            file = strcat(tm.modelsdir,'G-',int2str(tm.n),'x',int2str(tm.r),'-',tm.modelfile,'.rest');
            G = loaddata(file);
            [Rmat,rvec] = rmatrix(G,tm.n,tm.r);
            dfalpha_t = size(G,1);
            Rmat_orig = Rmat;
            if isempty(tm.Z2)==0;
               if curr_ini.fullrec==0;
                  Rmat = [zeros(dfalpha_t,size(tm.Z2,1)*tm.n) Rmat];
                  g2 = size(tm.Z2,1)+tm.r;
               else;
                  g2 = tm.r;
               end;
            else;
               g2 = tm.r;
            end;
         end;
      end;
      cbs_t = tm.cbs/100;
      input_var.title = ['Progress for ' int2str(tm.T-T1+1) ' recursive estimates'];
      input_var.facecolor = curr_ini.progress_facecolor;
      input_var.startfacecolor = curr_ini.progress_startfacecolor;
      input_var.edgecolor = curr_ini.progress_edgecolor;
      input_var.bgcolor = curr_ini.progress_bgcolor;
      input_var.label = 'Recursion number:';
      input_var.stop = 0;
      if (curr_ini.recalpha==1)|(curr_ini.recpi==1);
         input_var.name = 'Recursive Estimation of (Alpha,Beta)';
%         set(mywait,'Name','Recursive Estimation of (Alpha,Beta)');
      else;
         input_var.name = 'Recursive Estimation of Beta';
%         set(mywait,'Name','Recursive Estimation of Beta');
      end;
      mywait = progressdlg(0,input_var);
      set(mywait,'Color',get(0,'defaultuicontrolbackgroundcolor'));
      drawnow;
      while t>=T1;
         abort = get(mywait,'UserData');
         if strcmp(abort,'cancel')==1;
            break;
         else;
            progressdlg([((tm.T-t+1)/(tm.T-T1+1)) (tm.T-t+1)]);
         end;
         %
         % Check if tm.Z1 has redundant rows
         %
         %
         % Estimate unrestricted beta for period t
         %
         if curr_ini.fullrec==1;
            R0_t = R0_T(:,1:t);
            R1_t = R1_T(:,1:t);
            [S00_t,S01_t,S10_t,S11_t,beta_t] = recbeta(R0_t,R1_t,tm.r);
            dfix = tm.d;
         else;
            if tm.d>0;
               [Z2t,dfix] = fixdet(tm.Z1(:,1:t),tm.Z2(:,1:t),tm.d,tm.dcoint);
            else;
               dfix = 0;
               if isempty(tm.Z2)==0;
                  Z2t = tm.Z2(:,1:t);
               else;
                  Z2t = [];
               end;
            end;
            [S00_t,S01_t,S10_t,S11_t,M02_t,M22_t,M12_t,beta_t,lambda_t,trace_t] = mlcointbasic(tm.Z0(:,1:t),tm.Z1(:,1:t),Z2t,tm.r);
         end;
         unOmega_t = S00_t-S01_t*beta_t*inverse(beta_t'*S11_t*beta_t)*beta_t'*S10_t;
         %
         % Estimate restricted beta for period t
         %
         if curr_ini.fullrec==1;
            [betar_t,dfbeta_t,stdbeta_t] = recbetar(S00_t,S11_t,S01_t,S10_t,beta_t,t,tm.modelsdir,tm.modelfile,tm.dcoint);
         else;
            [betar_t,newlambda_t,dfbeta_t,stdbeta_t,outputtxt_t,abort_t] = betarestrict(S00_t,S11_t,S01_t,S10_t,beta_t,tm.T,tm.modelsdir,tm.modelfile,0,tm.dcoint);
         end;
         %
         % Estimate restricted Omega for period t
         %
         resOmega_t = S00_t-S01_t*betar_t*inverse(betar_t'*S11_t*betar_t)*betar_t'*S10_t;
         rOmega_alpha_t = resOmega_t;
         %
         % estimate alpha for period t if so indicated
         %
         if tm.restrict(1,1)==0;
            alpha_t = S01_t*betar_t*inverse(betar_t'*S11_t*betar_t);
            Sigma_alpha_t = (1/t)*kron(inverse(betar_t'*S11_t*betar_t),resOmega_t);
            if curr_ini.topeig==1;
               if curr_ini.fullrec==1;
                  if t==tm.T;
                     if isempty(tm.Z2)==0;
                        Psi_t = tm.M_02*inverse(tm.M_22)-(alpha_t*betar_t'*tm.M_12*inverse(tm.M_22));
                     else;
                        Psi_t = [];
                     end;
                  end;
               else;
                  if isempty(tm.Z2)==0;
                     Z3t = [Z2t;betar_t'*tm.Z1(:,1:t)];
                     Psi_t = M02_t*inverse(M22_t)-(alpha_t*betar_t'*M12_t*inverse(M22_t));
                  else;
                     Z3t = betar_t'*tm.Z1(:,1:t);
                     Psi_t = [];
                  end;
               end;
            end;
         else;
            if curr_ini.fullrec==1;
               if curr_ini.topeig==1;
                  if t==tm.T;
                     theta_t = get(cointbeta.estalpha,'UserData');
                     g = size(theta_t,2);
                     if g>tm.r;
                        Rmat_t = [zeros(size(Rmat,1),tm.n*(g-tm.r)) Rmat];
                        Z3t = [tm.Z2;betar_t'*tm.Z1];
                     else;
                        Rmat_t = Rmat;
                        Z3t = betar_t'*tm.Z1;
                     end;
                     if curr_ini.reestbeta==0;
                        [thetar_t,Sigma_theta,infomat,abort] = linrest(tm.Z0,Z3t,theta_t,Rmat_t,rvec,0,1);
                     else;
                        [thetar_t,Sigma_theta,betar_t,stdbeta_t,Z3t,infomat,abort] = alpha_beta_restrict(tm.Z0,tm.Z1,tm.Z2,Z3t,betar_t,theta_t,Rmat_t,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,0);
                     end;
                     alpha_t = thetar_t(:,g-tm.r+1:g);
                     if g>tm.r;
                        Psi_t = thetar_t(:,1:g-tm.r);
                     else;
                        Psi_t = [];
                     end;
                     Sigma_alpha_t = Sigma_theta(tm.n*(g-tm.r)+1:tm.n*g,tm.n*(g-tm.r)+1:tm.n*g);
                     eps_t = tm.Z0(:,1:t)-thetar_t*Z3t;
                  else;
                     alpha_t = S01_t*betar_t*inverse(betar_t'*S11_t*betar_t);
                     [alpha_t,Sigma_alpha_t,infomat,abort] = linrest(R0_t,betar_t'*R1_t,alpha_t,Rmat,rvec,0,1);
                     if curr_ini.reestbeta==1;
                        [alpha_t,Sigma_alpha_t,betar_t,stdbeta_t,R0_t,R1_t] = rec_alpha_beta_restrict(R0_t,R1_t,betar_t,alpha_t,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,Sigma_alpha_t);
                     end;
                     eps_t = R0_t-(alpha_t*betar_t'*R1_t);
                  end;
               else;
                  alpha_t = S01_t*betar_t*inverse(betar_t'*S11_t*betar_t);
                  [alpha_t,Sigma_alpha_t,infomat,abort] = linrest(R0_t,betar_t'*R1_t,alpha_t,Rmat,rvec,0,1);
                  if curr_ini.reestbeta==1;
                     [alpha_t,Sigma_alpha_t,betar_t,stdbeta_t,R0_t,R1_t] = rec_alpha_beta_restrict(R0_t,R1_t,betar_t,alpha_t,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,Sigma_alpha_t);
                  end;
                  eps_t = R0_t-(alpha_t*betar_t'*R1_t);
               end;
            else;
               alpha_t = S01_t*betar_t*inverse(betar_t'*S11_t*betar_t);
               if isempty(tm.Z2)==0;
                  Z3t = [Z2t;betar_t'*tm.Z1(:,1:t)];
                  Psi_t = M02_t*inverse(M22_t)-(alpha_t*betar_t'*M12_t*inverse(M22_t));
               else;
                  Z3t = betar_t'*tm.Z1(:,1:t);
                  Psi_t = [];
               end;
               theta_t = [Psi_t alpha_t];
               Rmat = [zeros(size(Rmat_orig,1),size(Z2t,1)*tm.n) Rmat_orig];
               if curr_ini.reestbeta==0;
                  [thetar_t,Sigma_theta,infomat,abort] = linrest(tm.Z0(:,1:t),Z3t,theta_t,Rmat,rvec,0,1);
               else;
                  [thetar_t,Sigma_theta,betar_t,stdbeta_t,Z3t,infomat,abort] = alpha_beta_restrict(tm.Z0(:,1:t),tm.Z1(:,1:t),Z2t,Z3t,betar_t,theta_t,Rmat,rvec,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,0);
               end;
               g2 = size(theta_t,2);
               alpha_t = thetar_t(:,g2-tm.r+1:g2);
               if g2>tm.r;
                  Psi_t = thetar_t(:,1:g2-tm.r);
               end;
               Sigma_alpha_t = Sigma_theta(tm.n*(g2-tm.r)+1:tm.n*g2,tm.n*(g2-tm.r)+1:tm.n*g2);
               eps_t = tm.Z0(:,1:t)-thetar_t*Z3t;
            end;
            rOmega_alpha_t = (1/t)*eps_t*eps_t';
         end;
         %
         % material for Nyblom test
         %
%         if (tm.q1+tm.q0)==0;
            if curr_ini.nyblom==1;
               if t==tm.T;
                  if curr_ini.taylor_nyblom==1;
                     betatT = betar_t;
                     fix_beta = chol(betar_t'*S11_t*betar_t)';
                     betatT = betar_t*inverse(fix_beta');
                     if tm.restrict(1,1)==0;
                        alpha_cT = S01_t*betatT*inverse(betatT'*S11_t*betatT);
                     else;
                        alpha_cT = alpha_t*fix_beta;
                     end;
                     beta_orth = null(betatT(1:tm.n,1:tm.r)');
                     if (tm.deterselect(1,1)|tm.deterselect(1,3))==1;
                        c = betatT;
                        c_orth = beta_orth;
                     else;
                        c = betatT(1:tm.n,:);
                        c_orth = beta_orth(1:tm.n,:);
                        c = [c;zeros(1,tm.r)];
                        c_orth = [[c_orth zeros(tm.n,1)];[zeros(1,tm.n-tm.r) 1]];
                     end;
                     c_bar = c*inverse(c'*c);
                     c_bar_orth = c_orth*inverse(c_orth'*c_orth);
                     alpha_cT = alpha_cT*betatT'*c_bar;
   %                        alpha_cT = alpha_t*betatT'*c_bar;
                     M_T = (1/tm.T)*c_orth'*S11_t*c_orth;
                     V_T = alpha_cT'*inverse(rOmega_alpha_t)*alpha_cT;
                     nyblomtest = 0;
                  else;
                     for i1=1:tm.r;
                        file = strcat(tm.modelsdir,'H_',num2str(i1),'-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.rest');
                        h = loaddata(file);
                        %
                        % need to remove column which corresponds to the normalizing variable
                        %
                        if i1==1;
                           file = strcat(tm.modelsdir,'normalize-',num2str(tm.n),'x',num2str(tm.r),'x',num2str(tm.dcoint+tm.q1),'-',tm.modelfile,'.norm');
                           normfile = loaddata(file);
                        end;
                        %
                        % normalizing h such that row with normalizing variable is a vector with 1 one and zeros elsewhere
                        % and the unit element is found in the first column of the normalized h matrix
                        %
                        normvar = normfile(i1);
                        normmat = h(normvar,:);
                        for j1=1:size(betar_t,1);
                           if size(normmat,1)==size(normmat,2);
                              break;
                           end;
                           if isequal(j1,normvar)==0;
                              checkmat = [normmat;h(j1,:)];
                              if rank(checkmat*checkmat')==size(checkmat,1);
                                 normmat = [normmat;h(j1,:)];
                              end;
                           end;
                        end;
                        h = h*inverse(normmat);
                        %
                        % removing first column of h
                        %
                        h = h(:,2:size(h,2));
                        %
                        if i1==1;
                           bH = h;
                        else;
                           bH = [[bH zeros(size(bH,1),size(h,2))];[zeros(size(h,1),size(bH,2)) h]];
                        end;
                     end;
                     J_T = bH'*kron(alpha_t'*inverse(rOmega_alpha_t)*alpha_t,S11_t)*bH;
                     alpha_T = alpha_t;
                     Omega_T = rOmega_alpha_t;
                     beta_T = betar_t;
                     nyblomtest = 0;
                  end;
               else;
                  if curr_ini.taylor_nyblom==1;
                     betatt = betar_t;
                     fix_beta = chol(betar_t'*S11_t*betar_t)';
                     betatt = betar_t*inverse(fix_beta');
                     nyblomtest = [nyblombeta(betatt,betatT,S11_t,c_bar,c_orth,c_bar_orth,M_T,V_T,t,tm.T) nyblomtest];
                  else;
                     S_t = (vec(alpha_T))'*kron(eye(tm.r),inverse(Omega_T)*(S01_t-alpha_T*beta_T'*S11_t))*bH;
                     Q_t = (t/tm.T)*(t/tm.T)*tm.T*S_t*inverse(J_T)*S_t';
                     nyblomtest = [Q_t nyblomtest];
                  end;
               end;
            end;
%         end;
         %
         % Compute largest non-zero eigenvalue
         %
         if curr_ini.topeig==1;
            eigen_t = companionrest(alpha_t,Psi_t,betar_t,tm.p,tm.n,dfix);
            eigen_t = abs(sort(eigen_t));
            i = size(eigen_t,1);
            while i>=1;
               evalue_t = eigen_t(i,1);
               if strcmp(num2str(evalue_t,'%1.10f'),'1.0000000000')==1;
                  i = i-1;
               else;
                  i = 0;
               end;
            end;
         end;
         %
         % Compute recursive tests
         %
         dfc = round((((tm.n+tm.q1+tm.dcoint-tm.r)*tm.r)-dfbeta_t)/tm.n);
         tm.df = tm.n*(tm.p-1)+tm.r+tm.q1*tm.pe+tm.q0*(tm.pe+1)+tm.d+dfc;
         %
         % Compute the LR test of the restrictions if there are any
         % overidentifying such
         %
         if dfbeta_t>0;
            LRbeta_t = t*log(det(resOmega_t)/det(unOmega_t));
            if curr_ini.sscorrect==0;
               critval_t = chisq_inv(cbs_t,dfbeta_t);
            else;
               LRbeta_t = ((t-tm.df)/(t*dfbeta_t))*LRbeta_t;
               critval_t = fdist_inv(cbs_t,dfbeta_t,t-tm.df);
            end;
         else;
            critval_t = [];
            LRbeta_t = [];
         end;
         if (curr_ini.recalpha==1)|(curr_ini.recpi==1);
            if tm.restrict(1,1)==1;
               dfa = tm.df-round(dfalpha_t/tm.n);
               LRalpha_t = t*log(det(rOmega_alpha_t)/det(unOmega_t));
               if curr_ini.sscorrect==0;
                  cvalpha_t = chisq_inv(cbs_t,dfalpha_t+dfbeta_t);
               else;
                  LRalpha_t = ((t-dfa)/(t*(dfalpha_t*dfbeta_t)))*LRalpha_t;
                  cvalpha_t = fdist_inv(cbs_t,dfalpha_t+dfbeta_t,t-dfa);
               end;
               if dfbeta_t>0;
                  LRalphabeta_t = t*log(det(rOmega_alpha_t)/det(resOmega_t));
                  if curr_ini.sscorrect==0;
                     cvalphabeta_t = chisq_inv(cbs_t,dfalpha_t);
                  else;
                     LRalphabeta_t = ((t-dfa)/(t*dfalpha_t))*LRalphabeta_t;
                     cvalphabeta_t = fdist_inv(cbs_t,dfalpha_t,t-dfa);
                  end;
               end;
            end;
         end;
         if t==tm.T;
            betart = vec(betar_t);
            stdbetat = vec(stdbeta_t);
            LRbetat = LRbeta_t;
            critvalt = critval_t;
            if curr_ini.topeig==1;
               evaluet = evalue_t;
            end;
            if (curr_ini.recalpha==1)|(curr_ini.recpi==1);
               alphat = vec(alpha_t);
               stdalphat = sqrt(abs(diag(Sigma_alpha_t)));
               Pi_t = alpha_t*betar_t(1:tm.n,:)';
               pit = vec(Pi_t);
               Sigma_Pi_t = kron(betar_t(1:tm.n,:),eye(tm.n))*Sigma_alpha_t*kron(betar_t(1:tm.n,:),eye(tm.n))';
               stdpit = sqrt(abs(diag(Sigma_Pi_t)));
               if curr_ini.recalpha==1;
                  if tm.restrict(1,1)==1;
                     LRalphat = LRalpha_t;
                     cvalphat = cvalpha_t;
                     if dfbeta_t>0;
                        LRalphabetat = LRalphabeta_t;
                        cvalphabetat = cvalphabeta_t;
                     end;
                  end;
               end;
            end;
         else;
            betart = [vec(betar_t) betart];
            stdbetat = [vec(stdbeta_t) stdbetat];
            LRbetat = [LRbeta_t LRbetat];
            critvalt = [critval_t critvalt];
            if curr_ini.topeig==1;
               evaluet = [evalue_t evaluet];
            end;
            if (curr_ini.recalpha==1)|(curr_ini.recpi==1);
               alphat = [vec(alpha_t) alphat];
               stdalphat = [sqrt(abs(diag(Sigma_alpha_t))) stdalphat];
               Pi_t = alpha_t*betar_t(1:tm.n,:)';
               pit = [vec(Pi_t) pit];
               Sigma_Pi_t = kron(betar_t(1:tm.n,:),eye(tm.n))*Sigma_alpha_t*kron(betar_t(1:tm.n,:),eye(tm.n))';
               stdpit = [sqrt(abs(diag(Sigma_Pi_t))) stdpit];
               if curr_ini.recalpha==1;
                  if tm.restrict(1,1)==1;
                     LRalphat = [LRalpha_t LRalphat];
                     cvalphat = [cvalpha_t cvalphat];
                     if dfbeta_t>0;
                        LRalphabetat = [LRalphabeta_t LRalphabetat];
                        cvalphabetat = [cvalphabeta_t cvalphabetat];
                     end;
                  end;
               end;
            end;
         end;
         t = t-1;
      end;
      set(mywait,'UserData','done');
      close(mywait);
      drawnow;
      set(fig_handle,'Visible','on');
      drawnow;
      drawnow;
      if strcmp(abort,'cancel')==0;
         if curr_ini.colors==1;
            colorstr = 'b';
            colorstr2 = 'r';
            typestr = '-';
         else;
            colorstr = 'k';
            colorstr2 = [0.5 0.5 0.5];
            typestr = '--';
         end;
         %
         % setting up the actual sample period
         %
         dataindex = make_dataindex(tm.freq,tm.samplebeg,tm.sampleend);
         %
         % Creating the plots
         %
         cbsv = cbsval(tm.cbs);
         upper_c = real(betart)+(cbsv*real(stdbetat));
         lower_c = real(betart)-(cbsv*real(stdbetat));
         nq1 = floor(size(betart,1)/tm.r);
         thispos = [(realscrsz(3)-550)/2-22 (realscrsz(4)-360)/2+22];
         stats = [];
         file_names = '';
         for i=1:tm.r;
            for j=1:nq1;
               thisi = j+nq1*(i-1);
               if sum(stdbetat(thisi,:))>0;
                  %
                  % Fixing the positioning of the window if it is outside
                  % the screen. This means add 70 to height in the check
                  % which is the size of the menubar+toolbar and top on
                  % Windoze. Also, the bottom is assumed to be 32 pixels
                  % 
                  thispos = [thispos(1,1)+22 thispos(1,2)-22];
                  if thispos(1,1)>(realscrsz(3)-550);
                     thispos = [0 realscrsz(4)-430];
                  end;
                  if thispos(1,2)>(realscrsz(4)-430);
                     thispos = [0 realscrsz(4)-430];
                  elseif thispos(1,2)<32;
                     thispos = [0 realscrsz(4)-430];
                  end;
                  myplot = figure('Units','pixels', ...
                     'Position',[thispos 550 360], ...
                     'Menubar','none', ...
                     'Toolbar','none', ...
                     'NumberTitle','off', ...
                     'Visible','off', ...
                     'Name',['Recursive beta(' num2str(i) ',' num2str(j) ')']);
                  %
                  % obey centering and filling defaults
                  %
                  setfigureproperties(myplot);
                  %
                  %
                  % Using a patch to display the confidence region
                  %
                  if curr_ini.colors==1;
                     colorstr3 = (1/255)*[255 255 177];
                  else;
                     colorstr3 = [0.6 0.6 0.6];
                  end;
                  my_p = patch([dataindex(T1:tm.T,1)' reverse(dataindex(T1:tm.T,1)')],[upper_c(thisi,:) reverse(lower_c(thisi,:))],colorstr3);
                  set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
                  hold('on');
                  %
                  % create a zero-line if needed
                  %
                  y_lim = [min(lower_c(thisi,:))-0.1 max(upper_c(thisi,:))+0.1];
                  if (y_lim(1,1)<0)&(y_lim(1,2)>0);
                     plot([dataindex(T1,1) dataindex(tm.T,1)],[0 0],'-','LineWidth',1,'Color',[0 0 0]);
                     hold('on');
                  end;
                  %
                  % Setting up the plot
                  %
                  plot(dataindex(T1:tm.T,1),betart(thisi,:)','-','LineWidth',1,'Color',colorstr,'Tag',['est-beta(' num2str(i) num2str(j) ')']);
                  hold('on');
                  set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)],'Layer','top');
                  set(gca,'YLim',y_lim);
                  if curr_ini.fullrec==0;
                     textadd = ' (for updated \delta_{i},\Gamma_{i})';
                  else;
                     textadd = ' (for fixed \delta_{i},\Gamma_{i})';
                  end;
                  setaxesfonts('Title',['Estimated \beta_{' num2str(i) ',' num2str(j) '} with ' num2str(tm.cbs) ' % conditional confidence bands' textadd]);
                  toolbar_fcn(gca);
                  hold('off');
                  if curr_ini.external==0;
                     plot_handles = [plot_handles myplot];
                  else;
                     file = [tm.outputdir 'beta-' num2str(i) '.' num2str(j)];
                     mstat = autosavefigure(myplot,file);
                     stats = [stats mstat];
                     file_names = strvcat(file_names,file);
                  end;
               end;
            end;
         end;
         %
         % providing graphs of recursive alpha
         %
         if curr_ini.recalpha==1;
            uppera = alphat+(cbsv*stdalphat);
            lowera = alphat-(cbsv*stdalphat);
            for i=1:tm.r;
               for j=1:tm.n;
                  thisi = j+tm.n*(i-1);
                  if sum(stdalphat(thisi,:))>0;
                     thispos = [thispos(1,1)+22 thispos(1,2)-22];
                     if thispos(1,1)>(realscrsz(3)-550);
                        thispos = [0 realscrsz(4)-430];
                     end;
                     if thispos(1,2)>(realscrsz(4)-430);
                        thispos = [0 realscrsz(4)-430];
                     elseif thispos(1,2)<32;
                        thispos = [0 realscrsz(4)-430];
                     end;
                     myplot = figure('Units','pixels', ...
                        'Position',[thispos 550 360], ...
                        'Menubar','none', ...
                        'Toolbar','none', ...
                        'NumberTitle','off', ...
                        'Visible','off', ...
                        'Name',['Recursive alpha(' num2str(j) ',' num2str(i) ')']);
                     %
                     % obey centering and filling defaults
                     %
                     setfigureproperties(myplot);
                     %
                     %
                     % Using a patch to display the confidence region
                     %
                     if curr_ini.colors==1;
                        colorstr3 = (1/255)*[255 255 177];
                     else;
                        colorstr3 = [0.6 0.6 0.6];
                     end;
                     my_p = patch([dataindex(T1:tm.T,1)' reverse(dataindex(T1:tm.T,1)')],[uppera(thisi,:) reverse(lowera(thisi,:))],colorstr3);
                     set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
                     hold('on');
                     %
                     % create a zero-line if needed
                     %
                     y_lim = [min(lowera(thisi,:))-0.1 max(uppera(thisi,:))+0.1];
                     if (y_lim(1,1)<0)&(y_lim(1,2)>0);
                        plot([dataindex(T1,1) dataindex(tm.T,1)],[0 0],'-','LineWidth',1,'Color',[0 0 0]);
                        hold('on');
                     end;
                     %
                     % Setting up the plot
                     %
                     plot(dataindex(T1:tm.T,1),alphat(thisi,:)','-','LineWidth',1,'Color',colorstr,'Tag',['est-alpha(' num2str(j) num2str(i) ')']);
                     hold('on');
                     set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)],'Layer','top');
                     set(gca,'YLim',y_lim);
                     if curr_ini.fullrec==0;
                        textadd = ' (for updated \delta_{i},\Gamma_{i})';
                     else;
                        textadd = ' (for fixed \delta_{i},\Gamma_{i})';
                     end;
                     setaxesfonts('Title',['Estimated \alpha_{' num2str(j) ',' num2str(i) '} with ' num2str(tm.cbs) ' % confidence bands' textadd]);
                     toolbar_fcn(gca);
                     hold('off');
                     if curr_ini.external==0;
                        plot_handles = [plot_handles myplot];
                     else;
                        file = [tm.outputdir 'alpha-' num2str(j) '.' num2str(i)];
                        mstat = autosavefigure(myplot,file);
                        stats = [stats mstat];
                        file_names = strvcat(file_names,file);
                     end;
                  end;
               end;
            end;
         end;
         %
         % graph the Pi parameters
         %
         if curr_ini.recpi==1;
            upperpi = pit+(cbsv*stdpit);
            lowerpi = pit-(cbsv*stdpit);
            for i=1:tm.n;
               for j=1:tm.n;
                  thisi = j+tm.n*(i-1);
                  if sum(stdpit(thisi,:))>0;
                     thispos = [thispos(1,1)+22 thispos(1,2)-22];
                     if thispos(1,1)>(realscrsz(3)-550);
                        thispos = [0 realscrsz(4)-430];
                     end;
                     if thispos(1,2)>(realscrsz(4)-430);
                        thispos = [0 realscrsz(4)-430];
                     elseif thispos(1,2)<32;
                        thispos = [0 realscrsz(4)-430];
                     end;
                     myplot = figure('Units','pixels', ...
                        'Position',[thispos 550 360], ...
                        'Menubar','none', ...
                        'Toolbar','none', ...
                        'NumberTitle','off', ...
                        'Visible','off', ...
                        'Name',['Recursive Pi(' num2str(j) ',' num2str(i) ')']);
                     %
                     % obey centering and filling defaults
                     %
                     setfigureproperties(myplot);
                     %
                     %
                     % Using a patch to display the confidence region
                     %
                     if curr_ini.colors==1;
                        colorstr3 = (1/255)*[255 255 177];
                     else;
                        colorstr3 = [0.6 0.6 0.6];
                     end;
                     my_p = patch([dataindex(T1:tm.T,1)' reverse(dataindex(T1:tm.T,1)')],[upperpi(thisi,:) reverse(lowerpi(thisi,:))],colorstr3);
                     set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
                     hold('on');
                     %
                     % create a zero-line if needed
                     %
                     y_lim = [min(lowerpi(thisi,:))-0.1 max(upperpi(thisi,:))+0.1];
                     if (y_lim(1,1)<0)&(y_lim(1,2)>0);
                        plot([dataindex(T1,1) dataindex(tm.T,1)],[0 0],'-','LineWidth',1,'Color',[0 0 0]);
                        hold('on');
                     end;
                     %
                     % Setting up the plot
                     %
                     plot(dataindex(T1:tm.T,1),pit(thisi,:)','-','LineWidth',1,'Color',colorstr,'Tag',['est-pi(' num2str(j) num2str(i) ')']);
                     hold('on');
                     set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)],'Layer','top');
                     set(gca,'YLim',y_lim);
                     if curr_ini.fullrec==0;
                        textadd = ' (for updated \delta_{i},\Gamma_{i})';
                     else;
                        textadd = ' (for fixed \delta_{i},\Gamma_{i})';
                     end;
                     setaxesfonts('Title',['Estimated \Pi_{' num2str(j) ',' num2str(i) '} with ' num2str(tm.cbs) ' % confidence bands' textadd]);
                     toolbar_fcn(gca);
                     hold('off');
                     if curr_ini.external==0;
                        plot_handles = [plot_handles myplot];
                     else;
                        file = [tm.outputdir 'pi-' num2str(j) '.' num2str(i)];
                        mstat = autosavefigure(myplot,file);
                        stats = [stats mstat];
                        file_names = strvcat(file_names,file);
                     end;
                  end;
               end;
            end;
         end;
         %
         % Graph the Nyblom test
         %
%         if ((tm.q1+tm.q0)==0)&(dfbeta_t<(tm.n+tm.q1+tm.dcoint-tm.r)*tm.r);
         if (dfbeta_t<(tm.n+tm.q1+tm.dcoint-tm.r)*tm.r);
            if (curr_ini.nyblom==1)&(curr_ini.nyblombeta==1);
               thispos = [thispos(1,1)+22 thispos(1,2)-22];
               if thispos(1,1)>(realscrsz(3)-550);
                  thispos = [0 realscrsz(4)-430];
               end;
               if thispos(1,2)>(realscrsz(4)-430);
                  thispos = [0 realscrsz(4)-430];
               elseif thispos(1,2)<32;
                  thispos = [0 realscrsz(4)-430];
               end;
               myplot = figure('Units','pixels', ...
                  'Position',[thispos 550 360], ...
                  'NumberTitle','off', ...
                  'Menubar','none', ...
                  'Toolbar','none', ...
                  'Visible','off', ...
                  'Name',['Recursive Nyblom Statistic']);
               %
               % obey centering and filling defaults
               %
               setfigureproperties(myplot);
               %
               %
               % Setting up the plot
               %
               plot(dataindex(T1:tm.T,1),nyblomtest','-','LineWidth',1,'Color',colorstr,'Tag','nyblom-statistics');
               %
               % add critical value when available
               %
               if (tm.restrict(1,1)==0)&(dfbeta_t==0)&(tm.nyblom_asymp==1);
                  cv_nyblom = nyblom_quantile(tm.n,tm.r,tm.cbs,'max',tm.deterselect);
                  hold('on');
                  plot([dataindex(T1,1) dataindex(tm.T,1)],cv_nyblom*ones(1,2),typestr,'LineWidth',1,'Color',colorstr2);
               end;
               set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
               %
               % Fix YLim so that max([max(nyblomtest) cv_nyblom])+0.1 is used
               %
               if (tm.restrict(1,1)==0)&(dfbeta_t==0)&(tm.nyblom_asymp==1);
                  set(gca,'YLim',[0 max(max(nyblomtest),cv_nyblom)+0.1]);
               else;
                  set(gca,'YLim',[0 max(nyblomtest)+0.1]);
               end;
               %
%                  set(gca,'YLim',[0 max([max(nyblomtest) cv_nyblom])+0.1]);
               if curr_ini.fullrec==0;
                  textadd = ' (for updated \delta_{i},\Gamma_{i})';
               else;
                  textadd = ' (for fixed \delta_{i},\Gamma_{i})';
               end;
               if (tm.restrict(1,1)==0)&(dfbeta_t==0)&(tm.nyblom_asymp==1);
                  setaxesfonts('Title',['Estimated Nyblom Q_{T}^{(t)} statistics with ' num2str(tm.cbs) ' % critical value for max test' textadd]);
                  myleg = legend_fcn('Nyblom statistics',['cr. val. (' num2str(cv_nyblom,'%0.2f') ')'],1);
                  setaxesfonts(myleg);
               else;
                  setaxesfonts('Title',['Estimated Nyblom Q_{T}^{(t)} statistics' textadd]);
               end
               toolbar_fcn(gca);
               hold('off');
               if curr_ini.external==0;
                  plot_handles = [plot_handles myplot];
               else;
                  file = [tm.outputdir 'nyblom-rest-' num2str(tm.n) 'x' num2str(tm.r)];
                  mstat = autosavefigure(myplot,file);
                  stats = [stats mstat];
                  file_names = strvcat(file_names,file);
               end;
            end;
         end;
         %
         % Graph recursive estimates of largest non-unit eigenvalue of the companion matrix
         %
         if curr_ini.topeig==1;
            thispos = [thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-550);
               thispos = [0 realscrsz(4)-430];
            end;
            if thispos(1,2)>(realscrsz(4)-430);
               thispos = [0 realscrsz(4)-430];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-430];
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 550 360], ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'NumberTitle','off', ...
               'Visible','off', ...
               'Name',['Recursive Maximum Non-Unit Eigenvalue']);
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),evaluet','-','LineWidth',1,'Color',colorstr,'Tag','max-eigenvalue-companion');
            hold('on');
            plot(dataindex(T1:tm.T,1),ones(size(dataindex(T1:tm.T,1),1),1),typestr,'LineWidth',1,'Color',colorstr2);
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            set(gca,'YLim',[0 max([max(evaluet) 1])+0.1]);
            if curr_ini.fullrec==0;
               textadd = ' (for updated \delta_{i},\Gamma_{i})';
            else;
               textadd = ' (for fixed \delta_{i},\Gamma_{i})';
            end;
            setaxesfonts('Title',['Estimated maximum non-unit eigenvalue of the companion matrix' textadd]);
            toolbar_fcn(gca);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir 'max-companion-eig-rank.' num2str(tm.r)];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
         %
         % Graph of recursive tests of beta restrictions
         %
         if dfbeta_t>0;
            thispos = [thispos(1,1)+22 thispos(1,2)-22];
            if thispos(1,1)>(realscrsz(3)-550);
               thispos = [0 realscrsz(4)-430];
            end;
            if thispos(1,2)>(realscrsz(4)-430);
               thispos = [0 realscrsz(4)-430];
            elseif thispos(1,2)<32;
               thispos = [0 realscrsz(4)-430];
            end;
            if curr_ini.sscorrect==1;
               testtype = 'F-';
               testfile = 'f-';
            else;
               testtype = 'LR ';
               testfile = 'lr-';
            end;
            myplot = figure('Units','pixels', ...
               'Position',[thispos 550 360], ...
               'Menubar','none', ...
               'Toolbar','none', ...
               'NumberTitle','off', ...
               'Visible','off', ...
               'Name',['Recursive ' testtype 'Tests of beta Restrictions']);
            %
            % obey centering and filling defaults
            %
            setfigureproperties(myplot);
            %
            %
            % Setting up the plot
            %
            plot(dataindex(T1:tm.T,1),LRbetat','-','LineWidth',1,'Color',colorstr,'Tag','LR-test-beta');
            if isempty(critvalt)==0;
               hold('on');
               plot(dataindex(T1:tm.T,1),critvalt',typestr,'LineWidth',1,'Color',colorstr2);
               critstr = [' with ' num2str(tm.cbs) ' % critical value'];
            else;
               critstr = '';
            end;
            set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
            set(gca,'YLim',[0 max([LRbetat critvalt])+0.5]);
            if curr_ini.fullrec==0;
               textadd = ' (for updated \delta_{i},\Gamma_{i})';
            else;
               textadd = ' (for fixed \delta_{i},\Gamma_{i})';
            end;
            setaxesfonts('Title',['Estimated ' testtype 'tests of ' num2str(dfbeta_t) ' \beta restrictions' critstr textadd]);
            toolbar_fcn(gca);
            hold('off');
            if curr_ini.external==0;
               plot_handles = [plot_handles myplot];
            else;
               file = [tm.outputdir testfile 'tests-beta'];
               mstat = autosavefigure(myplot,file);
               stats = [stats mstat];
               file_names = strvcat(file_names,file);
            end;
         end;
         %
         % Graph recursive tests of alpha if computed
         %
         if curr_ini.recalpha==1;
            if tm.restrict(1,1)==1;
               thispos = [thispos(1,1)+22 thispos(1,2)-22];
               if thispos(1,1)>(realscrsz(3)-550);
                  thispos = [0 realscrsz(4)-430];
               end;
               if thispos(1,2)>(realscrsz(4)-430);
                  thispos = [0 realscrsz(4)-430];
               elseif thispos(1,2)<32;
                  thispos = [0 realscrsz(4)-430];
               end;
               if curr_ini.sscorrect==1;
                  testtype = 'F-';
                  testfile = 'f-';
               else;
                  testtype = 'LR ';
                  testfile = 'lr-';
               end;
               addbeta = '';
               addfile = '';
               addbeta2 = '';
               if dfbeta_t>0;
                  addbeta = ' and beta';
                  addfile = '-beta';
                  addbeta2 = [' and ' num2str(dfbeta_t) ' \beta'];
               end;
               myplot = figure('Units','pixels', ...
                  'Position',[thispos 550 360], ...
                  'Menubar','none', ...
                  'Toolbar','none', ...
                  'NumberTitle','off', ...
                  'Visible','off', ...
                  'Name',['Recursive ' testtype 'Tests of alpha' addbeta ' Restrictions']);
               %
               % obey centering and filling defaults
               %
               setfigureproperties(myplot);
               %
               %
               % Setting up the plot
               %
               plot(dataindex(T1:tm.T,1),LRalphat','-','LineWidth',1,'Color',colorstr,'Tag',['LR-test-alpha' addfile]);
               if isempty(cvalphat)==0;
                  hold('on');
                  plot(dataindex(T1:tm.T,1),cvalphat',typestr,'LineWidth',1,'Color',colorstr2);
                  critstr = [' with ' num2str(tm.cbs) ' % critical value'];
               else;
                  critstr = '';
               end;
               set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
               set(gca,'YLim',[0 max([LRalphat cvalphat])+0.5]);
               if curr_ini.fullrec==0;
                  textadd = ' (for updated \delta_{i},\Gamma_{i})';
               else;
                  textadd = ' (for fixed \delta_{i},\Gamma_{i})';
               end;
               setaxesfonts('Title',['Estimated ' testtype 'tests of ' num2str(dfalpha_t) ' \alpha' addbeta2 ' restrictions' critstr textadd]);
               toolbar_fcn(gca);
               hold('off');
               if curr_ini.external==0;
                  plot_handles = [plot_handles myplot];
               else;
                  file = [tm.outputdir testfile 'tests-alpha' addfile];
                  mstat = autosavefigure(myplot,file);
                  stats = [stats mstat];
                  file_names = strvcat(file_names,file);
               end;
               %
               % Graph test of alpha restrictions if beta is overidentified
               %
               if dfbeta_t>0;
                  thispos = [thispos(1,1)+22 thispos(1,2)-22];
                  if thispos(1,1)>(realscrsz(3)-550);
                     thispos = [0 realscrsz(4)-430];
                  end;
                  if thispos(1,2)>(realscrsz(4)-430);
                     thispos = [0 realscrsz(4)-430];
                  elseif thispos(1,2)<32;
                     thispos = [0 realscrsz(4)-430];
                  end;
                  if curr_ini.sscorrect==1;
                     testtype = 'F-';
                     testfile = 'f-';
                  else;
                     testtype = 'LR ';
                     testfile = 'lr-';
                  end;
                  myplot = figure('Units','pixels', ...
                     'Position',[thispos 550 360], ...
                     'NumberTitle','off', ...
                     'Menubar','none', ...
                     'Toolbar','none', ...
                     'Visible','off', ...
                     'Name',['Recursive ' testtype 'Tests of alpha Restrictions']);
                  %
                  % obey centering and filling defaults
                  %
                  setfigureproperties(myplot);
                  %
                  %
                  % Setting up the plot
                  %
                  plot(dataindex(T1:tm.T,1),LRalphabetat','-','LineWidth',1,'Color',colorstr,'Tag','LR-test-alpha');
                  if isempty(cvalphabetat)==0;
                     hold('on');
                     plot(dataindex(T1:tm.T,1),cvalphabetat',typestr,'LineWidth',1,'Color',colorstr2);
                     critstr = [' with ' num2str(tm.cbs) ' % critical value'];
                  else;
                     critstr = '';
                  end;
                  set(gca,'XLim',[dataindex(T1,1) dataindex(tm.T,1)]);
                  set(gca,'YLim',[0 max([LRalphabetat cvalphabetat])+0.5]);
                  if curr_ini.fullrec==0;
                     textadd = ' (for updated \delta_{i},\Gamma_{i})';
                  else;
                     textadd = ' (for fixed \delta_{i},\Gamma_{i})';
                  end;
                  setaxesfonts('Title',['Estimated ' testtype 'tests of ' num2str(dfalpha_t) ' \alpha restrictions' critstr textadd]);
                  toolbar_fcn(gca);
                  hold('off');
                  if curr_ini.external==0;
                     plot_handles = [plot_handles myplot];
                  else;
                     file = [tm.outputdir testfile 'tests-alpha'];
                     mstat = autosavefigure(myplot,file);
                     stats = [stats mstat];
                     file_names = strvcat(file_names,file);
                  end;
               end;
            end;
         end;
         if (curr_ini.external==1)&(isempty(stats)==0);
            for i=1:size(stats,2);
               if stats(i)==0;
                  autoshowfigure(strtrim(file_names(i,:)));
               end;
            end;
         elseif curr_ini.external==0;
            for i=1:size(plot_handles,2);
               set(plot_handles(1,i),'Visible','on');
            end;
         end;
      end;
   else;
      txt = 'There are too few observations to estimate parameters recursively.';
      about(txt,'information','Recursions...',120,350);
      set(fig_handle,'Visible','on');
      drawnow;
   end;
   set(fig_handle,'UserData',cointbeta);
else;
   unident = '';
   for i=1:tm.r;
      if status(i,1)==0;
         if strcmp(unident,'')==1;
            unident = ['beta(' num2str(i) ')'];
            thisres = 'restriction';
            thisfail = 'fails';
         else;
            unident = [unident ', beta(' num2str(i) ')'];
            thisres = 'restrictions';
            thisfail = 'fail';
         end;
      end;
   end;
   txt = ['The restrictions you have selected for beta are not identifying. In particular, the ' thisres ' on ' unident ' ' thisfail ' the identification test.'];
   about(txt,'warning','Identification Test Failure',120,350);
end;

%
% end of show_recursivebeta.m
%
