function a = symm(b)
% a = SYMM(b)
%   Computes a symmetric decomposition of a positive definite matrix b,
%   such that a is symmetric and a*a = a*a' = b
%

[W,rho] = eig(b);
rho = diag(rho,0);
[rho2,AscInd] = sort(abs(rho));

nr = size(AscInd,1);
DescInd = zeros(nr,1);
for i=1:nr;
   DescInd(i)=AscInd(nr+1-i);
end;

rho = rho(DescInd);
sqrho = sqrt(rho);
rho = diag(rho,0);
sqrho = diag(sqrho,0);
W = W(:,DescInd);

%
% and the results
%

a = inverse((W/sqrho)*W');


%
% end of symm.m
%
