function status = write_inifile(init_structure)

status = 1;

if isstruct(init_structure)==0;
   return;
end;

%
% h is the maingui figure for structural var
%

h = findobj('Tag','StructuralVAR');
model = get(h,'UserData');
scrsz = [1 1 1024 768];
realscrsz = get(0,'ScreenSize');

if init_structure.geometry(1,1)+init_structure.geometry(1,2)>0;
   currpos = get(h,'Position');
   init_structure.geometry = [currpos(1,1) currpos(1,2)];
   if init_structure.geometry(1,1)>realscrsz(3)-(scrsz(3)/2);
      init_structure.geometry(1,1)=realscrsz(3)-(scrsz(3)/2);
   end;
   if init_structure.geometry(1,2)>realscrsz(4)-240-(scrsz(4)/2);
      init_structure.geometry(1,2)=realscrsz(4)-240-(scrsz(4)/2);
   end;
end;
if init_structure.geometry(1,1)<0;
   init_structure.geometry(1,1) = 0;
end;
if init_structure.geometry(1,2)<0;
   init_structure.geometry(1,2) = 0;
end;
fini = fopen('var.ini','w');
fprintf(fini,['max iterations = ' num2str(init_structure.maxit) '\n']);
if init_structure.convcrit<10;
   fprintf(fini,['convergence criterion = 1.0e-00' num2str(init_structure.convcrit) '\n']);
else;
   fprintf(fini,['convergence criterion = 1.0e-0' num2str(init_structure.convcrit) '\n']);
end;
fprintf(fini,['max lag length = ' num2str(init_structure.maxlag) '\n']);
fprintf(fini,['close matlab = ' num2str(init_structure.openvar) '\n']);
fprintf(fini,['residual statistics = ' num2str(init_structure.restat) '\n']);
fprintf(fini,['geometry = ' num2str(init_structure.geometry(1,1)) ' ' num2str(init_structure.geometry(1,2)) '\n']);
fprintf(fini,['method = ' num2str(init_structure.method(1,1)) ' ' num2str(init_structure.method(1,2)) ' ' num2str(init_structure.method(1,3)) '\n']);
fprintf(fini,['external apps = ' num2str(init_structure.external) '\n']);
fprintf(fini,['graphics format = ' init_structure.graphicsfmt '\n']);
fprintf(fini,'%s\n',['ai-viewer = ' init_structure.aiviewer]);
fprintf(fini,'%s\n',['eps-viewer = ' init_structure.epsviewer]);
fprintf(fini,'%s\n',['bitmap-viewer = ' init_structure.bitmapviewer]);
fprintf(fini,['small-sample correction = ' num2str(init_structure.sscorrect) '\n']);
fprintf(fini,['append to output = ' num2str(init_structure.append) '\n']);
fprintf(fini,['color graphs = ' num2str(init_structure.colors) '\n']);
fprintf(fini,['landscape = ' num2str(init_structure.landscape) '\n']);
fprintf(fini,['paper position mode = ' init_structure.paperposmode '\n']);
fprintf(fini,['paper type = ' init_structure.papertype '\n']);
fprintf(fini,['portmanteau = ' num2str(init_structure.portmanteau) '\n']);
fprintf(fini,['x-grid lines = ' num2str(init_structure.xgrid) '\n']);
fprintf(fini,['box graphs = ' num2str(init_structure.box) '\n']);
fprintf(fini,['omnibus = ' num2str(init_structure.omnibus) '\n']);
fprintf(fini,['critical value = ' num2str(init_structure.critval) '\n']);
fprintf(fini,['directory structure = ' num2str(init_structure.dirstructure) '\n']);
fprintf(fini,'%s\n',['editor = ' init_structure.editor]);
fprintf(fini,'recursive = %1.8f\n',init_structure.T0);
fprintf(fini,['fluctuations test = ' num2str(init_structure.fluctest) '\n']);
fprintf(fini,['nyblom test = ' num2str(init_structure.nyblom) '\n']);
fprintf(fini,['information criteria = ' num2str(init_structure.akaike) '\n']);
fprintf(fini,'%s\n',['help command = ' init_structure.helpexe]);
fprintf(fini,['short-run dynamics = ' num2str(init_structure.shortdyn) '\n']);
fprintf(fini,['weak exogeneity test = ' num2str(init_structure.weakexo) '\n']);
fprintf(fini,['granger causality test = ' num2str(init_structure.gctest) '\n']);
fprintf(fini,['y-grid lines = ' num2str(init_structure.ygrid) '\n']);
fprintf(fini,['chow divide = ' num2str(init_structure.chowfc) '\n']);
fprintf(fini,['chow test = ' num2str(init_structure.chow) '\n']);
fprintf(fini,['lstr test = ' num2str(init_structure.lstrtest) '\n']);
fprintf(fini,['full sample recursion = ' num2str(init_structure.fullrec) '\n']);
fprintf(fini,['correct trace test = ' num2str(init_structure.tracebart) '\n']);
fprintf(fini,['lag order test = ' num2str(init_structure.lagtest) '\n']);
fprintf(fini,['max response horizon = ' num2str(init_structure.maxresp) '\n']);
fprintf(fini,['recursive alpha = ' num2str(init_structure.recalpha) '\n']);
fprintf(fini,['recursive companion eigenvalue = ' num2str(init_structure.topeig) '\n']);
fprintf(fini,['beta gradient = ' num2str(init_structure.betagrad) '\n']);
fprintf(fini,'reopen list = %s\n',init_structure.reopenlist);
fprintf(fini,['use last file = ' num2str(init_structure.uselastfile) '\n']);
fprintf(fini,'last file = %s\n',get(model.open,'UserData'));
fprintf(fini,['start run = ' num2str(init_structure.startrun) '\n']);
fprintf(fini,['open output file = ' num2str(init_structure.openmyoutput) '\n']);
fprintf(fini,['no silly questions = ' num2str(init_structure.sillyq) '\n']);
fprintf(fini,'%s\n',['text print = ' init_structure.txtprint]);
fprintf(fini,'%s\n',['text print command = ' init_structure.txtprintcmd]);
fprintf(fini,'%s\n',['postscript print = ' init_structure.psprint]);
fprintf(fini,'%s\n',['postscript print command = ' init_structure.psprintcmd]);
fprintf(fini,['rahbek-mosconi solution = ' num2str(init_structure.rahbek) '\n']);
fprintf(fini,['extra convergence criterion = ' num2str(init_structure.extraccrit) '\n']);
fprintf(fini,['no printed output = ' num2str(init_structure.noprint) '\n']);
fprintf(fini,['reestimate beta = ' num2str(init_structure.reestbeta) '\n']);
fprintf(fini,'%s\n',['ghostscript = ' init_structure.ghostscript]);
fprintf(fini,'%s\n',['pstoedit = ' init_structure.pstoedit]);
fprintf(fini,'%s\n',['paperunits = ' init_structure.paperunits]);
fprintf(fini,['transformed eigenvalues = ' num2str(init_structure.transeig) '\n']);
fprintf(fini,['z-grid lines = ' num2str(init_structure.zgrid) '\n']);
fprintf(fini,'%s\n',['text font name = ' init_structure.text_fontname]);
fprintf(fini,['text font size = ' num2str(init_structure.text_fontsize) '\n']);
fprintf(fini,'%s\n',['text font weight = ' init_structure.text_fontweight]);
fprintf(fini,'%s\n',['text font angle = ' init_structure.text_fontangle]);
fprintf(fini,'%s\n',['text font units = ' init_structure.text_fontunits]);
fprintf(fini,['text color = ' num2str(init_structure.text_color) '\n']);
fprintf(fini,['text background color = ' num2str(init_structure.text_backgroundcolor) '\n']);
fprintf(fini,'%s\n',['axes font name = ' init_structure.axes_fontname]);
fprintf(fini,['axes font size = ' num2str(init_structure.axes_fontsize) '\n']);
fprintf(fini,'%s\n',['axes font weight = ' init_structure.axes_fontweight]);
fprintf(fini,'%s\n',['axes font angle = ' init_structure.axes_fontangle]);
fprintf(fini,'%s\n',['axes font units = ' init_structure.axes_fontunits]);
fprintf(fini,['axes color = ' num2str(init_structure.axes_color) '\n']);
fprintf(fini,'%s\n',['title font name = ' init_structure.title_fontname]);
fprintf(fini,['title font size = ' num2str(init_structure.title_fontsize) '\n']);
fprintf(fini,'%s\n',['title font weight = ' init_structure.title_fontweight]);
fprintf(fini,'%s\n',['title font angle = ' init_structure.title_fontangle]);
fprintf(fini,'%s\n',['title font units = ' init_structure.title_fontunits]);
fprintf(fini,['title color = ' num2str(init_structure.title_color) '\n']);
fprintf(fini,'%s\n',['label font name = ' init_structure.label_fontname]);
fprintf(fini,['label font size = ' num2str(init_structure.label_fontsize) '\n']);
fprintf(fini,'%s\n',['label font weight = ' init_structure.label_fontweight]);
fprintf(fini,'%s\n',['label font angle = ' init_structure.label_fontangle]);
fprintf(fini,'%s\n',['label font units = ' init_structure.label_fontunits]);
fprintf(fini,['label color = ' num2str(init_structure.label_color) '\n']);
fprintf(fini,['random number generator state = ' num2str(init_structure.random_state) '\n']);
fprintf(fini,['number of replications = ' num2str(init_structure.nRep) '\n']);
fprintf(fini,['draws per replication = ' num2str(init_structure.nDraw) '\n']);
fprintf(fini,'%s\n',['interpolation function = ' init_structure.interpolate]);
fprintf(fini,'%s\n',['simulation directory = ' lower(init_structure.simulatedir)]);
fprintf(fini,['color printing = ' num2str(init_structure.invert_hardcopy) '\n']);
fprintf(fini,['centering = ' num2str(init_structure.center_value) '\n']);
fprintf(fini,['filling = ' num2str(init_structure.fill_value) '\n']);
fprintf(fini,['crop image = ' num2str(init_structure.crop_image) '\n']);
fprintf(fini,['edit context menu = ' num2str(init_structure.edit_context) '\n']);
fprintf(fini,['zbuffer = ' num2str(init_structure.z_buffer) '\n']);
fprintf(fini,['use_toolbar_bgcolor = ' num2str(init_structure.use_toolbar_bgcolor) '\n']);
fprintf(fini,['gui_light_color = ' num2str(init_structure.gui_light_color) '\n']);
fprintf(fini,['gui_shade_color = ' num2str(init_structure.gui_shade_color) '\n']);
fprintf(fini,['gui_dark_color = ' num2str(init_structure.gui_dark_color) '\n']);
fprintf(fini,['reuse_bootstrap = ' num2str(init_structure.reuse_bootstrap) '\n']);
fprintf(fini,['taylor expansion of nyblom test = ' num2str(init_structure.taylor_nyblom) '\n']);
fprintf(fini,['nyblom test under beta restrictions = ' num2str(init_structure.nyblombeta) '\n']);
fprintf(fini,['bartlett correct lag tests = ' num2str(init_structure.bartserial) '\n']);
fprintf(fini,['correct portmanteau test = ' num2str(init_structure.lbcorrect) '\n']);
fprintf(fini,['default identification method = ' num2str(init_structure.identify) '\n']);
fprintf(fini,['fix y labels = ' num2str(init_structure.ytick) '\n']);
fprintf(fini,'%s\n',['latex = ' lower(init_structure.latex)]);
fprintf(fini,'%s\n',['dviviewer = ' lower(init_structure.dviviewer)]);
fprintf(fini,'%s\n',['distiller = ' lower(init_structure.distiller)]);
fprintf(fini,'%s\n',['psviewer = ' lower(init_structure.psviewer)]);
fprintf(fini,'%s\n',['pdfviewer = ' lower(init_structure.pdfviewer)]);
fprintf(fini,['TeX output format = ' num2str(init_structure.texoutputformat) '\n']);
fprintf(fini,'%s\n',['TeX header = ' init_structure.texheader]);
fprintf(fini,['use dvipdfm = ' num2str(init_structure.dvipdfm) '\n']);
fprintf(fini,['out-of-sample forecasts = ' num2str(init_structure.outofsample) '\n']);
fprintf(fini,['fix x labels = ' num2str(init_structure.xtick) '\n']);
fprintf(fini,['figure icons = ' num2str(init_structure.loadicon) '\n']);
fprintf(fini,'%s\n',['pstools directory = ' init_structure.pstoolsdir]);
fprintf(fini,['gui icons = ' num2str(init_structure.loadguiicon) '\n']);
fprintf(fini,['delay = ' num2str(init_structure.delay) '\n']);
fprintf(fini,'%s\n',['tempdir = ' init_structure.tempdir]);
fprintf(fini,['browse dialog = ' num2str(init_structure.browsedialog) '\n']);
fprintf(fini,['open dialog = ' num2str(init_structure.opendialog) '\n']);
fprintf(fini,['no icon = ' num2str(init_structure.noicon) '\n']);
fprintf(fini,'%s\n',['pdf version = ' init_structure.pdfversion]);
fprintf(fini,['recursive pi = ' num2str(init_structure.recpi) '\n']);
fprintf(fini,['show log tab = ' num2str(init_structure.logtab) '\n']);
fprintf(fini,['maximize viewer = ' num2str(init_structure.maximizeviewer) '\n']);
fprintf(fini,['symmetric omega = ' num2str(init_structure.symmetric) '\n']);
fprintf(fini,['recursive trace = ' num2str(init_structure.rectrace) '\n']);
fprintf(fini,['export data = ' num2str(init_structure.exportdata) '\n']);
fprintf(fini,['forecast horizon = ' num2str(init_structure.forecasthorizon) '\n']);
fprintf(fini,['exclusion and stationarity = ' num2str(init_structure.excludestat) '\n']);
fprintf(fini,['noise parameter = ' num2str(init_structure.noise_parm,'%0.8f') '\n']);
fprintf(fini,['no clear log = ' num2str(init_structure.clearlog) '\n']);
fprintf(fini,['parametric bootstrap = ' num2str(init_structure.parametric) '\n']);
fprintf(fini,['dummy tests = ' num2str(init_structure.dummytests) '\n']);
fprintf(fini,['common cycle tests = ' num2str(init_structure.commoncycles) '\n']);
fprintf(fini,['block size = ' num2str(init_structure.blocksize) '\n']);
fprintf(fini,['normalize beta = ' num2str(init_structure.normbeta) '\n']);
fprintf(fini,['decompose deterministics = ' num2str(init_structure.decompose_det) '\n']);
fprintf(fini,['burn-in draws = ' num2str(init_structure.burn_in) '\n']);
fprintf(fini,['save draws = ' num2str(init_structure.save_draws) '\n']);
fprintf(fini,['save draws frequency = ' num2str(init_structure.save_freq) '\n']);
fprintf(fini,['baseline shrinkage = ' num2str(init_structure.lambda_b) '\n']);
fprintf(fini,['off-diagonal shrinkage = ' num2str(init_structure.lambda_theta) '\n']);
fprintf(fini,['lag shrinkage = ' num2str(init_structure.lambda_l) '\n']);
fprintf(fini,['exogeneity shrinkage = ' num2str(init_structure.lambda_e) '\n']);
fprintf(fini,['deterministic shrinkage = ' num2str(init_structure.lambda_d) '\n']);
fprintf(fini,['alpha shrinkage = ' num2str(init_structure.lambda_alpha) '\n']);
fprintf(fini,['model select max lag = ' num2str(init_structure.ms_maxlag) '\n']);
fprintf(fini,['discard explosive processes = ' num2str(init_structure.discard_explosive) '\n']);
fprintf(fini,['informative shortrun prior = ' num2str(init_structure.prior_inf_shortrun) '\n']);
fprintf(fini,['informative deterministics prior = ' num2str(init_structure.prior_inf_deter) '\n']);
fprintf(fini,['informative alpha prior = ' num2str(init_structure.prior_inf_alpha) '\n']);
fprintf(fini,['informative Omega prior = ' num2str(init_structure.prior_inf_omega) '\n']);
fprintf(fini,['skip bad draws = ' num2str(init_structure.bad_draws) '\n']);
fprintf(fini,['a matrix = ' num2str(init_structure.amat_type) '\n']);
fprintf(fini,['a shrinkage = ' num2str(init_structure.lambda_a) '\n']);
fprintf(fini,['q df = ' num2str(init_structure.q_df) '\n']);
fprintf(fini,['A matrix lag order = ' num2str(init_structure.amat_lag) '\n']);
fprintf(fini,['GUI font weight = ' init_structure.gui_fontweight '\n']);
fprintf(fini,['GUI font angle = ' init_structure.gui_fontangle '\n']);
fprintf(fini,['GUI font name = ' init_structure.gui_fontname '\n']);
fprintf(fini,['GUI font size = ' num2str(init_structure.gui_fontsize) '\n']);
fprintf(fini,['GUI font = ' num2str(init_structure.gui_font) '\n']);
fprintf(fini,['show undo button = ' num2str(init_structure.show_undo) '\n']);
fprintf(fini,['frame color = ' num2str(init_structure.frame_color) '\n']);
fprintf(fini,['frame light color = ' num2str(init_structure.frame_light_color) '\n']);
fprintf(fini,['frame shade color = ' num2str(init_structure.frame_shade_color) '\n']);
fprintf(fini,['frame dark color = ' num2str(init_structure.frame_dark_color) '\n']);
fprintf(fini,['GUI foreground color = ' num2str(init_structure.gui_foreground_color) '\n']);
fprintf(fini,['restricted multivariate arch = ' num2str(init_structure.rest_march) '\n']);
fprintf(fini,['exclude first differences = ' num2str(init_structure.excludediffs) '\n']);
fprintf(fini,['number of decimals for output = ' num2str(init_structure.decimals) '\n']);
fprintf(fini,['progress face color = ' num2str(init_structure.progress_facecolor) '\n']);
fprintf(fini,['progress edge color = ' num2str(init_structure.progress_edgecolor) '\n']);
fprintf(fini,['progress background color = ' num2str(init_structure.progress_bgcolor) '\n']);
fprintf(fini,['progress start face color = ' num2str(init_structure.progress_startfacecolor) '\n']);
fclose(fini);

status = 0;

%
% end of write_inifile.m
%
